/*
*    Copyright (C) 1995 Ronald Van Iwaarden
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    I can presently be contacted on the internet at
*
*    rvaniwaa@carbon.denver.colorado.edu
*    rvaniwaa@smaug.cs.hope.edu
*   
*    or by snail mail at:
*
*    Ronald Van Iwaarden
*    4351 60th St.
*    Holland MI, USA, 49423
*/


#include "maxfdefine.h"
#include <os2.h>
#include "error.h"
#include <sys/winmgr.h>
#include <stdlib.h>
#include "maxfstruct.h"

extern int MaxX;
extern int MaxY;
extern int MidX;
extern int MidY;


/*
   error*() are procedures to open a window and display a message or two
   for a few seconds or until a key is pressed.  They are used many places
   in the program for various reasons.
*/

void error(char * msg)
{
  wm_handle error_window;
  int len = strlen(msg);

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-1,MaxX/2+len/2+2,MaxY/2+1,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  _sleep2(2000);
  wm_close(error_window);
  wm_delete(error_window);
}

void errorT(char * msg, int time)
{
  wm_handle error_window;
  int len = strlen(msg);

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-1,MaxX/2+len/2+2,MaxY/2+1,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  if (time > 0)
    _sleep2(time);
  else
    _read_kbd(0,1,0);
  wm_close(error_window);
  wm_delete(error_window);
}

void error2(char * msg, char * msg2)
{
  wm_handle error_window;
  int len = (strlen(msg) > strlen(msg2)) ? strlen(msg) : strlen(msg2);

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-1,MaxX/2+len/2+2,MaxY/2+2,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  wm_puts_at(error_window,1,2,msg2);
  _sleep2(2000);
  wm_close(error_window);
  wm_delete(error_window);
}

void error3(char * msg, char * msg2, char * msg3)
{
  wm_handle error_window;
  int len = (strlen(msg) > strlen(msg2)) ? strlen(msg) : strlen(msg2);

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-2,MaxX/2+len/2+2,MaxY/2+3,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  wm_puts_at(error_window,1,2,msg2);
  wm_puts_at(error_window,1,3,msg3);
  _sleep2(2000);
  wm_close(error_window);
  wm_delete(error_window);
}

void error3T(char * msg, char * msg2, char * msg3, int time)
{
  wm_handle error_window;
  int len = (strlen(msg) > strlen(msg2)) ? strlen(msg) : strlen(msg2);

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-2,MaxX/2+len/2+2,MaxY/2+3,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  wm_puts_at(error_window,1,2,msg2);
  wm_puts_at(error_window,1,3,msg3);
  if (time > 0)
    _sleep2(time);
  else
    _read_kbd(0,1,0);
  wm_close(error_window);
  wm_delete(error_window);
}

void error4(char * msg, char * msg2, char * msg3, char *msg4)
{
  wm_handle error_window;
  int len1 = (strlen(msg) > strlen(msg2)) ? strlen(msg) : strlen(msg2);
  int len2 = (strlen(msg3) > strlen(msg4)) ? strlen(msg3) : strlen(msg4);
  int len = (len1 > len2) ? len1 : len2;

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-2,MaxX/2+len/2+2,MaxY/2+3,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  wm_puts_at(error_window,1,2,msg2);
  wm_puts_at(error_window,1,3,msg3);
  wm_puts_at(error_window,1,4,msg4);
  _sleep2(2000);
  wm_close(error_window);
  wm_delete(error_window);
}

void error4T(char * msg, char * msg2, char * msg3, char *msg4, int time)
{
  wm_handle error_window;
  int len1 = (strlen(msg) > strlen(msg2)) ? strlen(msg) : strlen(msg2);
  int len2 = (strlen(msg3) > strlen(msg4)) ? strlen(msg3) : strlen(msg4);
  int len = (len1 > len2) ? len1 : len2;

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-2,MaxX/2+len/2+2,MaxY/2+3,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  wm_puts_at(error_window,1,2,msg2);
  wm_puts_at(error_window,1,3,msg3);
  wm_puts_at(error_window,1,4,msg4);
  if (time != -1) _sleep2(time);
  else _read_kbd(0,1,0);
  wm_close(error_window);
  wm_delete(error_window);
}

void error2T(char *msg, char *msg2, int time)
{
  wm_handle error_window;
  int len = (strlen(msg) > strlen(msg2)) ? strlen(msg) : strlen(msg2);

  error_window = wm_create(MaxX/2-len/2-2,MaxY/2-1,MaxX/2+len/2+2,MaxY/2+2,2,
			   BW_NORMAL|INTENSITY,BW_NORMAL);
  wm_open(error_window);
  wm_puts_at(error_window,1,1,msg);
  wm_puts_at(error_window,1,2,msg2);
  if (time != -1) _sleep2(time);
  else _read_kbd(0,1,0);
  wm_close(error_window);
  wm_delete(error_window);
}


