/*
*    Copyright (C) 1995 Ronald Van Iwaarden
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    I can presently be contacted on the internet at
*
*    rvaniwaa@carbon.denver.colorado.edu
*    rvaniwaa@smaug.cs.hope.edu
*   
*    or by snail mail at:
*
*    Ronald Van Iwaarden
*    4351 60th St.
*    Holland MI, USA, 49423
*/


/*

   MaxFile/2

   This is the source code for MaxFile/2 which is a file manager for OS/2 2.x.
   It compiles up under EMX 0.9a.  The rights to this source code are held by

   Ronald Van Iwaarden
   rvaniwaa@carbon.denver.colorado.edu        Internet
   Ronald Van Iwaarden 1:104/338@fidonet.org  Fidonet

   2208 S. Williams
   Denver CO 80210.

   You may not reuse this code in another program without the authors express
   written approval.

   */


#define INCL_DOSSESMGR
#include "maxfdefine.h"
//#include "filetype.h"
#include "mem.h"
#include <ctype.h>
#include <io.h>
#include <process.h>
#include <stdlib.h>
#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/winmgr.h>
#include <sys/utime.h>
#include <sys/stat.h>
#include <sys/kbdscan.h>
#include <sys/video.h>
#include <strings.h>

#include "maxstruc.h"
#include "error.h"
#include "maxfstruct.h"
#include "maxfile.h"
#include "utils.h"
#include "sort.h"
#include "read_areas.h"




int dateincr(struct FileInfo *, struct FileInfo *);

void HELP(int);
int cstart, cend, xpos, ypos;





int __path(char * exe, char * fname)
{
  char F[256];
  int retval;

  strcpy(F, fname);
  if ((retval = _path(exe, F)))
    {
      strcat(F, ".exe");
      if ((retval = _path(exe, F)))
	{
	  strcat(F, ".com");
	  retval = _path(exe, F);
	}
    }
  return retval;
}


/*
*   This procedure is passed a file name in fname and a directory in name.
*   All the files in the directory name are scanned with the external virus
*   scanner and then each directory below name is similarly scanned.  The
*   directory name is then removed recursively.
*/

void Virii_Check(char *name, char * fname)
{
  DIR * directory;
  struct dirent * Dirinfop;
  char * argv[20];
  char filename[300];
  char temp[200] = "";
  char dst[300];
  int i = 1;
  int j;
  int status;
  int pid;
  char execute[256];
  char execname[256];


  directory = opendir(name);
  if (!strlen(VirusScanner)){
    error("You have not set up a virus scanner in the maxfile.cfg");
    remove_recursively(name);
    return;}
  _fullpath(dst, name, sizeof(dst));
  for (j=0; j < strlen(dst); ++j) if (dst[j] == '/') dst[j] = '\\';
  strcpy(temp, VirusScanner);
  argv[0] = strtok(temp, " ");
  if (__path(execname, argv[0]))
    {
      error("Could not find archive extractor in path");
      return;
    }
  argv[0] = execname;
  if (_osmode != DOS_MODE){
    argv[2] = argv[0];
    argv[0] = "cmd.exe";
    argv[1] = "/c";
    i = 3;}
  else i = 1;
  while ((argv[i] = strtok('\0'," "))) ++i;
  strcat(dst, "\\*");
  argv[i++] = dst;
  argv[i++] = '\0';
  if (_osmode == DOS_MODE){
    strcpy(execute, "");
    for (i=0; argv[i]; ++i){strcat(execute, argv[i]); strcat(execute," ");}
    status = 256*spawnv(P_WAIT,argv[0], argv);
  }
  else{
    pid = spawnv(P_SESSION,argv[0], argv);
    if (pid >= 0) waitpid(pid, &status, 0);
    else status = 512;
  }
  if (_osmode != DOS_MODE)
    if (status/256)
      error("The virus scanner reports a virus");
    else
      error2T(fname, "This archive is clean", 1000);
  while ((Dirinfop = readdir(directory)))
    {
      if((Dirinfop->d_name[0] != '.') && (Dirinfop->d_attr == 16)){
	sprintf(temp, "%s/%s",name, Dirinfop->d_name);
	Virii_Check(temp, fname);}
      else{
	sprintf(filename,"%s/%s",name, Dirinfop->d_name);
	remove(filename);}
    }
  closedir(directory);
  rmdir(name);
}


/*
*   This function moves the file from source to dest.  If the two filenames
*   are the same, the function just returns.  If they are different, the file
*   is moved in blocks using the DosOpen API which will help reduce
*   fragmentation on a FAT file system
*/

int mv(char source[300], char dest[300])
{
  int choice;
  struct stat finfo;
  char fsize[20];
  char fdate[20];
  char stuffdest[60];
  char stuffsource[60];
  struct tm * lt;
  char str2[10];
  wm_handle exists;

  if (!stricmp(source, dest)) return 0;
  if (access(source,  0)) return 0;
  if (!stat(dest, &finfo))
    {
      _ltoa(finfo.st_size, fsize, 10);
      lt = localtime(&finfo.st_mtime);
      strftime(fdate, sizeof(fdate), "%D", lt);
      if (!American_date)
	{
	  str2[0] = fdate[3];
	  str2[1] = fdate[4];
	  fdate[3] = fdate[0];
	  fdate[4] = fdate[1];
	  fdate[0] = str2[0];
	  fdate[1] = str2[1];
	}
      sprintf(stuffdest,"destination: date = %s, size = %s",fdate, fsize);
      stat(source, &finfo);
      _ltoa(finfo.st_size, fsize, 10);
      lt = localtime(&finfo.st_mtime);
      strftime(fdate, sizeof(fdate), "%D", lt);
      if (!American_date)
	{
	  str2[0] = fdate[3];
	  str2[1] = fdate[4];
	  fdate[3] = fdate[0];
	  fdate[4] = fdate[1];
	  fdate[0] = str2[0];
	  fdate[1] = str2[1];
	}
      sprintf(stuffsource,"source:    date = %s, size = %s",fdate, fsize);
      
      exists = wm_create(MaxX/2-30, MaxY/2-2, MaxX/2+30, MaxY/2+3,2,
			 BW_NORMAL|INTENSITY,F_RED|B_BLACK|INTENSITY);
      wm_open(exists);
      wm_top(exists);
      wm_puts_at(exists, 26,0,"THE FILE:");
      wm_puts_at(exists, 30-strlen(dest)/2,1,dest);
      wm_puts_at(exists, 30-strlen(stuffsource)/2,2,stuffsource);
      wm_puts_at(exists, 30-strlen(stuffdest)/2,3,stuffdest);
      

      wm_puts_at(exists, 7,5,
		 "Already exists, do you wish to overwrite?  (Y|N)");
      wm_gotoxy(exists, 55,5);
      wm_cursor(exists);
      wm_cvis(exists,1);
      choice = _read_kbd(0,1,0);
      if ((choice =='n') || (choice =='N'))
	{
	  wm_clear(exists);
	  wm_puts_at(exists,26,1, "MOVE ABORTED");
	  sleep(1);
	  wm_close(exists);
	  wm_delete(exists);
	  return 1;
	  }
      wm_close(exists);
      wm_delete(exists);
    }
  remove(dest);
  if (_fngetdrive(source) == _fngetdrive(dest))
    {
      rename(source, dest);
      return 0;
    }
  else
    {
      if (MyDosCopy((PSZ) source, (PSZ) dest, DCPY_EXISTING)){
	error4("error in moving file to destination:",dest," ","Move Aborted");
	return 1;}
      else if (remove(source))
	error2("Could not delete the source file:",source);
    }
  return 0;
}






int _bsearch(struct FileInfo * list, char * fname, int NumFiles)
{
  int found = 0;
  int First = 0;
  int Last = NumFiles;
  int mid = 0;
  int rc;
  char temp[300];
  char temp2[300];

  strcpy(temp2, fname);
  strtok(mygetname(temp2), " ");
  if (DupIgnoreExt) _remext(temp2);
  while ((!found) && (First <= Last))
    {
      mid = (First + Last)/2;
      strcpy (temp, strtok(list[mid].fname, " "));
      if  (DupIgnoreExt) _remext(temp);
      rc = stricmp(temp2, temp);
      if (rc < 0) Last = mid - 1;
      else if (rc > 0) First = mid + 1;
      else found = 1;
    }

  if (!found) return -1;

  return mid;
}





int display_end(struct Window * win)
{
  int i=win->top_display;
  int j = 0;
  int depth = 0;
  int more;
  char *tempstr = NULL;
  char *eol;
  char *p;
  int first;
  int k = win->numfiles;
  char store;


  win->all_displayed = 1;
  while ((win->all_displayed) && (k))
    {
      j = 0;
      depth = 0;
      --k;
      win->top_display = k;
      i = k;
      win->FileStart[0] = 0;
      if (!win->numfiles)
	{
	  win->FileStart[0] = 0;
	  win->FileStart[1] = -1;
	  win->all_displayed = 1;
	  return 0;
	}
      while ((depth < win->depth) && (i < win->numfiles))
	{
	  mem_free(tempstr);
	  tempstr = Format_File(win, i, tempstr);
	  p = tempstr;
	  first = 1;
	  more = 1;
	  while((depth < win->depth) && (more))
	    {
	      eol = &p[ min(win->width, strlen(p))];
	      if (strlen(p) <= win->width){
		more = 0;}
	      while ((*eol != ' ') && (eol > p) && (more))
		eol--;
	      if (more){
		store = *p;
		p[win->width] = 0;
		eol = &p[win->width];}
	      else if (more){ *eol = 0; store = ' ';}
	      if(more) *eol = store;
	      p = eol;
	      if (!win->wrap) more = 0;
	      if (!WrapComments &&IsComment(win->Files[i].fname)) more=0;
	      first = 0;
	      ++depth;
	      if (!*p) more = 0;
	    }
	  ++i;
	  win->FileStart[++j] = depth;
	}
      /* if we have reached the bottom of the Window and not displayed everything,
*      	 set the next FileStart negative so that we know that.  If not, set the
	 win->all_displayed to 1 */
      if (depth >= win->depth)
	{
	  --j;
	  win->all_displayed = 0;
	}
      else
	{
	  win->all_displayed = abs(win->FileStart[j]) - win->FileStart[j-1];
	  win->FileStart[j+1] = 0;
	}
      win->FileStart[j]=-win->FileStart[j];
      win->bottom_display = i;
    }
  ++k;
  mem_free(tempstr);
  return k;
}


int _bsearch2(struct FileInfo * list, char * fname, int NumFiles)
{
  int found = 0;
  int First = 0;
  int Last = NumFiles;
  int mid = 0;
  int rc;
  char temp[20];
  char temp2[20];

  strcpy(temp2, fname);
  strtok(mygetname(temp2), " ");
  while ((!found) && (First <= Last))
    {
      mid = (First + Last)/2;
      strcpy (temp, list[mid].fname);
      strtok(temp, " ");
      rc = stricmp(temp2, temp);
      if (rc < 0) Last = mid - 1;
      else if (rc > 0) First = mid + 1;
      else found = 1;
    }

  if (!found) return -1;
  return mid;
}






void insert(struct Window * win, int oldpos, int newpos)
{
  int i;
  struct FileInfo temp;

  CopyFileInfo(&temp, &win->Files[oldpos]);

  if (oldpos < newpos-1)
    {
      for (i=oldpos; i < newpos-1; ++i)
	CopyFileInfo(&win->Files[i], &win->Files[i+1]);
      CopyFileInfo(&win->Files[newpos-1], &temp);
    }
  else if (oldpos > newpos-1)
    {
      for (i=oldpos-1; i > newpos-1; --i)
	CopyFileInfo(&win->Files[i+1], &win->Files[i]);
      CopyFileInfo(&win->Files[newpos], &temp);
    }
}



void insert_new(struct Window * WIN, int pos, char * tempstr)
{
  char filename[300];
  struct stat finfo;
  struct tm * lt;
  long long dirsize;
  char str2[20];

  if (!strlen(tempstr)) getfname(tempstr);
  if (strlen(tempstr))
    {
      WIN->changed = 1;
      --WIN->num_free;
      if(WIN->num_free == 0)
	{
	  WIN->Files =
	    (struct FileInfo *)
	      mem_realloc(WIN->Files,
		       (WIN->numfiles+20)*sizeof(struct FileInfo));
	  WIN->selected =
	    (int *) mem_realloc(WIN->selected,
			     (WIN->numfiles+20)*sizeof(int));
	  WIN->num_free = 20;
	}
      if (FnameUpper)
	strcpy(WIN->Files[WIN->numfiles].fname, strupr(tempstr));
      else strcpy(WIN->Files[WIN->numfiles].fname, tempstr);
      while(strlen(WIN->Files[WIN->numfiles].fname) < 13)
	strcat(WIN->Files[WIN->numfiles].fname, " ");

      if (!IsComment(tempstr))
	{
	  strcpy (str2, WIN->dirsize);
	  str2[strlen(str2) - 1] = 0;
	  dirsize = atoi(str2);
	  sprintf(filename,"%s\\%s", fileareas[WIN->area].Download, tempstr);
	  WIN->Files[WIN->numfiles].area = WIN->area;
	  if (!stat(filename, &finfo))
	  {
	    dirsize += finfo.st_size/1024;
	    lt = localtime(&finfo.st_mtime);
	    strftime(WIN->Files[WIN->numfiles].date,
		     sizeof(WIN->Files[WIN->numfiles].date),
		     "%D", lt);
	    if (!American_date)
	      {
		str2[0] = WIN->Files[WIN->numfiles].date[3];
		str2[1] = WIN->Files[WIN->numfiles].date[4];
		WIN->Files[WIN->numfiles].date[3] =
		  WIN->Files[WIN->numfiles].date[0];
		WIN->Files[WIN->numfiles].date[4] =
		  WIN->Files[WIN->numfiles].date[1];
		WIN->Files[WIN->numfiles].date[0] = str2[0];
		WIN->Files[WIN->numfiles].date[1] = str2[1];
	      }

	    WIN->Files[WIN->numfiles].date[8] = 0;
	    size2str(WIN->Files[WIN->numfiles].fsize, finfo.st_size);

	    sprintf(WIN->dirsize, " (%sk)", _ltoa(dirsize,str2, 10));
	    WIN->Files[WIN->numfiles].read_only = (finfo.st_attr & 1);
	  }
	  else{
	    WIN->Files[WIN->numfiles].read_only = OFFLINE;
	    strcpy(WIN->Files[WIN->numfiles].fsize,"       ");
	    strcpy(WIN->Files[WIN->numfiles].date,"OFFLINE ");
	    WIN->Files[WIN->numfiles].description = mem_strdup("");
	  }
	}
      else{
	WIN->Files[WIN->numfiles].read_only = FILE_COMMENT;
	strcpy(WIN->Files[WIN->numfiles].fsize,"-------");
	strcpy(WIN->Files[WIN->numfiles].date,"--------");
      }
      if (!DefaultDescription)
	WIN->Files[WIN->numfiles].description = mem_strdup("");
      else
	WIN->Files[WIN->numfiles].description = mem_strdup(DefaultDescription);
      insert(WIN, WIN->numfiles, pos);
      ++WIN->numfiles;	
    }
}




/*
   For every selected position in the window (it is assumed in the top window)
   of a file and it will attempt to view that with the GIF, JPG, or BMP viewer.
   it first determines what sort of file it is and returns error if it cannot
   view that type.  It then spawns the picture viewer in a separate session
   and waits for it to terminate before continuing.
*/

void pic_view(void *PDummy)
{
  char fname[300] = "";
  int i = 0;
  char * argv[20];
  int type = 0;
  char temp[200];
  char temp2[200];
  char * extension;
  int k;
  struct threadinfo * TInfo;
  int pid;
  int status;
  char execute[256];
  char execname[256];

  TInfo = (struct threadinfo *) PDummy;
  for (k=0; k < TInfo->numfiles; ++k)
    {
      strcpy(temp2, TInfo->namelist[k]);
      extension = strtok(temp2, " ");
      while ((*extension != '.') && (i < strlen(extension))) ++extension;
      ++extension;
      if (!stricmp(extension, "GIF")) type = 1;
      else if (!stricmp(extension, "JPG")) type = 2;
      else if (!stricmp(extension, "BMP")) type = 3;
      else if (!stricmp(extension, "PCX")) type = 4;
      else if (!stricmp(extension, "TIF")) type = 5;
      else if (!stricmp(extension, "TXT")) type = 6;
      i = 1;
      if (type == 1)      strcpy(temp,GifViewer);
      else if (type == 2) strcpy(temp,JPGViewer);
      else if (type == 3) strcpy(temp,BMPViewer);
      else if (type == 4) strcpy(temp,PCXViewer);
      else if (type == 5) strcpy(temp,TIFViewer);
      else strcpy(temp,TXTViewer);
      
      argv[0] = strtok(temp, " ");
      if (__path(execname, argv[0]))
	{
	  error("Could not find viewer in path");
	  return;
	}
      argv[0] = execname;
      if (_osmode != DOS_MODE){
	argv[2] = argv[0];
	argv[0] = "cmd.exe";
	argv[1] = "/c";
	i = 3;}
      else i = 1;
      while ((argv[i] = strtok('\0'," ")))++i;
      
      if (_fnisrel(TInfo->namelist[k]))
	sprintf(fname, "%s\\%s", TInfo->path, TInfo->namelist[k]);
      else strcpy(fname ,TInfo->namelist[k]);
      argv[i++] = strtok(fname," ");
      argv[i++] = '\0';
      
      if (!(access(fname, 0)) && (argv[0]))
	{
	  wm_puts_at(main_window, 60,0,"Viewing:");
	  wm_puts_at(main_window, 68, 0,mygetname(TInfo->namelist[k]));
	  if (_osmode == DOS_MODE){
	    strcpy(execute, " ");
	    for (i=0; argv[i]; ++i){ strcat(execute, argv[i]);
				     strcat(execute, " ");}
	    spawnv(P_WAIT,argv[0], argv);
	  }
	  else{
	    pid = spawnv(P_SESSION|P_WAIT,argv[0], argv);
	    if (pid >= 0) waitpid(pid, &status, 0);
	  }
	}
    }
  wm_puts_at(main_window,60,0,"                 ");
  wm_puta_at(main_window,60,0,F_WHITE|B_WHITE, 20);
  mem_free(PDummy);
  return;
}





int external_edit(char * str, char ** TEMPSTR)
{
  char * TEMPFILE;
  char * tempstr;
  FILE *TempFile;
  char TempStr2[80] = "";
  char * argv[20];
  char *temp;
  int i=1, j;
  int pid;
  int status;
  char execute[256];
  char execname[256];

  if (!strlen(externaledit)){
    error("You need to define an external editor");
    return 0;}

  if (!access(externaledit, 0))
    {
      TEMPFILE = mem_malloc(strlen(TempDir) + strlen("MFXXXXXX") + 2);
      sprintf(TEMPFILE, "%s/%s", TempDir, "MFXXXXXX");
      
      if(!(mktemp(TEMPFILE))){
	error("unable to create temp file");
	return 0;}
      TempFile = fopen(TEMPFILE, "w+");
      fprintf(TempFile, "%s",str);
      fclose(TempFile);
      
      temp = mem_strdup(externaledit);
      argv[0] = strtok(temp, " ");
      if (__path(execname, argv[0]))
	{
	  error("Could not find editor in path");
	  mem_free(TEMPFILE);
	  return 0;
	}
      argv[0] = execname;
      if (_osmode != DOS_MODE){
	argv[2] = argv[0];
	argv[0] = "cmd.exe";
	argv[1] = "/c";
	i = 3;}
      else i = 1;
      while ((argv[i] = strtok('\0'," ")))++i;
      argv[i++] = &TEMPFILE[0];
      for (j=0; j < strlen(TEMPFILE); ++j)
	if (TEMPFILE[j] == '/') TEMPFILE[j] = '\\';
      argv[i++] = '\0';
      if (_osmode == DOS_MODE){
	strcpy(execute, "");
	for (i=0; argv[i]; ++i){strcat(execute, argv[i]);strcat(execute, " ");}
	spawnv(P_WAIT,argv[0], argv);
      }
      else{
	pid = spawnv(P_SESSION|P_WAIT,argv[0], argv);
	if (pid >= 0) waitpid(pid, &status, 0);
      }
      tempstr  = mem_strdup("");
      TempFile = fopen(TEMPFILE, "r");
      while (fgets(TempStr2, 79, TempFile) && (TempFile))
	{
	  if ((!ExtendedDesc) && (!FileListMargin) &&
	      (TempStr2[strlen(TempStr2) - 1] == '\n'))
	    TempStr2[strlen(TempStr2) - 1] = ' ';
	  tempstr = desccat(tempstr, TempStr2);
	}
      if (TempStr2[strlen(TempStr2) - 1] == '\n')
	TempStr2[strlen(TempStr2) - 1] = 0;
      
      fclose(TempFile);
      remove(TEMPFILE);
      if (tempstr[strlen(tempstr) - 1] == '\n') tempstr[strlen(tempstr) - 1] = 0;
      *TEMPSTR = tempstr;
      mem_free(TEMPFILE);
      mem_free(temp);
      return strcmp(str, tempstr);
    }
  else{
    error("The external editor defined in maxfile.cfg does not exist");
    return 0;}

}






int  edit_str(char ** str, int length, char * fname)
{
  wm_handle edit;
  int hpos;
  int vpos;
  char title[140];
  char str1[1000];
  char str2[1000];
  char str3[10];
  char *tempstr = NULL;
  char *tempstrp;
  int choice = 1;
  int temp;
  int width, height;
  int retval;
  char tempstr2[80];
  char tempstr3[1300];
  int all_done = 0;
  int i;
  int x256;
  int y256;


  if (ExtendedDesc || FileListMargin || strlen(externaledit)){
    if (external_edit(*str, &tempstr))
      {
	mem_free(*str);
	*str = tempstr;
	windowlist[top(zorder)].changed = 1;
	return 1;
      }
    mem_free(tempstr);
    return 0;}


  edit = wm_create(MaxX/2-35, MaxY/2-6, MaxX/2+34, MaxY/2+6, 2,
		   DescColour|B_BLACK|INTENSITY, BW_NORMAL|INTENSITY);
  wm_open(edit);
  wm_top(edit);


  if (strlen(*str) > height*width - 1) str[height*width - 1] = 0;
  strcpy(str1, *str);
  strcpy(str2, "");
  wm_puts(edit, *str);

  wm_dimen(edit, &width, &height);
  wm_getxy(edit, &hpos, &vpos);
  wm_cursor(edit);
  wm_cvis(edit, 1);
  sprintf(tempstr2, "%s:<esc> abort <F10> accept(",fname);
  strcpy(title, tempstr2);
  _ltoa(hpos, str3, 10);
  if (strlen(str3) < 2) strcat(title, " ");
  strcat(title, str3);
  strcat(title, ",");
  _ltoa(vpos, str3, 10);
  strcat(title, str3);
  strcat(title, ")");
  wm_border(edit, 2, BW_NORMAL|INTENSITY,title,1, BW_NORMAL|INTENSITY);



  for(i=0; i*width < 256; ++i);
  x256 = 256 - (i-1)*width;
  y256 = i-1;

  while ((choice != ESCAPE) && (!all_done))
    {
      if (desc_256char)
	wm_puta_at(edit, x256, y256, F_YELLOW|B_BLUE|INTENSITY, 1);
      strcpy(title, tempstr2);
      _ltoa(hpos, str3, 10);
      if (strlen(str3) < 2) strcat(title, " ");
      strcat(title, str3);
      strcat(title, ",");
      _ltoa(vpos, str3, 10);
      strcat(title, str3);
      strcat(title, ")");
      wm_border(edit, 2, BW_NORMAL|INTENSITY,title,
		1, BW_NORMAL|INTENSITY);
      choice = _read_kbd(0,1,0);
      if(choice)
	{
	  if (choice == ENTER) choice = ' ';
	  if ((choice == 8) && (strlen(str1)))
	    {
	      --hpos;
	      if (hpos == -1){ hpos = (width - 1); --vpos; }
	      str1[strlen(str1)-1] = 0;
//	      wm_del_char (edit, hpos, vpos, 1);

	      wm_putc_at(edit,(strlen(str1) + strlen(str2))%width,
			 (strlen(str1) + strlen(str2))/width, ' ');
	      if (strlen(str2)){
		wm_gotoxy(edit, strlen(str1)%width, strlen(str1)/width);
		wm_puts(edit, str2);
		wm_gotoxy(edit,hpos,vpos);}
	      else wm_backsp(edit, 1);
	    }
	  else if (((strlen(str1) + strlen(str2)) < length*width - 1) 
		   && (isprint(choice)))
	    {
	      wm_putc(edit, choice);
	      ++hpos;
	      if (hpos == width){
		hpos = 0;
		++vpos;
	      }
	      temp = strlen(str1);
	      str1[temp] = choice;
	      str1[temp+1] = 0;
	      wm_puts(edit, str2);      
	      wm_gotoxy(edit,hpos,vpos);
	    }	
	}
      else
	{
	  choice = _read_kbd(0,1,0);
	  switch(choice)
	    {
	    case K_DEL:
	      if (strlen(str2)){
		
		for (i=0; i < strlen(str2); ++i) str2[i] = str2[i+1];
		wm_putc_at(edit,(strlen(str1) + strlen(str2))%width,
			   (strlen(str1) + strlen(str2))/width, ' ');
		wm_clr_eol(edit, vpos, (strlen(str1) + strlen(str2))/width);
		wm_gotoxy(edit, 0, 0);
		wm_puts(edit, str1);
		wm_puts(edit, str2);
		wm_gotoxy(edit,hpos,vpos);
		}
	      break;
	    case K_HOME:
	      hpos = 0;
	      vpos = 0;
	      sprintf(tempstr3, "%s%s", str1, str2);
	      strcpy(str2, tempstr3);
	      strcpy(str1, "");
	      wm_gotoxy(edit,hpos,vpos);
	      break;
	    case K_END:
	      vpos = (strlen(str1) + strlen(str2)) / width;
	      hpos = (strlen(str1) + strlen(str2)) % width;
	      sprintf(tempstr3, "%s%s",str1, str2);
	      strcpy(str1, tempstr3);
	      strcpy(str2, "");
	      wm_gotoxy(edit,hpos,vpos);
	      break;
	    case K_LEFT:
	      if (strlen(str1)){
		--hpos;
		if (hpos < 0){
		  hpos = width-1;
		  --vpos;};
		tempstrp = &str1[strlen(str1)-1];
		
		sprintf(tempstr3, "%s%s", tempstrp, str2);
		strcpy(str2, tempstr3);
		str1[strlen(str1)-1] = 0;
		wm_gotoxy(edit,hpos,vpos);
	      }
	      break;
	    case K_RIGHT:
	      if (width*vpos + hpos < strlen(str1) + strlen(str2))
		{
		  if (strlen(str2)){
		    ++hpos;
		    if (hpos > width - 1){
		      hpos = 0;
		      ++vpos;};
		    temp = strlen(str1);
		    str1[temp] = str2[0];
		    str1[temp+1] = 0;
		    tempstrp = &str2[1];
		    strcpy(str2, tempstrp);
		    wm_gotoxy(edit,hpos,vpos);
		  }
		}
	      break;
	    case K_UP:
	      if (vpos){
		--vpos;
		tempstrp = &str1[strlen(str1) - width];
		sprintf(tempstr3, "%s%s", tempstrp, str2);
		strcpy(str2, tempstr3);
		str1[strlen(str1) - width] = 0;
		wm_gotoxy(edit,hpos,vpos);
	      }
	      break;
	    case K_DOWN:
	      if (width * (vpos+1) + hpos <= strlen(str1) + strlen(str2)){
		++vpos;
		strcpy(tempstr3, str2);
		tempstrp = &str2[width];
		strcpy(str2, tempstrp);
		tempstr3[width] = 0;
		strcat(str1, tempstr3);
		wm_gotoxy(edit,hpos,vpos);
	      }
	      break;
	    case K_F10:
	      all_done = 1;
	      break;
	    case K_F1:
	      HELP(EditHelp);
	      break;
	    }
	}
    }
  wm_close(edit);
  wm_delete(edit);
  retval = all_done;
  if (retval){
    mem_free(*str);
    *str = mem_strdup("");
    *str = desccat(*str, str1);
    *str = desccat(*str, str2);
  }
  return retval;
}




void delete_listing(struct Window *win, int pos)
{
  int i;
  int other_wildcards = 0;
  char normal_delete = 1;
  
  if (win->Files[pos].wildcard)
    {
      for (i=0; i < win->numfiles; ++i)
	other_wildcards += 
	  (win->Files[pos].wildcard == win->Files[i].wildcard);
      if (!(other_wildcards - 1))
	{
	  strcpy(win->Files[pos].fname, win->Files[pos].wildcard);
	  while(strlen(mygetname(win->Files[pos].fname)) < 13)
	    strcat(win->Files[pos].fname, " ");
	  mem_free(win->Files[pos].wildcard);
	  win->Files[pos].wildcard = NULL;
	  win->Files[pos].read_only = OFFLINE;
	  strcpy(win->Files[pos].fsize,"       ");
	  strcpy(win->Files[pos].date,"OFFLINE ");
	  normal_delete = 0;
	}
    }
  if (normal_delete)
    {
      ++win->num_free;
      --win->numfiles;
      mem_free(win->Files[pos].description);
      for (i = pos; i <win->numfiles; ++i)
	CopyFileInfo(&win->Files[i], &win->Files[i+1]);
      if ((win->top_display<pos) && (win->top_display + win->highlight >=pos))
	--win->highlight;
      else if (win->top_display) --win->top_display;
    }
}




int new_file(char * fname, struct Window *win)
{
  int i=0;
  while (i < win->numfiles)
    {
      if (strnicmp(win->Files[i].fname, fname, strlen(fname))) ++i;
      else i = win->numfiles+1;
    }
  return (i < win->numfiles + 1);
}


int newname(char * fname, struct Window *win)
{
  int retval = 0;
  char choice = 'Y';
  char tempstr[9];
  char * extension = &(fname[strlen(fname) - 4]);
  wm_handle namewindow = wm_create(MaxX/2 - 30, MaxY/2-2, MaxX/2+30, MaxY/2+2,
				   3,BW_NORMAL|INTENSITY, BW_NORMAL|INTENSITY);
  wm_open(namewindow);
  wm_top(namewindow);
  wm_puts_at(namewindow, 0, 0,"I found the orphan file:");
  wm_puts_at(namewindow, 25, 0, fname);
  wm_puts_at(namewindow, 0, 1,
	     "However, the filename exceeds the Maximus 8.3 format");
  while ((choice == 'Y') || (choice == 'y'))
    {
      wm_puts_at(namewindow, 0, 2,
		 "Would you like to enter another one (Y|N)?");
      wm_gotoxy(namewindow, 43,2);
      wm_cursor(namewindow);
      choice = _read_kbd(0,1,0);
      if ((choice == 'Y') || (choice == 'y'))
	{
	  wm_puts_at(namewindow, 0, 3, "New filename (max 8 chars): ");
	  wm_puts_at(namewindow, 35, 3, extension);
	  mygets(namewindow, tempstr, 27, 3, 9);
	  if ((retval = strlen(tempstr))){
	    choice = 'n';
	    sprintf(fname,"%s%s",tempstr, extension);
	  }
	  wm_clr_eol(namewindow, 0,3);
	}
    }
  while(strlen(fname) < 12)
    strcat(fname, " ");

  wm_close(namewindow);
  wm_delete(namewindow);
  return retval;
}





/*
   This function simply skips any whitespace present at the beginning of a
   string.
   */
char *skipspace(char *p)
{
  while ((isspace(*p)) && (*p != '\0')) p++;
  return(p);
}


/*
   This function simply returns the colour of the string p
*/

int GetColour(char *p)
{
  int i;

  p = skipspace(p);

  for (i = F_BLACK; i < F_WHITE; i += F_BLUE)
    if (strnicmp(Colours[i], p, strlen(Colours[i])) == 0)
      return i;
  return(F_WHITE);
}



/*
   findverb is the workhorse of the whole process, it returns two things:

   1) a pointer to the first non-whitespace character after a verb is
   found, or NULL if it can't parse a verb from the string.

   2) the number of the verb in the verbs[] table. this should be ignored
   if the pointer returned is NULL.
   */
char *findverb(char *p, int *verb)
{
  int i;

  p = skipspace(p);

  for (i = 0; i < VerbCount; i++)
    if (strnicmp(verbs[i], p, strlen(verbs[i])) == 0)
      {
	p += strlen(verbs[i]);
	*verb = i;
	return(skipspace(p));
      }
  return(NULL);
}

/*
   Here's a suggested rewrite of your Read_Cfg_File, it's a bit easier to
   follow and still gives the same functionality. The major benefit from
   this type of scheme is that it is much easier to add verbs than if you
   are using an IF-ELSE construct.
     */
int Read_Cfg_File(FILE *ctlfile)
{
  char tempstr[82], *p;
  int verb;
  int j;

  while (fgets(tempstr, 81, ctlfile))
    {
      j = strlen(tempstr);
      while ((j >= 0) && (tempstr[j] < '\x20'))
	tempstr[j--] = '\0';

      p = skipspace(tempstr);
      if ((*p != '\0') && (*p != ';'))
	{
	  p = findverb(tempstr, &verb);
	  if (p != NULL)
	    {
	      switch(verb)
		{
		case 1:
		  mem_free(fbpcmd);
		  fbpcmd = mem_strdup(p);
		  break;
		case 2:
		  mem_free(maxdir);
		  maxdir = mem_strdup(p);
		  if (maxdir[strlen(maxdir)-1] == '\\')
		    maxdir[strlen(maxdir)-1] = 0;
		  break;
		case 3:
		  mem_free(areabbs);
		  areabbs = mem_strdup(p);
		  break;
		case 4:
		  display_date = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 5:
		  display_size = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 6:
		  mem_free(GifViewer);
		  GifViewer = mem_strdup(p);
		  break;
		case 7:
		  mem_free(JPGViewer);
		  JPGViewer = mem_strdup(p);
		  break;
		case 8:
		  mem_free(BMPViewer);
		  BMPViewer = mem_strdup(p);
		  break;
		case 9:
		  mem_free(VirusScanner);
		  VirusScanner = mem_strdup(p);
		  break;
		case 10:
		case 14:
		case 18:
		case 22:
		  strcpy(archivers[(verb-10)/4].extract, p);
		  break;
		case 11:
		case 15:
		case 19:
		case 23:
		  strcpy(archivers[(verb-11)/4].add, p);
		  break;
		case 12:
		case 16:
		case 20:
		case 24:
		  strcpy(archivers[(verb-12)/4].view, p);
		  break;
		case 13:
		case 17:
		case 21:
		case 25:
		  strcpy(archivers[(verb-13)/4].verify, p);
		  break;
		case 26:
		  touch_adoptee = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 27:
		  if (numadopt < 15)
		    strncpy(adopt[numadopt++], p, 3);
		  break;
		case 28:
		  mem_free(DefaultDescription);
		  DefaultDescription = mem_strdup(p);
		  break;
		case 29:
		  Priority = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 30:
		  mem_free(TempDir);
		  if ((p[strlen(p) - 1] == '\\') || (p[strlen(p) - 1] == '/'))
		    p[strlen(p)-1] = 0;
 		  TempDir = mem_strdup(p);
		  break;
		case 31:
		  NameColour = GetColour(p);
		  break;
		case 32:
		  SizeColour = GetColour(p);
		  break;
		case 33:
		  DateColour = GetColour(p);
		  break;
		case 34:
		  DescColour = GetColour(p);
		  break;
		case 35:
		  HighlightColour = GetColour(p)*16;
		  break;
		case 36:
		  auto_adopt = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 37:
		  Window1area = atoi(p);
		  break;
		case 38:
		  Window2area = atoi(p);
		  break;
		case 39:
		  key = _atoll(p);
		  break;
		case 40:
		  WrapComments = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 41:
		  DupIgnoreExt = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 42:
		  AutoFBP = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 43:
		  mem_free(PCXViewer);
		  PCXViewer = mem_strdup(p);
		  break;
		case 44:
		  mem_free(TIFViewer);
		  TIFViewer = mem_strdup(p);
		  break;
		case 45:
		  mem_free(TXTViewer);
		  TXTViewer = mem_strdup(p);
		  break;
		case 46:
		  if (!strnicmp(p, "Maximus", strlen("Maximus")))
		    bbs_type = MAXIMUS;
		  else if(!strnicmp(p, "Lora", strlen("Lora")))
		    bbs_type = LORA;
		  else if(!strnicmp(p, "SBBS", strlen("SBBS")))
		    bbs_type = SBBS;
		  else if(!strnicmp(p, "GENERIC", strlen("GENERIC")))
		    bbs_type = GENERIC;
		case 47:
		  ReadOnlyColour = GetColour(p);
		  break;
		case 48:
		  American_date = !strnicmp(p, "Yes", strlen("Yes"));
		  break;
		case 49:
		  ExtendedDesc = *p;
		  break;
		case 50:
		  VerticalWindow = !strnicmp(p, "Yes", strlen("Yes"));
		  break;
		case 51:
		  CommentColour = GetColour(p);
		  break;
		case 52:
		  OfflineColour = GetColour(p);
		  break;
		case 53:
		  Macros[0] = mem_strdup(p);
		  break;
		case 54:
		  Macros[1] = mem_strdup(p);
		  break;
		case 55:
		  Macros[2] = mem_strdup(p);
		  break;
		case 56:
		  Macros[3] = mem_strdup(p);
		  break;
		case 57:
		  Macros[4] = mem_strdup(p);
		  break;
		case 58:
		  Macros[5] = mem_strdup(p);
		  break;
		case 59:
		  Macros[6] = mem_strdup(p);
		  break;
		case 60:
		  Macros[7] = mem_strdup(p);
		  break;
		case 61:
		  display_wrap = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 62:
		  strip_high_ascii = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 63:
		  mem_free(externaledit);
		  externaledit = mem_strdup(p);
		  break;
		case 64:
		  desc_256char = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 65:
		  DISameArea = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 66:
		  OSDupeSearch = atoi(p);
		  break;
		case 67:
		  FileListMargin = atoi(p);
		  break;
		case 68:
		  FnameUpper = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 69:
		  areasort = (!strnicmp(p, "YES", 3)) ? 1 : 0;
		  break;
		case 70:
		  NewFiles = atoi(p);
		  break;
		case 71:
		  DlCounter = strdup(p);
		  break;
		}
	    }
	  else
	    {
	      printf("Check configuration file, \ntext: %s\n", tempstr);
	      printf("could not be parsed.\n");
	      sleep(2);
	    }
	}
    }
  if (ExtendedDesc && FileListMargin) FileListMargin = 0;
  return(0);
}





void init_screen(struct Window windowlist[maxwindows])
{
  int scr_size[2];
  int i;
  char * argv[5];

  _scrsize(scr_size);
  if (scr_size[1] < 20)
    {
      argv[1] = "/c";
      argv[2] = "mode co80,25";
      argv[3] = 0;
      if (_osmode != DOS_MODE) argv[0] = "cmd.exe";
      else argv[0] = "command.com";
      spawnv(P_WAIT, argv[0], argv);
      _scrsize(scr_size);
    }
  wm_init(10);
  MaxX = scr_size[0];
  MaxY = scr_size[1];
  MidX = MaxX/2;
  MidY = MaxY/2;
  if (VerticalWindow){
    windowlist[1].Handle = wm_create(1,2,MaxX/2-2, MaxY-2,  2,
				     BW_NORMAL|INTENSITY,DescColour|B_BLACK|INTENSITY);
    windowlist[2].Handle = wm_create(MidX+1,2, MaxX-2, MaxY-2, 2,
				     BW_NORMAL,DescColour|B_BLACK|INTENSITY);
  }
  else{
    windowlist[1].Handle = wm_create(1,2,MaxX-2, MaxY/2-2, 2,
				     BW_NORMAL|INTENSITY,DescColour|B_BLACK|INTENSITY);
    windowlist[2].Handle = wm_create(1,MaxY/2+1, MaxX-2, MaxY-2, 2,
				     BW_NORMAL,DescColour|B_BLACK|INTENSITY);
  }
  wm_dimen(windowlist[1].Handle, &windowlist[1].width, &windowlist[1].depth);
  wm_dimen(windowlist[2].Handle, &windowlist[2].width, &windowlist[2].depth);

  main_window = wm_create(0,0,MaxX,MaxY,
			  0,BW_NORMAL,DescColour|B_BLACK|INTENSITY);
  wm_puta_at(main_window, 0, 0, F_BLACK|B_WHITE, MaxX);
  wm_open(main_window);
  wm_puts_at(main_window,1,0,"File");
  wm_puta_at(main_window, 1, 0, F_BLACK|B_WHITE, 4);
  wm_puta_at(main_window, 1, 0, F_RED|B_WHITE, 1);
  wm_puts_at(main_window, 12,0,"Sort");
  wm_puta_at(main_window, 12, 0, F_BLACK|B_WHITE, 4);
  wm_puta_at(main_window, 12, 0, F_RED|B_WHITE, 1);
  wm_puts_at(main_window, 18,0,"Description");
  wm_puta_at(main_window, 18, 0, F_BLACK|B_WHITE, 11);
  wm_puta_at(main_window, 18, 0, F_RED|B_WHITE, 1);

  wm_dimen(main_window, &windowlist[0].width, &windowlist[0].depth);
  wm_dimen(windowlist[1].Handle, &windowlist[1].width, &windowlist[1].depth);
  wm_dimen(windowlist[2].Handle, &windowlist[2].width, &windowlist[2].depth);
  zorder[1] = 1;
  zorder[2] = 2;
  num_windows = 2;
  for(i = 0; i < maxwindows; ++i)
    {
      windowlist[i].Files = NULL;
      windowlist[i].selected = NULL;
      windowlist[i].num_free = 0;
      windowlist[i].numselected = 0;
      windowlist[i].top_display = 0;
      windowlist[i].highlight = 0;
      windowlist[i].wrap = display_wrap;
      windowlist[i].date = display_date;
      windowlist[i].size = display_size;
      windowlist[i].area = i;
    }
}





int Get_File_id(char *fname, char **TEMP, int no_old_desc, int commandline,
		char * olddesc)
{
  char * temp = NULL;
  char cwd[300];
  char * argv[30];
  int archiver = 0;
  int status;
  char FILE_ID[15] = "FILE_ID.DIZ";
  char file_id[15] = "file_id.diz";
  char DESC_SDI[15] = "DESC.SDI";
  char desc_sdi[15] = "desc.sdi";
  int i = 1;
  char read[100];
  char temp2[256];
  char temp3[256];
  FILE * fid;
  int pid;
  int retval = 0;
  char ExtDesc[4] = "   ";
  char * TEMPDIR;
  int len;
  char * p;
  char execute[256];
  char execname[256];
  char * path = getenv("PATH");
  char extractor[100];


  path[strlen(path)] = 0;
  ExtDesc[1] = ExtendedDesc;
  _getcwd2(cwd, sizeof(cwd));
  TEMPDIR = mem_malloc(strlen(TempDir) + strlen("MFXXXXXX") + 3);
  sprintf(TEMPDIR, "%s/%s", TempDir, "MFXXXXXX");

  if(!(mktemp(TEMPDIR)))
    {
      error("unable to create temp directory");
      mem_free(TEMPDIR);
      return 1;
    }
  mkdir(TEMPDIR, 0);
  _chdir2(TEMPDIR);


  archiver = archive_type(fname);
  if (archiver)
    {
      strcpy(temp2,archivers[archiver-1].extract);
      argv[0] = strtok(temp2, " ");
      if (stricmp((char *) &argv[0][strlen(argv[0]-3)], "exe"))
	sprintf(extractor, "%s.exe",argv[0]);
      else strcpy(extractor, argv[0]);
      if (__path(execname, argv[0]))
	{
	  error("Could not find archive extractor in path");
	  mem_free(TEMPDIR);
	  return 1;
	}
      argv[0] = execname;
      if (_osmode != DOS_MODE)
	{
	  argv[2] = execname;
	  argv[0] = "cmd.exe";
	  argv[1] = "/c";
	  i = 3;
	}
      else i = 1;
      while ((argv[i] = strtok('\0'," ")))++i;
      strcpy(temp3, fname);
      argv[i] = strtok(temp3," ");
      argv[++i] = FILE_ID;
      argv[++i] = DESC_SDI;
      argv[++i] = "1>";
      argv[++i] = "NUL";
      argv[++i] = "2>";
      argv[++i] = "NUL";
      argv[++i] = '\0';

      if (_osmode == DOS_MODE){
	strcpy(execute, "");
	for (i=0; argv[i];++i){strcat(execute, argv[i]);strcat(execute, " ");}
	argv[0] = execname;
	spawnv(P_WAIT,argv[0], argv);
      }
      else{
	pid = spawnv(P_SESSION|P_MINIMIZE|P_BACKGROUND,argv[0], argv);
	if (pid >= 0) waitpid(pid, &status, 0);
      }
      if (!(access(file_id, 0)) || !(access(FILE_ID, 0))
	   || !(access(desc_sdi, 0))  || !(access(DESC_SDI, 0)))
	{
	  if (!commandline) errorT("Extracting description",250);
	  if (!(fid = fopen(file_id,"r")))
	    if (!(fid = fopen(FILE_ID,"r")))
	      if (!(fid = fopen(DESC_SDI,"r")))
		if (!(fid = fopen(desc_sdi,"r"))) len = 0;

	  if (!no_old_desc){
	    if ((olddesc[0] == DlCounter[0]) &&
		(olddesc[strlen(DlCounter)-1]==DlCounter[strlen(DlCounter)-1]))
	      {
		temp = mem_malloc(strlen(DlCounter)+3);
		strncpy(temp, olddesc, strlen(DlCounter));
		temp[strlen(DlCounter)] = 0;
		strcat(temp, " ");}
	    else{
	      temp = mem_malloc(strlen(DlCounter) + 3);
	      sprintf(temp, "%s ", DlCounter);}
	  }
	  else{
	    temp = mem_malloc(strlen(DlCounter) + 3);
	    sprintf(temp, "%s ", DlCounter);}
	  while(fgets(read, 80, fid))
	    {
	      if (!ExtendedDesc && !FileListMargin) read[strlen(read)-1] = ' ';
	      else if (ExtendedDesc) strcat(read, ExtDesc);

	      temp = mem_realloc(temp, strlen(temp) + strlen(read) + 2);
	      strcat(temp, read);
	      if (strip_high_ascii)
		for (i=0;i<strlen(temp);++i) if (temp[i] < 0) temp[i] = ' ';
	      i = 0;
	      len = strlen(temp)-3;
	      while ((i < len) && (ExtendedDesc || FileListMargin)){
		++i;
		if ((temp[i]==' ') && (temp[i+1]==' ') && (temp[i+2]==' '))
		  {
		    p = &temp[i+2];
		    temp[i] = 0;
		    strcat(temp, p);
		    len = strlen(temp) - 3;
		    if ((i) && (i < len)) --i;
		  }
	      }
	    }
	  if (ExtendedDesc || FileListMargin) temp[strlen(temp) - 1] = 0;
	  fclose(fid);
	  remove(FILE_ID);
	  remove(DESC_SDI);
	  chdir("..");
	  remove_recursively (TEMPDIR);
	  _chdir2(cwd);
	  if (desc_256char && (!FileListMargin) && (strlen(temp) > 256))
	    temp[256] = 0;
	  *TEMP = temp;
	  mem_free(TEMPDIR);
	  return 1;
	}
      else if (no_old_desc) *TEMP = mem_strdup(DefaultDescription);
    }
  else if (no_old_desc) *TEMP = mem_strdup(DefaultDescription);
  chdir("..");
  _chdir2(cwd);
  remove_recursively (TEMPDIR);
  mem_free(TEMPDIR);
  return retval;
}


void touch(char * fname)
{
  utime(fname, NULL);
}







int search(struct Window * win, char * fname)
{
  int i;

  for (i = 0; i < win->numfiles; ++i)
    if (!strnicmp(mygetname(win->Files[i].fname), fname, strlen(fname)))
      return i;
  return -1;
}




int adopt_files(struct Window *win, int no_long_names, char other_dir)
{
  struct tm * lt;
  DIR * directory;
  char *extension;
  struct dirent * Dirinfop;
  int dirsize;
  struct stat finfo;
  int i=0;
  int num_added = 0;
  int numfiles = win->numfiles;
  char fname[300];
  char oldfname[300];
  char str2[10];
  char *tempstrptr;
  char dirname[300];
  wm_handle adding = wm_create(MaxX/2-30, MaxY/2/2-1,MaxX/2+30, MaxY/2/2+1, 2,
			       BW_NORMAL|INTENSITY, BW_NORMAL|INTENSITY);



  wm_handle where;

  if (other_dir){
    where = wm_create(MaxX/2-35, MaxY/2/2,MaxX/2+35, MaxY/2/2, 2,
		      BW_NORMAL|INTENSITY, BW_NORMAL|INTENSITY);
    wm_border(where, 2, BW_NORMAL|INTENSITY, "Enter the directry for import",
	      2, BW_NORMAL|INTENSITY);
    wm_open(where);
    wm_cursor(where);
    mygets(where, dirname, 0, 0, 70);
    wm_close(where);
    wm_delete(where);
    wm_cursor(win->Handle);
  }
  else strcpy(dirname, fileareas[win->area].Download);
  if ((directory = opendir(dirname))){
    
    strcpy (str2, win->dirsize);
    str2[strlen(str2) - 1] = 0;
    dirsize = atoi(str2);
    if (access(fileareas[win->area].Download, 0)) return 0;
    while ((Dirinfop = readdir(directory)))
      {
	if(Dirinfop->d_namlen >3)
	  if (Dirinfop->d_name[Dirinfop->d_namlen - 4] == '.')
	    {
	      extension = &(Dirinfop->d_name[Dirinfop->d_namlen - 3]);
	      i = 0;
	      while(i < numadopt)
		{
		  if (stricmp(extension, adopt[i])) ++i;
		  else i = numadopt+1;
		}
	      
	      if (no_long_names && (strlen(Dirinfop->d_name) >= 13)) i = 0;
	      if ((i == numadopt+1) && (strlen(Dirinfop->d_name) >= 13))
		{
		  sprintf(oldfname, "%s\\%s",dirname, Dirinfop->d_name);
		  if (newname(Dirinfop->d_name, win))
		    {
		      sprintf(fname, "%s\\%s", dirname, Dirinfop->d_name);
		      rename(oldfname, fname);
		    }
		}
	      if ((i == numadopt+1) &&
		  (search(win, Dirinfop->d_name)==-1)
		  && (strlen(Dirinfop->d_name) < 13))
		{
		  --win->num_free;
		  if(win->num_free == 0)
		    {
		      win->Files =
			(struct FileInfo *)
			  mem_realloc(win->Files,
				      (win->numfiles+20)*sizeof(struct FileInfo));
		      win->selected =
			(int *) mem_realloc(win->selected,
					    (win->numfiles+20)*sizeof(int));
		      win->num_free = 20;
		    }
		  if (no_long_names){
		    printf("\nadopting file %s\n",Dirinfop->d_name);
		    printf("in area %s\n",fileareas[win->area].FileInfo);
		  }
		  else wm_open(adding);
		  wm_top(adding);
		  if (FnameUpper)
		    strcpy(win->Files[win->numfiles].fname, strupr(Dirinfop->d_name));
		  else strcpy(win->Files[win->numfiles].fname, Dirinfop->d_name);
		  
		  while(strlen(win->Files[win->numfiles].fname) < 13)
		    strcat(win->Files[win->numfiles].fname, " ");
		  
		  sprintf(fname, "%s\\%s", dirname, Dirinfop->d_name);
		  if (touch_adoptee) touch(fname);
		  stat(fname, &finfo);
		  if (other_dir){
		    sprintf(oldfname, "%s\\%s", fileareas[win->area].Download,
			    Dirinfop->d_name);
		    mv(fname, oldfname);
		    wm_puts_at(adding,0,0,"importing");
		  }
		  else {
		    wm_puts_at(adding,0,0,"adding");
		    strcpy(oldfname, fname);
		  }
		  wm_clr_eol(adding,0,1);
		  wm_puts_at(adding,0,1,fname);
		  Get_File_id(oldfname, &tempstrptr, 1, no_long_names,
			      win->Files[win->numfiles].description);
		  win->Files[win->numfiles].description = mem_strdup(tempstrptr);
		  if (no_long_names)
		  printf("with description: %s\n\n",tempstrptr);
		  mem_free(tempstrptr);
		  
		  dirsize += finfo.st_size/1024;
		  lt = localtime(&finfo.st_mtime);
		  strftime(win->Files[win->numfiles].date,
			   sizeof(win->Files[win->numfiles].date),
			   "%D", lt);
		  if (!American_date)
		    {
		      str2[0] = win->Files[win->numfiles].date[3];
		      str2[1] = win->Files[win->numfiles].date[4];
		      win->Files[win->numfiles].date[3] =
			win->Files[win->numfiles].date[0];
		      win->Files[win->numfiles].date[4] =
		      win->Files[win->numfiles].date[1];
		      win->Files[win->numfiles].date[0] = str2[0];
		      win->Files[win->numfiles].date[1] = str2[1];
		    }
		  win->Files[win->numfiles].date[8] = 0;
		  size2str(win->Files[win->numfiles].fsize, finfo.st_size);
		  win->Files[win->numfiles].read_only = (finfo.st_attr & 1);
		  win->Files[win->numfiles].wildcard = 0;
		  win->Files[win->numfiles].area = win->area;
		  ++num_added;
		  ++win->numfiles;
		}
	    }
    }
    sprintf(win->dirsize," (%sk)", _ltoa(dirsize,str2, 10));
    closedir(directory);
    wm_close(adding);
    wm_delete(adding);
    return (numfiles - win->numfiles) ? num_added : 0;
  }
  return 0;
}




int savewin(struct Window * WIN, int alldone)
{
  char read;
  wm_handle changed;

  if (WIN->changed){
    changed=wm_create(MaxX/2-30,MaxY/2-1,MaxX/2+30,MaxY/2+2,
		      2,F_RED|B_BLACK|INTENSITY,
		      F_YELLOW|B_BLACK|INTENSITY);
    wm_open(changed);
    wm_top(changed);
    if (alldone)
      wm_border(changed, 2, F_RED|B_BLACK|INTENSITY, "", 0,
		F_RED|B_BLACK|INTENSITY);
    else
      wm_border(changed, 2, F_RED|B_BLACK|INTENSITY,
		"Press <esc> to abort", 1,
		F_RED|B_BLACK|INTENSITY);
    wm_puts_at(changed, 0, 0, fileareas[WIN->area].FileInfo);
    wm_puts_at(changed, 0,1,
	       "This file list has not been saved. Press 'Y' or 'y' to");
    wm_puts_at(changed, 0,2,
	       "save your changes, anything else to abandon them");
    read = _read_kbd(0,1,0);
    if ((read == 'y') || (read == 'Y'))
      write_filesbbs(WIN, 0);
    else if (read != ESCAPE)
      {
	wm_clear(changed);
	wm_puts_at(changed, 0,0,
		   "Any changes made have been lost. Moved files have");
	wm_puts_at(changed, 0,1,
		   "not been returned to their directories and re-");
	wm_puts_at(changed, 0,2,"archived files will retain their new type");
	wm_puts_at(changed, 0,3,"Press any key to continue");
	_read_kbd(0,1,0);
      }
    wm_close(changed);
    if (changed) wm_delete(changed);
    if (read == ESCAPE){WIN->changed = 0; return 0;}
    WIN->changed = 0;
    return 1;
  }
  WIN->changed = 0;
  return 1;
}





int ReadFileList(int AREA, struct Window *win, int get_f_info)
{
  char ** WildCards;
  int list_number;
  long disk_space = 0;
  int i, j;
  char tempstr[1350];
  char readline[1350];
  char * TEMPSTR = tempstr;
  char str2[30];
  FILE * files_bbs;
  char fname[1000];
  char DownloadPath[100];
  char tempstr2[100];
  int width;
  int height;
  int num_files;
  int rc;
  int first;
  char strcat_last = 0;
  int filestart;
  char * FirstNonSpace;
  char * p;
  struct stat finfo;
  int l;
  struct tm * lt;
  DIR * directory;
  struct dirent * Dinfop;

  HDIR DirHandle = 0xFFFF;
  ULONG Attribute = FILE_NORMAL;
  FILEFINDBUF3 ResultBuf;
  ULONG ulFileNames;
  ULONG uInfoLevel = 1;


  for (i = 0; i < win->numfiles; ++i)
    {
      mem_free(win->Files[i].description);
      if (win->Files[i].wildcard){
	mem_free(win->Files[i].wildcard);
	for (j=i+1; win->Files[j].wildcard == win->Files[i].wildcard; ++j)
	  win->Files[j].wildcard = 0;
      }
    }
  
  win->changed = 0;
  win->lock = 0;
  win->SortLock = 0;
  num_files = 0;
  win->numfiles = 0;
  win->num_free = 0;


  filestart = win->numfiles;
  list_number = AREA;
  win->area = list_number;
  DirHandle = 0xFFFF;
  Attribute= FILE_NORMAL;
  uInfoLevel = 1;
  strcat_last = 0;
  win->highlight = 0;
  if (win->Handle){
    wm_dimen(win->Handle, &width, &height);
    wm_clear(win->Handle);
    wm_puts_at(win->Handle, width/2-5, height/2, "Please wait");
    wm_puts_at(win->Handle, width/2-8, height/2+1, "Getting File Info");
  }
  sprintf (DownloadPath, "%s\\", fileareas[list_number].Download);
  
  if (strlen(fileareas[list_number].FileList))
    strcpy(fname,fileareas[list_number].FileList);
  else
    sprintf(fname, "%s\\files.bbs", fileareas[list_number].Download);
  
  
  if(!(files_bbs = fopen(fname, "r")))
    {
      strcpy(readline, "the files.bbs for area ");
      strcat(readline,fileareas[list_number].Area);
      strcat(readline," could not be opened");
      error4(readline, fileareas[list_number].FileList,
	     fileareas[list_number].Download,
	     fname);
      win->top_display = 0;
      win->highlight = 0;
      wm_clear(win->Handle);
      win->Files = (struct FileInfo *)
	mem_realloc(win->Files,(21)*sizeof(struct FileInfo));
      win->selected = (int *) mem_realloc(win->selected, (21)*sizeof(int));
      win->num_free = 20;
      strcpy(win->Files[0].fname,"COMMENTS     ");
      strcpy(win->Files[0].date, "--------");
      strcpy(win->Files[0].fsize,"-------");
      win->Files[0].wildcard = NULL;
      win->Files[win->numfiles].description = mem_strdup("");
      win->numfiles++;
      strcpy(win->dirsize, "(0k)");
    }
  else{
    
    while (fgets(readline, 1349, files_bbs) && (files_bbs))
      ++num_files;
    win->Files=(struct FileInfo *)
      mem_realloc(win->Files, (num_files+20)*sizeof(struct FileInfo));
    win->selected = (int *)
      mem_realloc(win->selected, (num_files+20)*sizeof(int));
    num_files += 20;
    
    win->num_free = 20;
    rewind(files_bbs);
    while (fgets(tempstr, 1349, files_bbs) && (files_bbs))
      {
	FirstNonSpace = first_non_space(tempstr);
	if (strcat_last)
	  {
	    --win->numfiles;
	    if (tempstr[strlen(tempstr)-1] == '\n')
	      tempstr[strlen(tempstr)-1] = 0;
	    else strcat_last = 0;
	    win->Files[win->numfiles].description = 
	      desccat(win->Files[win->numfiles].description,tempstr);
	    strcat_last = 0;
	  }
	else if ((*FirstNonSpace==ExtendedDesc) && (ExtendedDesc))
	  {
	    --win->numfiles;
	    win->Files[win->numfiles].description = 
	      desccat(win->Files[win->numfiles].description,"\n");
	    if (tempstr[strlen(tempstr)-1] == '\n')
	      tempstr[strlen(tempstr)-1] = 0;
	    else strcat_last = 0;
	    win->Files[win->numfiles].description = 
	      desccat(win->Files[win->numfiles].description,tempstr);
	  }
	else if ((tempstr[0] == ' ') && FileListMargin &&
		 tempstr && (*FirstNonSpace != ' '))
	  {
	    --win->numfiles;
	    p = tempstr;
	    while (isspace(*p)) ++p;
	    win->Files[win->numfiles].description = 
	      desccat(win->Files[win->numfiles].description, p);
	  }
	else
	  {if (tempstr && (tempstr[0] != ' ') && (tempstr[0] != '-')
	       && (tempstr[0] != '\n'))
	     {
	       for(i=0; (!isspace(tempstr[i])) && (i < strlen(tempstr));++i);
	       tempstr[i] = 0;
	       TEMPSTR = &tempstr[i+1];
	       if(TEMPSTR[strlen(TEMPSTR) - 1] != '\n') strcat_last = 1;
	       else if (!FileListMargin) TEMPSTR[strlen(TEMPSTR)-1] = 0;
	       strcpy(fname, tempstr);
	       if (FnameUpper){
		 strupr(tempstr);
		 win->changed = stricmp(fname, tempstr) || win->changed;
	       }

	       if (strchr(tempstr, '*') || strchr(tempstr, '?')){

		 /* Now handle the case in which there is a wild
		    card file name.  There will be a single pointer to
		    the char string of the wildcard name and each instance
		    if the wildcard will have the pointer argument set to
		    that string.  The filename will correspond to the specific
		    instance of the wildcard.  */

		 if (!_fnisabs(tempstr))
		   sprintf(fname, "%s%s", DownloadPath, tempstr);
		 else strcpy(fname, tempstr);
		 WildCards = _fnexplode(fname);
		 if (WildCards[0]){
		   for (l=0; WildCards[l]; ++l){
		     --win->num_free;
		     if (!win->num_free) ExpandWindow(win, num_files);
		     if (!first)
		       win->Files[win->numfiles].wildcard = 
			 win->Files[win->numfiles-1].wildcard;
		     else 
		       win->Files[win->numfiles].wildcard =
			 mem_strdup(tempstr);
		     first = 0;
		     strcpy(win->Files[win->numfiles].fname, WildCards[l]);
		     while(strlen(mygetname(win->Files[win->numfiles].fname))
			   < 13) strcat(win->Files[win->numfiles].fname," ");
		     win->Files[win->numfiles].description =
		       mem_strdup(TEMPSTR);
		     win->Files[win->numfiles].area = list_number;
		     ++win->numfiles;
		   }
		 --win->numfiles;
		 mem_free(win->Files[win->numfiles].description);
		 _fnexplodefree(WildCards);
		 }
		 else{
		   win->Files[win->numfiles].area = list_number;
		   win->Files[win->numfiles].wildcard = NULL;
		   strcpy(win->Files[win->numfiles].fname, fname);
		   while(strlen(mygetname(win->Files[win->numfiles].fname))
			 < 13) strcat(win->Files[win->numfiles].fname, " ");
		 }
	       }
	       else {
		 win->Files[win->numfiles].area = list_number;
		 win->Files[win->numfiles].wildcard = NULL;
		 strcpy(win->Files[win->numfiles].fname, tempstr);
		 if (_fnisabs(win->Files[win->numfiles].fname))
		   {
		     _fullpath (tempstr2, win->Files[win->numfiles].fname,
				sizeof(tempstr2));
		     strcpy(win->Files[win->numfiles].fname, tempstr2);
		     for (j=0;j<strlen(win->Files[win->numfiles].fname); ++j)
		       if( win->Files[win->numfiles].fname[j] == '/')
			 win->Files[win->numfiles].fname[j] = '\\';
		   }
		 while(strlen(mygetname(win->Files[win->numfiles].fname))<13)
		   strcat(win->Files[win->numfiles].fname, " ");
		 TEMPSTR = &tempstr[i+1];
		 while ((isspace(*TEMPSTR)) && (strlen(TEMPSTR)))++TEMPSTR;
		 win->Files[win->numfiles].read_only = OFFLINE;
	       }
	     }
	  else
	    {
	      TEMPSTR = &tempstr[0];
	      if (TEMPSTR[0] == '\n') TEMPSTR[0] = ' ';
	      else if (TEMPSTR[strlen(TEMPSTR) - 1] == '\n')
		TEMPSTR[strlen(TEMPSTR)-1] = 0;
	      win->Files[win->numfiles].wildcard = 0;
	      strcpy(win->Files[win->numfiles].fname,"COMMENTS     ");
	      strcpy(win->Files[win->numfiles].fsize,"-------");
	      strcpy(win->Files[win->numfiles].date,"--------");
	      win->Files[win->numfiles].read_only = FILE_COMMENT;
	      win->Files[win->numfiles].area = list_number;
	    }
	   if (TEMPSTR[strlen(TEMPSTR) - 1] == '\n')
	     TEMPSTR[strlen(TEMPSTR)-1] = 0;
	   win->Files[win->numfiles].description = mem_strdup(TEMPSTR);
	 }
	++win->numfiles;
      }
    for (i=filestart; i < win->numfiles; ++i)
      if (!IsComment(win->Files[i].fname)){
	strcpy(win->Files[i].date, "OFFLINE ");
	strcpy(win->Files[i].fsize,"       ");
	win->Files[i].read_only = OFFLINE;
      }
    
    if (get_f_info){
      
      if (_osmode != DOS_MODE){
	
	strcpy(fname,DownloadPath);
	strcat(fname,"*");
	ulFileNames = 1;
	DirHandle = 0xFFFF;
	rc = DosFindFirst((PCSZ) fname, &DirHandle, Attribute, &ResultBuf,
			  sizeof(ResultBuf), &ulFileNames, uInfoLevel);
	while (!rc)
	  {
	    for (i=filestart;
		 strnicmp(ResultBuf.achName,win->Files[i].fname,ResultBuf.cchName);
		 ++i) if (i == win->numfiles) break;
	    if (i < win->numfiles)
	      {
		if (ResultBuf.fdateLastWrite.year)
		  date2str(ResultBuf.fdateLastWrite, win->Files[i].date);
		else
		  date2str(ResultBuf.fdateCreation, win->Files[i].date);
		disk_space += ResultBuf.cbFile;
		size2str(win->Files[i].fsize, ResultBuf.cbFile);
		win->Files[i].read_only = (ResultBuf.attrFile & FILE_READONLY);
	      }
	    rc = DosFindNext(DirHandle,&ResultBuf,sizeof(ResultBuf),&ulFileNames);
	  }
	DosFindClose(DirHandle);
      }
      else {
	directory = opendir(DownloadPath);
	while ((Dinfop = readdir(directory)))
	  {
	    for (i=filestart;
		 strnicmp(Dinfop->d_name, win->Files[i].fname,
			  strlen(Dinfop->d_name)); ++i)
	      if (i == win->numfiles) break;

	    if (i < win->numfiles){
	      d_date2str((struct d_date *) &Dinfop->d_date, win->Files[i].date);
	      disk_space += Dinfop->d_size;
	      size2str(win->Files[i].fsize, Dinfop->d_size);
	      win->Files[i].read_only = (Dinfop->d_attr & A_RONLY);
	    }
	  }
	closedir(directory);
      }
      for(i=filestart; i < win->numfiles; ++i)
	{
	  if (_fnisabs(win->Files[i].fname))
	    {
	      if (!_fnisabs(win->Files[i].fname))
		sprintf(tempstr2, "%s/%s", fileareas[list_number].Download,
			win->Files[i].fname);
	      else strcpy(tempstr2, win->Files[i].fname);
	      strtok(tempstr2, " ");
	      if (!stat(tempstr2, &finfo)){
		
		lt = localtime(&finfo.st_mtime);
		strftime(win->Files[i].date,
			 sizeof(win->Files[i].date),"%D", lt);
		if (!American_date)
		  {
		    str2[0] = win->Files[i].date[3];
		    str2[1] = win->Files[i].date[4];
		    win->Files[i].date[3] =
		      win->Files[i].date[0];
		    win->Files[i].date[4] =
		      win->Files[i].date[1];
		    win->Files[i].date[0] = str2[0];
		    win->Files[i].date[1] = str2[1];
		  }
		win->Files[i].date[8] = 0;
		size2str(win->Files[i].fsize, finfo.st_size);
		win->Files[i].read_only = (finfo.st_attr & 1);
		win->Files[i].wildcard = 0;
		win->Files[i].area = win->area;
		disk_space += finfo.st_size/1024;
	      }
	    }
	}
	
    }
    if(files_bbs) fclose(files_bbs);      
    
    sprintf(win->dirsize, " (%sk)", _ltoa(disk_space/1024,str2, 10));
    win->numselected = 0;
    
    
    if (auto_adopt && (numareas == 1)) if (adopt_files(win, 0, 0)){
      win->numselected = 0;
	win->changed = 1;}
  }

  for (i=0; i < win->numfiles; ++i)
    if (win->Files[i].description[strlen(win->Files[i].description)] == '\n')
      win->Files[i].description = 0;

  if (win->changed) savewin(win, 1);
  return win->numfiles;
}






int get_number(char first_num, int numareas)
{
  char title[20];
  wm_handle number;
  char num[5] = "    ";
  char read = 0;
  int retval = -1;
  int numchars = 1;
  char temp[20];
  char temp2[20];

  number = wm_create(MaxX/2-3, MaxY/2, MaxX/2+3, MaxY/2, 2,
		     BW_NORMAL|INTENSITY, F_WHITE|B_BLACK|INTENSITY);
  sprintf(title,"%s-%s", _ltoa(0, temp, 10), _ltoa(numareas-1, temp2, 10));
  wm_border(number, 2, F_YELLOW|B_BLACK|INTENSITY,
	    title,1,F_RED|B_BLACK|INTENSITY);
  wm_puta_at(number, 0, 0, F_WHITE|B_WHITE, 6);
  num[4] = first_num;
  wm_open(number);
  wm_top(number);
  wm_puta_at(number, 6, 0, F_WHITE|B_BLACK, 1);
  wm_putc_at(number, 6, 0, num[4]);
  while ((read != ESCAPE) && (read != ENTER))
    {
      read = _read_kbd(0,1,0);
      switch(read)
	{
	case 0:
	  _read_kbd(0,1,0);
	  break;
	case '0': case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
	  if (10*atoi(num) + read-48 < numareas)
	    {
	      ++numchars;
	      num[1] = num[2]; num[2] = num[3];
	      num[3] = num[4]; num[4] = read;
	      wm_puts_at(number, 2, 0, num);
	      wm_puta_at(number,0, 0, F_WHITE|B_WHITE|INTENSITY, 6-numchars+1);
	    }
	  break;
	case 8:
	  if (numchars)
	    {
	      --numchars;
	      wm_puta_at(number, 3, 0, F_WHITE|B_WHITE|INTENSITY, 1);
	      num[4] = num[3]; num[3] = num[2]; num[2] = num[1];num[1] = ' ';
	      wm_puts_at(number, 2, 0, num);
	      wm_puta_at(number, 0, 0,F_WHITE|B_WHITE|INTENSITY, 6-numchars+1);
	      num[0] = ' ';
	    }
	  break;
	case ENTER:
	  retval = atoi(num);
	  break;
	}
    }
  wm_close(number);
  wm_delete(number);
  return retval;
}



void make_area(char * str, int area, int selected)
{
  char areanumber[10];
  char mark[2];

  mark[1] = 0;
  if (selected) mark[0] = '*'; else mark[0] = ' ';
  if (area < 10)
    sprintf(str,"%s(00%s) %s:%s", mark, _ltoa(area, areanumber, 10),
	    fileareas[area].Area, fileareas[area].FileInfo);  
  else if (area < 100)
    sprintf(str,"%s(0%s) %s:%s", mark, _ltoa(area, areanumber, 10),
	    fileareas[area].Area, fileareas[area].FileInfo);  
  else
    sprintf(str,"%s(%s) %s:%s", mark, _ltoa(area, areanumber, 10),
	    fileareas[area].Area, fileareas[area].FileInfo);  
}







void select_area(int num_areas, int presarea, int * area, int multiple)
{
  wm_handle select_Window;
  int i;
  int newwinpos = 0;
  int choice = 1;
  char title[130];
  int selection;
  int winpos = 1;
  int pos;
  int scroll = 1;
  int NumSelected;
  int windepth = MaxY - 7;
  int mxdisp;

  windepth = 2*(windepth/2);
  mxdisp = windepth - 1;
  select_Window = wm_create(MaxX/2-28,
			    MaxY/2-windepth/2 + 1,
			    MaxX/2+28,
			    MaxY/2+windepth/2,
			    2, BW_NORMAL|INTENSITY, F_WHITE|B_BLACK|INTENSITY);
  wm_border(select_Window, 2, BW_NORMAL|INTENSITY,
	    "<esc> to cancel, <enter> to select", 1, BW_NORMAL);
  wm_open(select_Window);
  wm_top(select_Window);
  wm_wrap(select_Window, 0);
  selection = presarea;
  winpos = 0;


  if (presarea + windepth < numareas-1)
    newwinpos = 0;
  else
    newwinpos = min(windepth - (num_areas - selection), selection);


  if (multiple) for (i = 0; i < num_areas; area[i++] = 0);

  while ((choice != ESCAPE) && (choice != ENTER))
    {
      if(scroll){
	wm_clear(select_Window);
	for (i=0; i<min(windepth, numareas); ++i)
	  {
	    pos = i + selection - newwinpos;
	    make_area(title, pos, area[pos*multiple]*multiple);
	    wm_puts_at(select_Window, 1, i, title);
	  }
	}
      if ((winpos != newwinpos) || (scroll)){
	wm_puta_at(select_Window,1,winpos,
		   F_WHITE|B_BLACK|INTENSITY,56);
	winpos = newwinpos;
	wm_puta_at(select_Window, 1, winpos, F_BLACK|B_WHITE,56);
	scroll = 0;
      }

      choice = _read_kbd(0,1,0);

      if (isdigit(choice)){
	if ((selection = get_number(choice, num_areas)) != -1){
	  if (selection + windepth < num_areas-1)
	    newwinpos = 0;
	  else
	    newwinpos = windepth - (num_areas - selection);
	  scroll = 1;
	}
      }
      
      else if ((choice == ' ') && (multiple))
	{
	  if ((area[selection] = !area[selection]))
	    wm_putc_at(select_Window, 1, winpos, '*');
	  else
	    wm_putc_at(select_Window, 1, winpos, ' ');
	  wm_puta_at(select_Window, 1, winpos, F_BLACK|B_WHITE|INTENSITY, 1);
	  if (winpos < min(mxdisp, numareas-1))
	    {
	      newwinpos = winpos + 1;
	      ++selection;
	    }
	  else if (selection < num_areas-1)
	    {
	      ++selection;
	      wm_scroll(select_Window, 1);
	      make_area(title, selection, area[selection*multiple]*multiple);
	      wm_puts_at(select_Window, 1,mxdisp, title);
	      wm_puta_at(select_Window,1,mxdisp-1,F_WHITE|B_BLACK|INTENSITY,56);
	      wm_puta_at(select_Window,1,mxdisp,B_WHITE|F_BLACK,56);
	    }
	}
    
      else if (!choice){
	choice = _read_kbd(0,1,0);
	switch(choice)
	  {
	  case K_F1:
	    HELP(AreaHelp);
	    break;
	  case K_UP:
	    if (winpos > 0)
	      {
		--selection;
		newwinpos = winpos - 1;
	      }
	    else if (selection > 0)
	      {
		--selection;
		wm_ins_line(select_Window, 0, 1);
		make_area(title, selection, area[selection*multiple]*multiple);
		wm_puts_at(select_Window, 1, 0, title);
		wm_puta_at(select_Window,1,1,F_WHITE|B_BLACK|INTENSITY,56);
		wm_puta_at(select_Window,1,0,B_WHITE|F_BLACK,56);
	      }
	    break;

	  case K_PAGEUP:
	    if (selection+winpos){
	      if (selection - winpos - windepth > 0)
		selection -= windepth;
	      else{
		newwinpos = 0;
		selection = 0;}
	      scroll = 1;
	    }
	    break;
	  case K_HOME:
	    if (winpos+selection){
	      newwinpos = 0;
	      scroll = 1;
	      selection = 0;
	    }
	    break;
	  case K_END:
	    if (selection != num_areas - 1)
	      {
		scroll = 1;
		selection = num_areas-1;
		newwinpos = mxdisp;
	      }
	    break;
	  case K_DOWN:
	    if (winpos < min(mxdisp, numareas-1))
	      {
		newwinpos = winpos + 1;
		++selection;
	      }
	    else if (selection < num_areas-1)
	      {
		++selection;
		wm_scroll(select_Window, 1);
		make_area(title, selection, area[selection*multiple]*multiple);
		wm_puts_at(select_Window, 1, mxdisp, title);
		wm_puta_at(select_Window,1,mxdisp-1,F_WHITE|B_BLACK|INTENSITY,56);
		wm_puta_at(select_Window,1,mxdisp,B_WHITE|F_BLACK,56);
	      }
	    break;
	  case K_PAGEDOWN:
	    if ((selection != num_areas - 1)){
	      if (selection + windepth + (windepth-winpos) < num_areas-1)
		selection += windepth;
	      else {
		newwinpos = min(mxdisp, num_areas-1);
		selection = num_areas-1;}
	      scroll = 1;
	    }
	    break;
	  case K_F10:
	    if (multiple)
	      {
		NumSelected = 0;
		for (i=0; i < num_areas; ++i)
		  NumSelected += area[i];
		if (NumSelected == num_areas)
		  for(i=0; i <num_areas; area[i++] = 0);
		else for(i=0; i <num_areas; area[i++] = 1);
		scroll = 1;
	      }
	    break;
	  }
      }
    }
  if (choice == ESCAPE){
    *area = -1;
    selection = -1;
  }
  wm_close(select_Window);
  wm_delete(select_Window);
  if (!multiple) *area = selection;
}






void cpfileinfo(char * str, struct Window * WIN, int position)
{
  char areaname[40];
  char tmpstr[130];

  sprintf(tmpstr, "%s%s %s", mygetname(WIN->Files[position].fname),
	  WIN->Files[position].date, WIN->Files[position].fsize);
  if (WIN->Files[position].read_only == OFFLINE)
    strcat(tmpstr," Offline");
  else if (WIN->Files[position].read_only == READ_ONLY)
    strcat(tmpstr," Read Only");
  strcpy(areaname, fileareas[WIN->Files[position].area].Area);
  while (strlen(areaname) < 5) strcat(areaname, " ");
  areaname[5] = 0;
  sprintf(str, " %s%s", areaname, tmpstr);
}





int Ok2Operate(struct Window * WIN)
{
  wm_handle delete_Window;
  int i, j=0;
  int newwinpos = 0;
  int choice = 1;
  char title[130];
  int selection = 0;
  int winpos = 1;
  int pos;
  int scroll = 1;
  int numselected = WIN->numselected;
  char NoneSelected = 0;
  int windepth = MaxY - 7;
  int mxdisp;
  int * selected = mem_malloc((numselected + 1)*sizeof(int));



  windepth = 2*(windepth/2);
  mxdisp = windepth - 1;
  for (i = 0; i < numselected; ++i)
    selected[i] = WIN->selected[i];
  if (numselected == 0)
    {
      NoneSelected = 0;
      selected = mem_realloc(selected, 2*sizeof(int));
      selected[0] = WIN->top_display + WIN->highlight;
      numselected = 1;
    }
  selected[numselected] = 0;

  delete_Window = wm_create(MaxX/2-28,
			    MaxY/2-windepth/2 + 1,
			    MaxX/2+28,
			    MaxY/2+windepth/2,
			    2, BW_NORMAL|INTENSITY, F_WHITE|B_BLACK|INTENSITY);
  wm_border(delete_Window, 2, BW_NORMAL|INTENSITY,
	    "These files?  <F1> = Help", 1, BW_NORMAL);
  wm_open(delete_Window);
  wm_top(delete_Window);
  wm_wrap(delete_Window, 0);
  winpos = 0;



  while ((choice != ESCAPE) && (choice != ENTER) && numselected)
    {
      if(scroll){
	wm_clear(delete_Window);
	for (i=0; i<min(windepth, numselected); ++i)
	  {
	    pos = i + selection - newwinpos;
	    cpfileinfo(title, WIN, selected[pos]);
	    wm_puts_at(delete_Window, 1, i, title);
	  }
	}
      if ((winpos != newwinpos) || (scroll)){
	wm_puta_at(delete_Window,1,winpos,
		   F_WHITE|B_BLACK|INTENSITY,56);
	winpos = newwinpos;
	wm_puta_at(delete_Window, 1, winpos, F_BLACK|B_WHITE,56);
	scroll = 0;
      }

      choice = _read_kbd(0,1,0);
      if (choice){
	switch(choice){
	case ' ':
	  --numselected;
	  if (winpos == min(mxdisp, numselected)) --winpos;
	  for (j = selection; j <=numselected; ++j)
	    selected[j] = selected[j+1];
	  scroll = 1;
	  newwinpos = winpos;
	  if (selection > winpos) selection = winpos;
	}
      }
      else{
	choice = _read_kbd(0,1,0);
	switch(choice)
	  {
	  case K_F1:
	    HELP(Ok2OperateHelp);
	    break;
	  case K_UP:
	    if (winpos > 0)
	      {
		--selection;
		newwinpos = winpos - 1;
	      }
	    else if (selection > 0)
	      {
		--selection;
		wm_ins_line(delete_Window, 0, 1);
		cpfileinfo(title, WIN, selected[selection]);
		wm_puts_at(delete_Window, 1, 0, title);
		wm_puta_at(delete_Window,1,1,F_WHITE|B_BLACK|INTENSITY,56);
		wm_puta_at(delete_Window,1,0,B_WHITE|F_BLACK,56);
	      }
	    break;

	  case K_PAGEUP:
	    if (selection+winpos){
	      if (selection - winpos - mxdisp > 0)
		selection -= mxdisp;
	      else{
		newwinpos = 0;
		selection = 0;}
	      scroll = 1;
	    }
	    break;
	  case K_HOME:
	    if (winpos+selection){
	      newwinpos = 0;
	      scroll = 1;
	      selection = 0;
	    }
	    break;
	  case K_END:
	    if ((winpos != mxdisp) && (selection != numselected - 1))
	      {
		scroll = 1;
		selection = numselected-1;
		newwinpos = min(mxdisp, numselected-1);
	      }
	    break;
	  case K_DOWN:
	    if ((winpos < min(mxdisp, numselected-1)))
	      {
		newwinpos = winpos + 1;
		++selection;
	      }
	    else if (selection < numselected-1)
	      {
		++selection;
		wm_scroll(delete_Window, 1);
		cpfileinfo(title, WIN, selected[selection]);
		wm_puts_at(delete_Window, 1, mxdisp, title);
		wm_puta_at(delete_Window,1,mxdisp-1,F_WHITE|B_BLACK|INTENSITY,56);
		wm_puta_at(delete_Window,1,mxdisp,B_WHITE|F_BLACK,56);
	      }
	    break;
	  case K_PAGEDOWN:
	    if ((winpos != mxdisp) && (selection != numselected - 1)){
	      if (selection + windepth + (windepth-winpos) < numselected-1)
		selection += windepth;
	      else {
		newwinpos = min(mxdisp, numselected-1);
		selection = numselected-1;}
	      scroll = 1;
	    }
	    break;
	  }
      }
    }
  wm_close(delete_Window);
  wm_delete(delete_Window);

  if ((choice == ESCAPE) && (numselected)){ mem_free(selected); return 0;}
  for (i = 0; i < numselected; ++i) WIN->selected[i] = selected[i];
  WIN->numselected = numselected;
  mem_free(selected);
  displaylist(WIN);
  wm_highlight(WIN, 1);
  return numselected;
}







void touch_pos(struct Window *win, int pos)
{
  struct stat finfo;
  struct tm * lt;
  int position = win->top_display + win->highlight;
  char fname[300] = "";
  char str2[2];

  if (pos == -1) position = win->top_display + win->highlight;
  else position = pos;
  if (_fnisrel(win->Files[position].fname))
    {
      strcat(fname, fileareas[win->area].Download);
      strcat(fname, "\\");
    }
  strcat(fname ,win->Files[position].fname);
  touch(strtok(fname, " "));
  if (!stat(fname, &finfo))
    {
      lt = localtime(&finfo.st_mtime);
      strftime(win->Files[position].date,
	       sizeof(win->Files[position].date),
	       "%D", lt);
      if (!American_date)
	{
	  str2[0] = win->Files[position].date[3];
	  str2[1] = win->Files[position].date[4];
	  win->Files[position].date[3] =
	    win->Files[position].date[0];
	  win->Files[position].date[4] =
	    win->Files[position].date[1];
	  win->Files[position].date[0] = str2[0];
	  win->Files[position].date[1] = str2[1];
	}
      win->Files[position].date[8] = 0;
      size2str(win->Files[position].fsize, finfo.st_size);
    }
}



int extract(char *fname, char * tempdir)
{
  char presdir[100];
  char path[200];
  char fpath[200] = "";
  char * argv[20];
  int i = 1;
  int pid;
  int * status = &pid;
  int rc;
  int a_type;
  char temp[100];
  char * TEMPDIR;
  char execute[256];
  char execname[256];

  strcpy(path, fileareas[windowlist[top(zorder)].area].Download);

  TEMPDIR = mem_malloc(strlen(TempDir) + strlen("MFXXXXXX") + 2);
  sprintf(TEMPDIR, "%s/%s", TempDir, "MFXXXXXX");

  if(!(mktemp(TEMPDIR)))
    {
      error("unable to create temp directory");
      return 1;
    }
  strcpy(tempdir, TEMPDIR);
  mem_free(TEMPDIR);
  mkdir(tempdir, 0);
  _getcwd2(presdir, sizeof(presdir));
  _chdir2(tempdir);
  if (_fnisrel(fname))
    {
      strcat(fpath, path);
      strcat(fpath,"\\");
    }
  strcat(fpath, fname);

  if ((a_type = archive_type(fname)))
    {
      strcpy(temp, archivers[a_type-1].extract);
      argv[0] = strtok(temp, " ");
      if (__path(execname, argv[0]))
	{
	  error("Could not find archive extractor in path");
	  mem_free(TEMPDIR);
	  return 1;
	}
      argv[0] = execname;
      if (_osmode != DOS_MODE){
	argv[2] = argv[0];
	argv[0] = "cmd.exe";
	argv[1] = "/c";
	i = 3;}
      else i = 1;
      while ((argv[i] = strtok('\0', " "))) ++i;
      argv[i++] = strtok(fpath, " ");
      argv[i++] = '\0';
      if (_osmode == DOS_MODE){
	strcpy(execute, "");
	for(i=0;argv[i];++i){strcat(execute,argv[i]);strcat(execute," ");}
        *status = 256*spawnv(P_WAIT,argv[0], argv);
	// *status = 0;
      }
      else {
	pid = spawnv(P_SESSION,argv[0], argv);
	if (pid >= 0) waitpid(pid, status, 0);
	else * status = 512;
      }
      /* get the return code from the high-order byte */
      rc = *status/256;
      chdir("..");
      _chdir2(presdir);
      if (rc) {
	error(" unable to extract archive... ");
	return 1;}
      else return 0;
    }
  error2("I don't know how to unarchive that sort of file", fname);
  return 1;
}


void re_archive(void * PDummy)
{
  char presdir[100];
  struct threadinfo * TInfo = (struct threadinfo *) PDummy;
  HFILE ifd;
  HFILE ofd;
  char *tmpdir;
  char fpath[200] = "";
  char newfpath[200] = "";
  char * argv[20];
  int a_type;
  int i;
  int pid;
  int * status = &pid;
  int rc;
  char new_name[200];
  char temp[100];
  char temp2[100];
  ULONG ActionTaken;
  char OLDFinfo[100];
  char NEWFinfo[100];
  struct stat finfo;
  int k;
  int j;
  struct Window * WIN = TInfo->WIN;
  struct utimbuf times;
  char execute[256];
  char execname[256];

  _getcwd2(presdir, sizeof(presdir));
  WIN->lock = 1;
  ++Re_Archiving;
  --TInfo->new_type;
  if (TInfo->new_type+1) for(k = 0; k < TInfo->numfiles; ++k)
    {
      i = 1;
      wm_puts_at(main_window, 40,0,"Re-Arch:");
      wm_puts_at(main_window, 48, 0,mygetname(TInfo->namelist[k]));

      tmpdir = mem_malloc(strlen(TempDir) + strlen("MFXXXXXX") + 2);
	sprintf(tmpdir, "%s/%s", TempDir, "MFXXXXXX");

      if(!(mktemp(tmpdir)))
	{
	  error("unable to create temp directory");
	  return;
	}
      mkdir(tmpdir, 0);
      _chdir2(tmpdir);
      strcpy(fpath, "");
      if(_fnisrel(TInfo->namelist[k]))
	{
	  strcat(fpath, TInfo->path);
	  strcat(fpath,"\\");
	}
      strcat(fpath, TInfo->namelist[k]);
      stat(fpath, &finfo);

      if (_osmode != DOS_MODE){

	rc = DosOpen ((UCHAR*) fpath, &ifd, &ActionTaken,finfo.st_size,
		      FILE_NORMAL,
		      OPEN_ACTION_OPEN_IF_EXISTS,
		      OPEN_FLAGS_SEQUENTIAL|OPEN_ACCESS_READONLY|
		      OPEN_SHARE_DENYREADWRITE|OPEN_FLAGS_NOINHERIT|
		      OPEN_FLAGS_FAIL_ON_ERROR|OPEN_FLAGS_WRITE_THROUGH,0);
	DosQueryFileInfo(ifd, 1, OLDFinfo, sizeof(OLDFinfo));
	DosClose(ifd);
      }
      if ((a_type = archive_type(TInfo->namelist[k])))
	{
	  strcpy(temp, archivers[a_type-1].extract);
	  argv[0] = strtok(temp, " ");
	  if (__path(execname, argv[0]))
	    {
	      error("Could not find archive extractor in path");
	      return;
	    }
	  argv[0] = execname;
	  if (_osmode != DOS_MODE){
	    argv[2] = argv[0];
	    argv[0] = "cmd.exe";
	    argv[1] = "/c";
	    i = 3;}
	  else i = 1;
	  while ((argv[i] = strtok('\0', " "))) ++i;
	  argv[i++] = strtok(fpath, " ");
	  argv[i++] = '\0';

	  if (_osmode == DOS_MODE){
	    strcpy(execute,"");
	    for(i=0;argv[i];++i){strcat(execute,argv[i]);strcat(execute," ");}
	    *status = 256*spawnv(P_WAIT, argv[0], argv);
	  }
	  else {
	    pid = spawnv(P_SESSION|P_BACKGROUND|P_MINIMIZE, argv[0], argv);
	    if (pid >= 0) waitpid(pid, status, 0);
	    else * status = 512;
	  }
	  /* get the return code from the high-order byte */
	  rc = *status/256;
	  if (rc) error(" unable to extract archive... ");
	  else
	    {
	      strcpy(newfpath, "");
	      strcpy(new_name, TInfo->namelist[k]);
	      _remext(new_name);
	      _defext(new_name, TInfo->newextension);
	      if(_fnisrel(TInfo->namelist[k]))
		{
		  strcat(newfpath, TInfo->path);
		  strcat(newfpath,"\\");
		}
	      strcat(newfpath, new_name);
	      i = 1;
	      strcpy(temp, archivers[TInfo->new_type].add);
	      argv[0] = strtok(temp, " ");
	      if (__path(execname, argv[0]))
		{
		  error("Could not find archive creator in path");
		  return;
		}
	      argv[0] = execname;
	      if (_osmode != DOS_MODE){
		argv[2] = argv[0];
		argv[0] = "cmd.exe";
		argv[1] = "/c";
		i = 3;}
	      else i = 1;
	      while ((argv[i] = strtok('\0', " "))) ++i;
	      strcpy(temp2,new_name);
	      argv[i++] = strtok(temp2, " ");
	      argv[i++] = "*";
	      argv[i++] = '\0';
	      if (_osmode==DOS_MODE){
		strcpy(execute,"");
		for(i=0;argv[i];++i)
		  {strcat(execute,argv[i]);strcat(execute, " ");}
		*status=256*spawnv(P_WAIT,argv[0], argv);
	      }
	      else{
		pid = spawnv(P_SESSION|P_BACKGROUND|P_MINIMIZE, argv[0], argv);
		if (pid >= 0) waitpid(pid, status, 0);
		else * status = 512;
	      }
	      rc = *status/256;
	      if (!rc){
		stat(new_name, &finfo);
		if (_osmode != DOS_MODE){
		  rc = DosOpen ((UCHAR *) new_name, &ofd,
				&ActionTaken,finfo.st_size,
				FILE_NORMAL,
				OPEN_ACTION_OPEN_IF_EXISTS,
				OPEN_FLAGS_SEQUENTIAL|OPEN_ACCESS_WRITEONLY|
				OPEN_SHARE_DENYREADWRITE|
				OPEN_FLAGS_FAIL_ON_ERROR|
				OPEN_FLAGS_WRITE_THROUGH,0);
		  DosQueryFileInfo(ofd, 1, NEWFinfo, sizeof(NEWFinfo));
		  OLDFinfo[12] = NEWFinfo[12];
		  OLDFinfo[13] = NEWFinfo[13];
		  OLDFinfo[14] = NEWFinfo[14];
		  OLDFinfo[15] = NEWFinfo[15];
		  OLDFinfo[16] = NEWFinfo[16];
		  OLDFinfo[17] = NEWFinfo[17];
		  DosSetFileInfo(ofd, 1, OLDFinfo, sizeof(OLDFinfo));
		  DosClose(ofd);
		}
		else{
		  times.actime = finfo.st_atime;
		  times.modtime = finfo.st_mtime;
		  utime(new_name, &times);
		}

		if (stricmp(new_name, newfpath))
		  if (MyDosCopy((UCHAR *)new_name, (UCHAR *)newfpath, 1))
		    error4T("Problem moving new archive to destination",
			   new_name, "to", newfpath, 2000);
		else
		  {
		    if (stricmp(mygetname(fpath), mygetname(newfpath)))
		      if (remove(fpath))
			error2("problem removing the file",TInfo->namelist[k]);
		    WIN->SortLock = 1;
		    for (j=0; ((j < WIN->numfiles) &&
			       (stricmp(TInfo->namelist[k],
					WIN->Files[j].fname)));
			 ++j);
		    if (j < WIN->numfiles){
		      _remext(WIN->Files[j].fname);
		      strcat(WIN->Files[j].fname, ".");
		      strcat(WIN->Files[j].fname, TInfo->newextension);
		      while (strlen(WIN->Files[j].fname) < 13)
			strcat(WIN->Files[j].fname," ");
		      size2str(WIN->Files[j].fsize, finfo.st_size);
		    }
		    else error3("Problem re-archiving:",
			       "The file being re-archived could not be",
			       "located in the file list. Perhaps you have moved it...");
		    WIN->SortLock = 0;
		    displaylist(WIN);
		    wm_highlight(WIN, 1);
		  }
	      }
	    }
	}
      else error(" you cannot re-archive that type of file");
      chdir("..");
      _chdir2(presdir);
      remove_recursively(tmpdir);
      free(tmpdir);
    }
  wm_puts_at(main_window,40,0,"                 ");
  wm_puta_at(main_window,40,0,F_WHITE|B_WHITE, 21);
  WIN->lock = 0;
  --Re_Archiving;
  mem_free(PDummy);
}


int scroll_down(struct Window *win)
{
  int max_displayed;
  char *new_desc[60];
  int more;
  char *tempstr = NULL;
  char *eol;
  char *p;
  int depth = 0;
  int i;
  char store = ' ';
  int pos;

  if(win->highlight){ --win->highlight; return 1;}
  if (!win->top_display) return 0;

  --win->top_display;
  tempstr = Format_File(win, win->top_display, tempstr);
  p = tempstr;
  more = 1;
  pos = win->top_display;
  while(more)
    {
      eol = &p[min( win->width, strlen(p)) ];
      if (strlen(p) <= win->width){
	new_desc[depth] = mem_strdup(p);
	more = 0;}
      else
	{
	  while ((*eol != ' ') && (eol > p))
	    eol--;
	  if ( eol == p ){
	    store = *p;
	    p[win->width] = 0;
	    eol = &p[win->width];
	  }
	  else {*eol = 0; store = ' ';}
	  new_desc[depth] = mem_strdup(p);
	  *eol = store;
	  p = eol;
	  if ((!win->wrap) || (!*p) ||
	      (!WrapComments&&IsComment(win->Files[pos].fname)))
	    more = 0;
	}
      ++depth;
    }
  wm_ins_line(win->Handle, 0, depth);
  for (i=0; i < depth; ++i){
    wm_puts_at(win->Handle, 0, i, new_desc[i]);
    mem_free(new_desc[i]);};
  highlight_date_time(win, 0, 1, win->Files[pos].read_only);

  max_displayed = max_vis_file(win) + 2;

  for (i = max_displayed + 1; i > 0; --i)
    win->FileStart[i] = abs(win->FileStart[i-1]) + depth;

  for (i=0; (win->FileStart[i] < win->depth) && 
       (i + win->top_display < win->numfiles); ++i);

  if (win->FileStart[i] < win->depth){
    win->all_displayed = 1;
    win->FileStart[i] = -win->FileStart[i];
  }
  else{
    win->all_displayed = 0;
    win->FileStart[i-1] = -win->FileStart[i-1];
  }
  win->bottom_display = max_vis_file(win) + win->top_display;
  mem_free(tempstr);
  return 1;
}


int scroll_up(struct Window *win)
{
  int i;
  int j = 0;
  int depth;
  int more;
  char *tempstr = NULL;
  int num_vis = max_vis_file(win);
  char *eol;
  char * p;
  char mvf;
  int temp;
  int first;
  char store = ' ';
  int highlighted;

  highlighted = win->highlight + win->top_display;
  if (win->all_displayed)
    {
      if ((win->highlight < max_vis_file(win)) &&
	  (win->highlight + win->top_display < win->numfiles - 1))
	++win->highlight;
      return 1;
    }
  if (win->highlight < num_vis){++win->highlight; return 1;}
  i = win->top_display++;
  if (abs(win->FileStart[1]) < win->depth)
    wm_scroll(win->Handle, abs(win->FileStart[1]));
  else {displaylist(win); return 1;}
  temp = abs(win->FileStart[1]);
  for(j=0; j < num_vis+1; ++j){
    win->FileStart[j] = abs(win->FileStart[j+1]) - temp;
    ++i;}
  depth = abs(win->FileStart[num_vis]);
  j = num_vis;
  while ((depth < win->depth) && (i < win->numfiles))
    {
      if (tempstr) mem_free(tempstr);
      tempstr = Format_File(win, i, tempstr);

      p = tempstr;
      first = 1;
      more = 1;
      while((depth < win->depth) && (more))
	{
	  eol = &p[win->width];
	  if ( strlen(p) <= win->width ){
	    wm_puts_at(win->Handle, 0, depth ,p);
	    more = 0;}
	  if (more){
	    while ((*eol != ' ') && (eol > p) && (more))
	      eol--;
	    if (eol == p){
	      store = *p;
	      p[win->width] = 0;
	      eol = &p[win->width];}
	    
	    else if (more) {store = ' '; *eol = 0;}
	    wm_puts_at(win->Handle, 0, depth, p);
	  }
	  if (first) highlight_date_time(win, depth,0,win->Files[i].read_only);
	  ++depth;
	  if (more) *eol = store;
	  p = eol;
	  if (!win->wrap) more = 0;
	  if (!WrapComments && IsComment(win->Files[i].fname)) more = 0;
	  first = 0;
	  if (!*p) more = 0;
	}
      ++i;
      win->FileStart[++j] = depth;
    }
  if (depth >= win->depth)
    {
      --j;
      win->all_displayed = 0;
    }
  else
    {
      win->all_displayed = abs(win->FileStart[j]) - win->FileStart[j-1];
      win->FileStart[j+1] = 0;
    }
  win->FileStart[j]=-abs(win->FileStart[j]);
  win->bottom_display = i;
  mvf = max_vis_file(win);
  if (win->top_display + win->highlight > mvf)
    {
      win->highlight = 0;
      while (win->highlight < mvf) ++win->highlight;
    }
  mem_free(tempstr);
  while (win->highlight + win->top_display > highlighted+1)
    --win->highlight;
  return 1;
}



int move(struct Window *win, int to, int pos)
{
  char filename[200] = "";
  char destname[200];
  char FilesBBS[200];
  char FilesBKP[200];
  int i;
  struct Window * WIN;
  FILE * FILESBBS;
  char last_char;

  int area = win->area;
  if (strlen(fileareas[to].FileList))
    strcpy (FilesBBS, fileareas[to].FileList);
  else
    sprintf(FilesBBS, "%s\\files.bbs", fileareas[to].Download);
  if(!fileareas[to].backed_up)
    {
      strcpy(FilesBKP, FilesBBS);
      FilesBKP[strlen(FilesBKP)-2] = 'k';
      FilesBKP[strlen(FilesBKP)-1] = 'p';
      MyDosCopy((UCHAR *) FilesBBS, (UCHAR *) FilesBKP, 1);
      fileareas[to].backed_up = 1;
    }
  if ((FILESBBS = fopen(FilesBBS, "a+t")))
    {
      if (_fnisrel(win->Files[pos].fname))
	sprintf(filename, "%s\\", fileareas[area].Download);
      strcat(filename, win->Files[pos].fname);
      sprintf(destname, "%s\\%s",fileareas[to].Download,
	      win->Files[pos].fname);
      if (!mv(filename, destname) ||
	  !(strnicmp("offline",win->Files[pos].date, strlen("offline"))))
	{
	  fseek(FILESBBS, -1, SEEK_END);
	  fread(&last_char, sizeof(char), 1, FILESBBS);
	  fseek(FILESBBS, 0, SEEK_END);
	  if (last_char != '\n'){
	    last_char = '\n';
	    fwrite(&last_char, sizeof(char), 1, FILESBBS);}
	  fwrite(mygetname(win->Files[pos].fname),
		 sizeof(char)*strlen(mygetname(win->Files[pos].fname)),
		 1, FILESBBS);
	  fwrite(win->Files[pos].description,
		 sizeof(char)*strlen(win->Files[pos].description),
		 1, FILESBBS);
	  last_char = '\n';
	  fwrite(&last_char, sizeof(char), 1, FILESBBS);
	}
      else return 1;
      fclose(FILESBBS);
    }
  else
    {
      error2("The target files.bbs could not be opened",
	     "The description will be left in the original files.bbs");
      return 1;
    }
  
  /*now check to see if another window is open with the destination
    files.bbs in that window.  If so, add the moved files descriptions
    to the end of that files.bbs.   The "3" in the for statement is
    because I presently only have two windows open*/
  for (i = 1; i< 3; ++i)
    {
      if (windowlist[i].area == to)
	{
	  WIN = &windowlist[i];
	  --WIN->num_free;
	  if(!WIN->num_free) {
	    WIN->Files = (struct FileInfo *)
	      mem_realloc(WIN->Files,
		       (WIN->numfiles+20)*sizeof(struct FileInfo));
	    win->selected =
	      (int *) mem_realloc(win->selected,
			       (WIN->numfiles+20)*sizeof(int));
	    WIN->num_free = 20;}
	  DuplicateFileInfo(&WIN->Files[WIN->numfiles], &win->Files[pos]);
	  ++WIN->numfiles;
	  displaylist(WIN);
	  break;
	}
    }
  return 0;
}




int del(struct Window * WIN, int pos)
{
  int retval = 0;
  char * filename;
  int len;

  if (_fnisrel(WIN->Files[pos].fname))
    {
      len = strlen(fileareas[WIN->area].Download) + 1
	+ strlen(WIN->Files[pos].fname)+1  +3;
      filename = mem_malloc(len);
      sprintf(filename, "%s\\%s",fileareas[WIN->area].Download,
	      WIN->Files[pos].fname);
    }
  else filename = mem_strdup(WIN->Files[pos].fname);
  if (remove(filename)) retval = 1;
  mem_free(filename);
  return retval;
}



int contents(int pos, struct Window *win)
{
  char * argv[20];
  char execname[256];
  char temp2[256];
  char temp3[256] = "";
  wm_handle output;
  int winpos;
  int numlines = 0;
  int archiver = 0;
  FILE * pipe;
  char title[130];
  char OUT[400][81];
  int choice = 0;
  int i, j;
  char *TEMPFILE;
  ULONG apptype;
  int pid, status;

  archiver = archive_type(win->Files[pos].fname);
  numlines = 0;
  if (archiver)
    {
      strcpy(temp2,archivers[archiver-1].view);
      argv[0] = strtok(temp2, " ");
      if (__path(execname, argv[0]))
	{
	  error("Could not find archive viewer in path");
	  return 0;
	}
      argv[0] = execname;
      if (_osmode != DOS_MODE){
	argv[2] = argv[0];
	argv[0] = "cmd.exe";
	argv[1] = "/c";
	i = 3;}
      else i = 1;
      while ((argv[i] = strtok('\0'," ")))++i;
      if (_fnisrel(win->Files[pos].fname))
	{
	  strcat(temp3, fileareas[win->area].Download);
	  strcat(temp3, "\\");
	}
      strcat(temp3, win->Files[pos].fname);
      strtok(temp3," ");
      argv[i++] = temp3;
      if (_osmode == DOS_MODE) argv[i++] = "1>";
      else{
	DosQueryAppType(argv[i-1], &apptype);
	if (apptype & FAPPTYP_DOS)
	  argv[i++] = "^>";
	else argv[i++] = ">";
      }
      TEMPFILE = mem_malloc(strlen(TempDir) + strlen("MFXXXXXX") + 2);
      sprintf(TEMPFILE, "%s/%s", TempDir, "MFXXXXXX");
      if(!(mktemp(TEMPFILE))){
	error("unable to create temp file");
	return 0;}
      for (j=0; j < strlen(TEMPFILE); ++j)
	if (TEMPFILE[j] == '/') TEMPFILE[j] = '\\';
      argv[i++] = TEMPFILE;
      argv[i++] = '\0';
      
      if (_osmode == DOS_MODE)spawnv(P_WAIT,argv[0], argv);
      else{ pid=spawnv(P_SESSION|P_MINIMIZE|P_BACKGROUND,argv[0], argv);
      waitpid(pid, &status, 0);}
      pipe = fopen(TEMPFILE, "r");
      mem_free(TEMPFILE);
      if (!pipe){
	error2("Could not open the archive", win->Files[pos].fname);
	return 0;
      }
      while ((fgets(OUT[numlines], 80, pipe)) && (numlines < 400)) ++numlines;
      fclose(pipe);
      remove(TEMPFILE);
      /* Strip off all of the non-alpha numeric characters (spaces, control
	 characters, slashes... */
      for(i=0;i<numlines;++i)
	{
	  int j = strlen(OUT[i])-1;
	  OUT[i][j] = 0;
	}
      output = wm_create(1,MaxY/2 - 8, 78, MaxY/2+8,
			 2,BW_NORMAL|INTENSITY,BW_NORMAL|INTENSITY);
      wm_open(output);
      wm_top(output);
      wm_wrap(output, 0);
      strcpy(title,"<esc> to cancel:  ");
      strcat(title, win->Files[pos].fname);
      wm_border(output, 2, BW_NORMAL|INTENSITY,
		title, 1, F_RED|B_BLACK|INTENSITY);
      winpos = 0;
      for(i = 0; ((i < 17) && (i < numlines)); ++i)
	wm_puts_at(output,0,i,OUT[winpos+i]);
      while (choice != ESCAPE)
	{
	  choice = _read_kbd(0,1,0);
	  switch(choice)
	    {
	    case K_DOWN:
	      if (winpos < (numlines-16))
		{
		  ++winpos;
		  wm_scroll(output, 1);
		  wm_puts_at(output, 0,16, OUT[winpos+16]);
		}
	      break;
	    case K_UP:
	      if (winpos > 0)
		{
		  --winpos;
		  wm_ins_line(output, 0, 1);
		  wm_puts_at(output, 0,0, OUT[winpos]);
		}
	      break;
	    case K_HOME:
	      if (winpos){
		winpos = 0;
		wm_clear(output);
		for(i = 0; ((i < 17) && (i < numlines)); ++i)
		  wm_puts_at(output,0,i,OUT[winpos+i]);
	      }
	      break;
	    case K_END:
	      if (winpos != numlines-16){
		winpos = (numlines > 16) ? numlines-16 : 0;
		wm_clear(output);
		for(i = 0; ((i < 17) && (i < numlines)); ++i)
		  wm_puts_at(output,0,i,OUT[winpos+i]);
	      }
	      break;
	    case K_PAGEDOWN:
	      if (numlines < 16) {winpos = 0; break;}
	      if (winpos < numlines-16)
		{
		  wm_clear(output);
		  winpos = ((winpos + 32) > numlines) ?
		    numlines -16 : winpos+16;
		  for(i = 0; ((i < 17) && (i < numlines)); ++i)
		    wm_puts_at(output,0,i,OUT[winpos+i]);
		}
	      break;
	    case K_PAGEUP:
	      if (winpos){
		wm_clear(output);
		if (numlines < 16) winpos = 0;
		else winpos = ((winpos - 16) < 0) ?
		  0 : winpos-16;
		for(i = 0; ((i < 17) && (i < numlines)); ++i)
		  wm_puts_at(output,0,i,OUT[winpos+i]);
	      }
	      break;
	    }
	}
      wm_close(output);
      wm_delete(output);
      return 0;
    }
  else{
    error2(" I don't know how to handle files like this ",
	   win->Files[pos].fname);
    return 1;
  }
}





void verify(int pos, struct Window *win)
{
  char * argv[20];
  char * file;
  int archiver = 0;
  int * status;
  int rc = 1;
  int i = 0;
  char temp[300];
  char temp2[300];
  char fname[300] = "";
  int pid;
  char execname[256];
  char execute[256];

  strcpy(temp2,win->Files[pos].fname);
  file = strtok(temp2," ");
  archiver = archive_type(win->Files[pos].fname);
  if (archiver)
    {
      strcpy(temp,archivers[archiver-1].verify);
      argv[0] = strtok(temp, " ");
      if (__path(execname, argv[0]))
	{
	  error("Could not find archive verifier in path");
	  return;
	}
      argv[0] = execname;
      if (_osmode != DOS_MODE){
	argv[2] = argv[0];
	argv[0] = "cmd.exe";
	argv[1] = "/c";
	i = 3;}
      else i = 1;
      while ((argv[i] = strtok('\0'," ")))++i;
      if (_fnisrel(win->Files[pos].fname))
	{
	  strcat(fname, fileareas[win->area].Download);
	  strcat(fname, "\\");
	}
      strcat(fname, win->Files[pos].fname);
      argv[i++] = strtok(fname," ");
      argv[i++] = '\0';
      if (_osmode == DOS_MODE){
	strcpy(execute, "");
	for(i=0;argv[i];++i){strcat(execute, argv[i]); strcat(execute, " ");}
	rc = spawnv(P_WAIT, argv[0], argv);
      }
      else {
	pid = spawnv(P_SESSION, argv[0], argv);
	status = &rc;
	if (pid >= 0) waitpid(pid, status, 0);
	else * status = 512;
	/* get the return code from the high-order byte */
	rc = *status/256;
      }
      if (_osmode != DOS_MODE)
	if (rc) error2(fname, "is corrupt!");
	else error2(fname,"is valid");
    }
}


void DupeOperate(struct Window * WIN, int pos, int operation)
{
  struct Window *TmpWin;
  int i, k;
  char fname[100];
  char * fnamep;
  char fname1[100];
  char * fname1p;
  char winopen = 0;

  for (k=0; k < 3; ++k)
    if (windowlist[k].area == WIN->Files[pos].area){
      TmpWin = &windowlist[k];
      winopen = 1;
    }
  if (!winopen){
    TmpWin = mem_malloc(sizeof(struct Window));
    TmpWin->Handle = 0;
    TmpWin->Files = NULL;
    TmpWin->numfiles = 0;
    TmpWin->selected = NULL;
    ReadFileList(WIN->Files[pos].area, TmpWin, 0);
  }
  strcpy(fname, WIN->Files[pos].fname);
  fnamep = mygetname(strtok(fname, " "));
  for (i=0; i < TmpWin->numfiles; ++i)
    {
      strcpy(fname1, TmpWin->Files[i].fname);
      fname1p = mygetname(strtok(fname1, " "));
      if (!stricmp(fnamep, fname1p)) break;
    }
  if ((operation == DUPEREMOVE) || (operation == DUPEDELETE))
    {
      if (DUPEDELETE) del(TmpWin, i);
      delete_listing(TmpWin, i);
      delete_listing(WIN, pos);
    }
  else if (operation == DUPEEDIT){
    mem_free(TmpWin->Files[i].description);
    TmpWin->Files[i].description = mem_strdup(WIN->Files[pos].description);
  }
  write_filesbbs(TmpWin, 0);
  if (!winopen){
    free_window(TmpWin);
    mem_free(TmpWin);
  }
}





void DupeEdit(struct Window * WIN)
{
  int i, j;
  char * tempstrp;
  char choice;
  int diff;
  int pos;
  int temp_pos;

  if (WIN->numfiles)
    {
      
      WIN->wrap = display_wrap;
      WIN->date = display_date;
      WIN->size = display_size;
      
      strcpy(WIN->dirsize, "");
      WIN->numselected = 0;
      wm_open(WIN->Handle);
      wm_top(WIN->Handle);
      WIN->area = 0;
      displaylist(WIN);
      wm_highlight(WIN, 1);
      choice = 1;
      WIN->numselected = 0;
      
      while ((choice != ESCAPE) && (WIN->numfiles)){
	TITLE(WIN, WIN->Files[WIN->top_display+WIN->highlight].area);
	choice = _read_kbd(0,1,0);
	if (!choice){
	  choice = _read_kbd(0,1,0);
	  switch(choice)
	    {
	    case K_F1:
	      HELP(DupeHelp);
	    break;
	    case K_HOME:
	      WIN->top_display = 0;
	      displaylist(WIN);
	      WIN->highlight = 0;
	      wm_highlight(WIN, 1);
	      break;
	    case K_END:
	      if (!(WIN->all_displayed))
		{
		  WIN->top_display = display_end(WIN);
		  displaylist(WIN);
		  WIN->highlight = max_vis_file(WIN);
		  wm_highlight(WIN, 1);
		}
	      else if (WIN->highlight + WIN->top_display != WIN->numfiles - 1){
		wm_highlight(WIN, 0);
		WIN->highlight = max_vis_file(WIN);
		wm_highlight(WIN, 1);
	      }
	      break;
	    case K_DOWN:
	      if (WIN->highlight + WIN->top_display != WIN->numfiles - 1)
		{
		  wm_highlight(WIN, 0);
		  scroll_up(WIN);
		  wm_highlight(WIN, 1);
		}
	      break;
	    case K_UP:
	      if (WIN->top_display || WIN->highlight){
		wm_highlight(WIN, 0);
		scroll_down(WIN);
		wm_highlight(WIN, 1);}
	      break;
	    case K_PAGEDOWN:
	      if (WIN->bottom_display < WIN->numfiles-1)
		{
		  diff = WIN->bottom_display - WIN->top_display - 1;
		  if (WIN->bottom_display + diff < WIN->numfiles-1){
		    WIN->top_display += diff;
		    WIN->highlight = 0;
		    displaylist(WIN);
		    wm_highlight(WIN, 1);
		  }
		  else if(!WIN->all_displayed){
		    WIN->top_display = display_end(WIN);
		    WIN->highlight = max_vis_file(WIN);
		    displaylist(WIN);
		    wm_highlight(WIN, 1);
		  }
		  else{
		    wm_highlight(WIN, 0);
		    WIN->highlight = max_vis_file(WIN);
		    wm_highlight(WIN, 1);
		  }
		}
	      break;
	  case K_PAGEUP:
	      diff = WIN->bottom_display - WIN->top_display - 1;
	      if (WIN->top_display - diff < 0)
	      WIN->top_display = 0;
	      else
		WIN->top_display -= diff;
	      if (WIN->top_display - diff < 0) diff = 0;
	      displaylist(WIN);
	      WIN->highlight = 0;
	      wm_highlight(WIN, 1);
	      break;
	  case K_ALT_C:
	      if((!WIN->numselected) && (choice != ' ')){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
	      for (i = 0; i < WIN->numselected; ++i)
		contents(WIN->selected[i],WIN);
	      WIN->numselected = 0;
	      displaylist(WIN);
	      wm_highlight(WIN, 1);
	      break;
	    case K_ALT_R:
	      if(!WIN->numselected){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
	      if (Ok2Operate(WIN)){
		for (i = WIN->numselected-1; i >= 0; --i)
		  DupeOperate(WIN, WIN->selected[i], DUPEREMOVE);
		WIN->numselected = 0;
		if (WIN->numfiles){
		  displaylist(WIN);
		  if (WIN->highlight>max_vis_file(WIN))
		  WIN->highlight = max_vis_file(WIN);
		  wm_highlight(WIN, 1);
		}
	      }
	      break;
	    case K_ALT_D:
	      if(!WIN->numselected){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
	      if (Ok2Operate(WIN)){
		for (i = WIN->numselected-1; i >= 0; --i)
		DupeOperate(WIN, WIN->selected[i], DUPEDELETE);
		WIN->numselected = 0;
		if (WIN->numfiles){
		  displaylist(WIN);
		  if (WIN->highlight>max_vis_file(WIN))
		  WIN->highlight = max_vis_file(WIN);
		  wm_highlight(WIN, 1);
		}
	      }
	      break;
	    case K_ALT_V:
	      if((!WIN->numselected) && (choice != ' ')){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	      for (i = 0; i < WIN->numselected; ++i)
		verify(WIN->selected[i], WIN);
	      WIN->numselected = 0;
	      displaylist(WIN);
	      wm_highlight(WIN, 1);
	      break;
	    case K_ALT_E:
	      if(!WIN->numselected){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
	      for (i = WIN->numselected-1; i >= 0; --i)
		{
		tempstrp= mem_strdup(WIN->Files[WIN->selected[i]].description);
		if (edit_str(&tempstrp, 250,
			     WIN->Files[WIN->selected[i]].fname)){
		  mem_free(WIN->Files[WIN->selected[i]].description);
		  WIN->Files[WIN->selected[i]].description = tempstrp;
		  WIN->changed = 1;
		  DupeOperate(WIN, WIN->selected[i], DUPEEDIT);
		}
		else mem_free(tempstrp);
	      }
	      break;
	    }
	  
	}
	else
	  switch (choice)
	    {
	    case 'e': case 'E':
	      pos = WIN->highlight + WIN->top_display;
	      tempstrp= mem_strdup(WIN->Files[pos].description);
	      if (edit_str(&tempstrp, 250,
			   WIN->Files[pos].fname)){
		mem_free(WIN->Files[pos].description);
		WIN->Files[pos].description = tempstrp;
		WIN->changed = 1;
		DupeOperate(WIN, pos, DUPEEDIT);
	      }
	      else mem_free(tempstrp);
	      break;
	    case 'R': case 'r':
	      if(!WIN->numselected){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
	      if (Ok2Operate(WIN)){
		for (i = WIN->numselected-1; i >= 0; --i)
		  DupeOperate(WIN, WIN->selected[i], DUPEREMOVE);
		WIN->numselected = 0;
		if (WIN->numfiles){
		  displaylist(WIN);
		  if (WIN->highlight>max_vis_file(WIN))
		    WIN->highlight = max_vis_file(WIN);
		  wm_highlight(WIN, 1);
		}
	      }
	      break;
	    case 'D': case 'd':
	      if(!WIN->numselected){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
	      if (Ok2Operate(WIN)){
		for (i = WIN->numselected-1; i >= 0; --i)
		  DupeOperate(WIN, WIN->selected[i], DUPEDELETE);
		WIN->numselected = 0;
		if (WIN->numfiles){
		  displaylist(WIN);
		  if (WIN->highlight>max_vis_file(WIN))
		    WIN->highlight = max_vis_file(WIN);
		  wm_highlight(WIN, 1);
		}
	      }
	      break;
	    case 'C': case 'c':
	      contents(WIN->top_display+WIN->highlight,WIN);
	    break;
	    case 'V': case 'v':
	      verify(WIN->highlight + WIN->top_display, WIN);
	      break;
	    case ' ':
	      pos = WIN->top_display + WIN->highlight;
	      if (!is_selected(WIN, pos))
		{
		  for(i=0;(i<WIN->numselected) && (WIN->selected[i]<pos); ++i);
		  ++WIN->numselected;
		  for (j=i; j < WIN->numselected; ++j)
		    {
		      temp_pos = WIN->selected[j];
		      WIN->selected[j] = pos;
		      pos = temp_pos;
		    }
		  wm_putc_at(WIN->Handle, 0,
			     WIN->FileStart[WIN->highlight], '*');
		}
	      else
		{
		  for(i = 0; (i < WIN->numselected) &&
		      (WIN->selected[i] < pos); ++i);
		  --WIN->numselected;
		  for (j = i; j <WIN->numselected; ++j)
		    WIN->selected[j] = WIN->selected[j+1];
		  wm_putc_at(WIN->Handle, 0,
			     WIN->FileStart[WIN->highlight], ' ');
		}
	      wm_highlight(WIN, 0);
	      scroll_up(WIN);
	      wm_highlight(WIN, 1);
	      break;
	    case 'z': case 'Z':
	      WIN->size = !(WIN->size);
	      displaylist(WIN);
	      if (WIN->highlight >= max_vis_file(WIN))
		WIN->highlight = max_vis_file(WIN);
	      wm_highlight(WIN, 1);
	      break;
	    case 'W':
	    case 'w':
	      WIN->wrap = !(WIN->wrap);
	      displaylist(WIN);
	      if ((WIN->highlight) > max_vis_file(WIN))
		WIN->highlight = 0;
	      wm_highlight(WIN, 1);
	      break;
	    case 't':
	    case 'T':
	      WIN->date = !(WIN->date);
	      displaylist(WIN);
	      if (WIN->highlight >= max_vis_file(WIN))
		WIN->highlight = max_vis_file(WIN);
	      wm_highlight(WIN, 1);
	      break;
	    }
      }
    }
  wm_close(WIN->Handle);
}






struct Window * find_dupes(int numareas, int commandline)
{
  struct stat finfo;
  int * areas = mem_malloc(numareas*sizeof(int));
  int i, j;
  int k, area2;
  int presarea = windowlist[top(zorder)].area;
  int numsearches;
  int numselected;
  static struct Window tmpwin;
  struct Window * WIN = &tmpwin;
  static struct Window tmpwin1;
  struct Window * WIN1 = &tmpwin1;
  struct FileInfo * FileList;
  char fnamepres[80];
  char * FPres;
  wm_handle status;
  char ** fnames;
  char * comparisons;
  char junk[20];

  int DupeSameArea;
  int ReallocAmount;
  
  
  numsearches = (OSDupeSearch) ? numareas : 1;
  
  
  WIN->Handle = wm_create(0,1,MaxX,MaxY,
			  1,BW_NORMAL|INTENSITY,DescColour|B_BLACK|INTENSITY);
  WIN1->Handle = wm_create(0,1,MaxX,MaxY,
			   1,BW_NORMAL|INTENSITY,DescColour|B_BLACK|INTENSITY);
  status = wm_create(MidX-9,MidY,MidX+9,MidY,
		     2,BW_NORMAL|INTENSITY,BW_NORMAL|INTENSITY);
  wm_dimen(WIN->Handle, &WIN->width, &WIN->depth);
  if (!commandline) wm_top(status);
  
  if (!commandline) wm_open(status);
  
  for (area2=0; area2 < numsearches; ++area2){
    areas = mem_realloc(areas, numareas*sizeof(int));
    WIN->top_display = 0;
    WIN->num_free = 0;
    WIN->numselected = 0;
    WIN->highlight = 0;
    WIN->numfiles = 0;
    WIN->selected = NULL;
    WIN->Files = NULL;
    WIN->width = 79;
    WIN1->top_display = 0;
    WIN1->numselected = 0;
    WIN1->highlight = 0;
    WIN1->numfiles = 0;
    WIN1->selected = NULL;
    WIN1->Files = NULL;
    WIN1->width = 79;

    if (!(commandline || OSDupeSearch)) select_area(numareas, 0, areas, 1);
    else if (commandline) for (i=0; i < numareas; areas[i++] = 1);
    else {
      for (i=0; i < numareas; areas[i++] = 0);
      areas[presarea] = 1;
      if ((area2 == presarea) && (area2 < numareas-1)) ++ area2;
      areas[area2] = 1;
    }
    
    if (areas[0] == -1){
      mem_free(areas);
      wm_delete(status);
      wm_delete(WIN->Handle);
      wm_delete(WIN1->Handle);
      mem_free(areas);
      wm_close(status);
      return NULL;
    }
    j = 0;
    for (i=0; i < numareas; ++i) if (areas[i]) areas[j++] = i;
    numselected = j;
    if (numselected == 0){
      error("You must select at least one area to scan for dupes");
      mem_free(areas);
      wm_close(status);
      wm_delete(status);
      wm_delete(WIN->Handle);
      wm_delete(WIN1->Handle);
      wm_close(status);
      mem_free(areas);
    return NULL;}
    
    
    if (!(commandline || OSDupeSearch))
      if (numareas > 1) wm_puts_at(status, 0, 0, " Reading area");
      else wm_puts_at(status, 0, 0, "Reading File List");
    else if (commandline) printf("Reading File List(s)\n");
    else {
      sprintf(fnamepres, "area %s", fileareas[area2].Area);
      fnamepres[15] = 0;
      wm_puts_at(status, 0, 0, fnamepres);
    }
    
    
    ReallocAmount = 0;
    for (i=0; i < numselected; ++i){
      sprintf(junk,"%d",i);
      wm_puts_at(status, 14, 0, junk);
      ReadFileList(areas[i], WIN1, 0);
      if (commandline) printf(".");
      
      if (WIN->num_free < WIN1->numfiles)
	{
	  ReallocAmount = max(WIN->numfiles, ReallocAmount);
	  while (ReallocAmount < WIN1->numfiles + WIN->numfiles)
	    ReallocAmount = max(2*ReallocAmount, 5000);
	  WIN->Files =
	    mem_realloc(WIN->Files,(ReallocAmount + 1) *
			sizeof(struct FileInfo));

	  WIN->num_free = ReallocAmount-WIN->numfiles - WIN1->numfiles - 2;
	}
      else WIN->num_free -= WIN1->numfiles;
      
      for (k=0; k < WIN1->numfiles; ++k)
	{
	  DuplicateFileInfo(&WIN->Files[WIN->numfiles+k], &WIN1->Files[k]);
	  WIN->Files[WIN->numfiles+k].wildcard = 0;
	}
      WIN->numfiles+= WIN1->numfiles;
      WIN->selected =
	mem_realloc(WIN->selected, (WIN->numfiles + 20)*sizeof(int));
    }
    if (commandline) printf("\n");
    free_window(WIN1);
    
    
    for (i=0; i < WIN->numfiles; ++i)
      WIN->selected[i] = 0;

    FileList = mem_malloc((WIN->numfiles + 2)*sizeof(struct FileInfo));
    
    for(i = 0; i < WIN->numfiles; ++i)
      DuplicateFileInfo(&FileList[i], &WIN->Files[i]);
    

    wm_clear(status);
    if (!(commandline || OSDupeSearch)) wm_puts_at(status, 3, 0, "Sorting Files");
    else if (commandline) printf("Sorting Files\n");
    
    QuickSort(FileList, WIN->numfiles, 3);


    for(i = 0; i < WIN->numfiles; ++i){
      mem_free(WIN->Files[i].description);
      CopyFileInfo(&WIN->Files[i], &FileList[i]);
    }
    


    mem_free(FileList);
    
    wm_clear(status);
    if (!(commandline || OSDupeSearch)) wm_puts_at(status, 1, 0, "Identifying Dupes");
    else if (commandline) printf("Identifying Dupes\n");
    
    fnames = (char **) mem_malloc(WIN->numfiles*sizeof(char *));
    comparisons = (char *) mem_malloc(WIN->numfiles*sizeof(char));
    for(i=0; i < WIN->numfiles; ++i)
      {
	strcpy(fnamepres, WIN->Files[i].fname);
	FPres = mygetname(strtok(fnamepres, " "));
	if (DupIgnoreExt) _remext(FPres);
	fnames[i] = mem_strdup(FPres);
      }
    for(i=0; i < WIN->numfiles; WIN->selected[i++] = 0);
    
    for(i=0; i < WIN->numfiles-1; ++i)
      comparisons[i] = stricmp(fnames[i], fnames[i+1]);
    
    for(i=0; i < WIN->numfiles-2; ++i)
      WIN->selected[i+1] = (comparisons[i] && comparisons[i+1]);
    
    for(i=0; i < WIN->numfiles-1; ++i)
      if (!WIN->selected[i]) WIN->selected[i] = IsComment(fnames[i]);
    
    if (WIN->numfiles > 1){
      WIN->selected[0] =
	(stricmp(fnames[0], fnames[1]) || IsComment(fnames[0]));
      WIN->selected[WIN->numfiles-1] =
	(stricmp(fnames[WIN->numfiles-1], fnames[WIN->numfiles-2]) ||
	 IsComment(fnames[WIN->numfiles-1]));
    }
    else if (WIN->numfiles) WIN->selected[0] = 1;
    
    for(i=0; i < WIN->numfiles; ++i) mem_free(fnames[i]);
    mem_free(fnames);
    mem_free(comparisons);
    
    j = 0;
    for (i = 0; i < WIN->numfiles; ++i)
      {
	if ((!WIN->selected[i]) && (i != j))
	  {
	    mem_free(WIN->Files[j].description);
	    DuplicateFileInfo(&(WIN->Files[j]), &(WIN->Files[i]));
	    ++j;
	  }
	else if ((!WIN->selected[i]) && (i == j)) ++j;
      }
    
    for (i = j; i < WIN->numfiles; ++i)
      mem_free(WIN->Files[i].description);
    WIN->numfiles = j;
    
    
    
    /* now look for duplicates that occur in the same file area */
    
    if (DISameArea){
      fnames = (char **) mem_malloc(WIN->numfiles*sizeof(char *));
      for(i=0; i < WIN->numfiles; ++i)
	{
	  strcpy(fnamepres, WIN->Files[i].fname);
	  FPres = mygetname(strtok(fnamepres, " "));
	  if (DupIgnoreExt) _remext(FPres);
	  fnames[i] = mem_strdup(FPres);
	}
      for(i=0; i < WIN->numfiles; WIN->selected[i++] = 0);
      
    i = 0;
      while (i < WIN->numfiles){
	DupeSameArea = 0;
	for (j = i+1; (j < WIN->numfiles) && (!stricmp(fnames[i], fnames[j])); ++j)
	  DupeSameArea += (WIN->Files[i].area == WIN->Files[j].area);
	if (DupeSameArea)
	  for (j=i; ((j < WIN->numfiles) && !stricmp(fnames[i], fnames[j])); ++j)
	    WIN->selected[j] = 1;
	i = j;
      }
      
      for(i=0; i < WIN->numfiles; ++i) mem_free(fnames[i]);
      mem_free(fnames);
      for (i = WIN->numfiles-1; i >= 0; --i)
	if (WIN->selected[i]) delete_listing(WIN, i);
    }
    
    WIN->Files = 
      mem_realloc(WIN->Files, (WIN->numfiles + 20)*sizeof(struct FileInfo));
    WIN->selected = mem_realloc(WIN->selected, (WIN->numfiles + 20)*sizeof(int));
    
    if (!(commandline || OSDupeSearch)) wm_puts_at(status, 1, 0, "Getting File Info");
    else if (commandline) printf("gettting file info\n");
    for(i=0; i < WIN->numfiles; ++i)
      {
	if (!_fnisabs(WIN->Files[i].fname))
	  {
	    strcpy(fnamepres, WIN->Files[i].fname);
	    sprintf(WIN->Files[i].fname, "%s\\%s", 
		    fileareas[WIN->Files[i].area].Download, fnamepres);
	    strcpy(fnamepres, WIN->Files[i].fname);
	  }
	
	if (!stat(fnamepres, &finfo)){
	  strcpy(junk, "");
	  t_date2str(finfo.st_ctime, WIN->Files[i].date);
	  size2str(WIN->Files[i].fsize, finfo.st_size);
	  WIN->Files[i].read_only = ((finfo.st_attr & 1) != 0);
	}
	else{
	  strcpy(WIN->Files[i].fsize,"       ");
	  strcpy(WIN->Files[i].date,"OFFLINE ");
	  WIN->Files[i].read_only = OFFLINE;
	}
      }
    
    if (commandline){
      wm_delete(status);
      wm_delete(WIN->Handle);
      wm_delete(WIN1->Handle);
      return WIN;
    }
    if (WIN->numfiles){
      wm_close(status);
      DupeEdit(WIN);
      wm_open(status);
    }
  free_window(WIN);
  }
  wm_close(status);
  wm_delete(status);
  wm_close(WIN->Handle);
  wm_delete(WIN->Handle);
  wm_delete(WIN1->Handle);
  mem_free(areas);
  return NULL;
}












void locate(int numareas, struct Window * WIN)
{
  wm_handle String= wm_create(MidX-10, MidY, MidX+10, MidY, 2,
			      F_RED|B_BLACK|INTENSITY,
			      F_YELLOW|B_BLACK|INTENSITY);
  wm_handle Searching= wm_create(MidX-20, MidY-1, MidX+20, MidY, 2,
				 F_RED|B_BLACK|INTENSITY,
				 F_YELLOW|B_BLACK|INTENSITY);
  int TO;
  int j;
  int area;
  char choice = 1;
  char ABORT = 0;
  char character = 'x';
  char tempstr[21];
  char *tempstrp;
  int found = 0;
  int pos;
  int startarea = WIN->area;
  int oldtopdisplay = WIN->top_display;
  int oldhighlight = WIN->highlight;

  wm_open(String);
  wm_top(String);
  wm_cursor(String);
  wm_cvis(String,1);
  wm_border(String, 1, F_RED|B_BLACK|INTENSITY, "String???",
	    1, F_YELLOW|B_BLACK|INTENSITY);
  mygets(String, tempstr, 0, 0, 20);
  strupr(tempstr);
  wm_close(String);
  wm_delete(String);


  if (strlen(tempstr)){
    WIN->numselected = 0;
    for(area = 0; (area < numareas) && (!ABORT); ++area){
      savewin(WIN, 0);
      ReadFileList(area, WIN, 0);
      character = _read_kbd(0,0,0);
      wm_open(Searching);
      wm_top(Searching);
      wm_border(Searching, 1, F_RED|B_BLACK|INTENSITY,"Press 'a' to abort",
		1, F_YELLOW|B_BLACK|INTENSITY);
      wm_puts_at(Searching, 12, 0, "Searching area");
      wm_clr_eol(Searching, 12,1);
      wm_puts_at(Searching, 12, 1, fileareas[area].Area);
      if ((character == 'a') || (character == 'A'))
	{
	  area = numareas;
	  ABORT = 1;
	}
      else if (character == 0) if (_read_kbd(0,1,0) == K_F1) HELP(SearchHelp);
      
      for (j=0; (j < WIN->numfiles) && (!ABORT); ++j){
	found = 0;
	if (strstr(strupr(WIN->Files[j].fname), tempstr)) found = 1;
	else if (strstr(strupr(WIN->Files[j].description), tempstr)) found = 1;
	
	if (found){
	  wm_close(Searching);
	  if (WIN->changed) savewin(WIN, 1);
	  ReadFileList(area, WIN, 1);
	  WIN->top_display = j;
	  WIN->highlight = 0;
	  displaylist(WIN);
	  wm_highlight(WIN, 1);
	  choice = 1;}
	while ((choice != ESCAPE) && (found) && (!ABORT)){
	  choice = _read_kbd(0,1,0);
	  if (choice)
	    switch (choice)
	      {
	      case 'm': case 'M':
		select_area(numareas, WIN->area, &TO, 0);
		if (TO >= 0){
		  choice = ESCAPE;
		  if (!move(WIN,TO, WIN->top_display))
		    delete_listing(WIN, WIN->top_display);
		  WIN->changed = 1;
		  displaylist(WIN);
		  wm_highlight(WIN, 1);
		}
		break;
		
	      case 'c': case 'C':
		contents(WIN->top_display,WIN);
		break;
	      case 'd': case 'D':
		pos = WIN->top_display;
		del(WIN, pos);
		delete_listing(WIN, pos);
		WIN->changed = 1;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		choice = ESCAPE;
		break;
	      case 'r': case 'R':
		delete_listing(WIN, WIN->top_display);
		WIN->changed = 1;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		choice = ESCAPE;
		break;
	      case 'a': case 'A':
		ABORT = 1;
		break;
	      case 'e': case 'E':
		tempstrp = mem_strdup(WIN->Files[WIN->top_display].description);
		if (edit_str(&tempstrp, 250,
			     WIN->Files[WIN->top_display].fname)){
		  mem_free(WIN->Files[WIN->top_display].description);
		  WIN->Files[WIN->top_display].description = tempstrp;
		  WIN->changed = 1;}
		else mem_free(tempstrp);
		displaylist(WIN);
		wm_highlight(WIN, 1);
		
		break;
	      }
	  else{
	    choice = _read_kbd(0,1,0);
	    switch (choice)
	      {
	      case K_ALT_C:
		contents(WIN->top_display,WIN);
		break;
	      case K_ALT_D:
	      pos = WIN->top_display;
		del(WIN, pos);
		delete_listing(WIN, pos);
		WIN->changed = 1;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		choice = ESCAPE;
		break;
	      case K_ALT_R:
		delete_listing(WIN, WIN->top_display);
	      WIN->changed = 1;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		choice = ESCAPE;
		break;
	      case K_F1:
		HELP(SearchHelp);
		break;
	      }
	  }
	}
      }
    };
    if (!found){
      ReadFileList(startarea, WIN, 1);
      WIN->highlight = oldhighlight;
      WIN->top_display = oldtopdisplay;
      displaylist(WIN);
      wm_highlight(WIN, 1);
    }
    wm_close(Searching);
    wm_delete(Searching);
    errorT("DONE!!",250);
  }
}






int file_highlight(int pos)
{
  int retval = 0;

  switch (pos)
    {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 7:
    case 10:
    case 11:
    case 12:
    case 15:
      retval = 0; break;
    case 16:
    case 18:
      retval = 1; break;
    case 17:
      retval = 2; break;
    case 8:
    case 9:
    case 6:
    case 13:
      retval = 3; break;
    case 14:
      retval = 10; break;
    }
  return retval;
}



int ren(struct Window * WIN, int position, char * oldfname)
{
  char newfname[CCHMAXPATH];
  char fname[_MAX_FNAME], ext[_MAX_EXT];
  char drive[_MAX_DRIVE], dir[_MAX_DIR];
  char rc = -1;
  char temp[_MAX_FNAME];
  int retval = 0;
  struct stat finfo;


  _splitpath(oldfname, drive, dir, fname, ext);

  strcpy(temp, fname);
  strcat(temp, ext);
  while (rc){
    sprintf(newfname,"%s%s", drive, dir);
    if (strlen(getfname(temp))){
      sprintf(newfname,"%s%s%s", drive, dir, temp);
      if ((rc = rename(oldfname, newfname)) && !WIN->Files[position].read_only)
	{
	  error("Sorry, I cannot rename the file to that name");
	  strcpy(temp, fname);
	  strcat(temp, ext);
	}
      else{
	rc = 0;
	retval = 1;
	if (_fnisabs(WIN->Files[position].fname))
	  strcpy(WIN->Files[position].fname, newfname);
	else strcpy(WIN->Files[position].fname, temp);

	while (strlen(mygetname(WIN->Files[position].fname)) < 13) 
	  strcat(WIN->Files[position].fname, " ");


	if (!stat(newfname, &finfo)){
	  WIN->Files[position].date[0] = 0;
	  WIN->Files[position].fsize[0] = 0;
	  t_date2str(finfo.st_ctime, WIN->Files[position].date);
	  size2str(WIN->Files[position].fsize, finfo.st_size);
	  WIN->Files[position].read_only = ((finfo.st_attr & 1) != 0);
	}
      }
    }
    else{
      rc = 0;
      error("rename aborted");}
  }
  return retval;
}


int file_menu(int numareas)
{
  int top_window = top(zorder);
  struct Window * WIN = &windowlist[top_window];
  int choice = 0;
  wm_handle FileMenu;
  int selection = 0;
  int maxselections = 18;
  int width, height;
  int i, j, k;
  int TO;
  int position;
  int pos;
  char tempdir[200];
  struct threadinfo * ThreadFiles;
  int ThreadID;
  int noselection;
  char fname[CCHMAXPATH];
  int offset;
  char NoneSelected = WIN->numselected;

  /* selections:
     0) Move
     1) Contents
     2) Verify
     3) Rearchive
     4) Adopt orphans
     5) Delete
     6) vieW
     7) Touch file
     8) Scan for Virii
     9) Mark all
     10)Unmark all
     11)Save
     12)Insert
     13)re-pOsition
     14)dupe searcH
     15)Locate
     15)rEname
     16)Import
     17)eXit
     */

  FileMenu = wm_create(1,2,14,maxselections+2,
		       2,F_BLACK|B_WHITE,F_BLACK|B_WHITE);
  wm_dimen(FileMenu, &width, &height);
  wm_puts_at(FileMenu, 0, 0, "Move");
  wm_puta_at(FileMenu, 0, 0, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 1, "Contents");
  wm_puta_at(FileMenu, 0, 1, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 2, "Verify");
  wm_puta_at(FileMenu, 0, 2, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 3, "Re-Archive");
  wm_puta_at(FileMenu, 0, 3, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 4, "Adopt Orphans");
  wm_puta_at(FileMenu, 0, 4, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 5, "Delete");
  wm_puta_at(FileMenu, 0, 5, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 6, "vieW");
  wm_puta_at(FileMenu, 3, 6, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 7, "Touch File");
  wm_puta_at(FileMenu, 0, 7, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 8, "scaN for Virii");
  wm_puta_at(FileMenu, 3, 8, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 9, "marK all");
  wm_puta_at(FileMenu, 3, 9, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 10, "Unmark all");
  wm_puta_at(FileMenu, 0, 10, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 11, "Save");
  wm_puta_at(FileMenu, 0, 11, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 12, "Insert");
  wm_puta_at(FileMenu, 0, 12, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 13, "repOsition");
  wm_puta_at(FileMenu, 3, 13, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 14, "dupe searcH");
  wm_puta_at(FileMenu, 10,14, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 15, "Locate");
  wm_puta_at(FileMenu, 0, 15, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 16, "rEname");
  wm_puta_at(FileMenu, 1, 16, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 17, "imPort file");
  wm_puta_at(FileMenu, 2, 17, F_RED|B_WHITE, 1);
  wm_puts_at(FileMenu, 0, 18, "eXit");
  wm_puta_at(FileMenu, 1, 18, F_RED|B_WHITE, 1);
  wm_open(FileMenu);
  wm_top(FileMenu);
  wm_puts_at(main_window,1,0,"File");
  wm_puta_at(main_window, 1, 0, F_WHITE|B_BLACK|INTENSITY, 4);
  wm_puta_at(main_window, 1, 0, F_RED|B_BLACK|INTENSITY, 1);

  wm_puta_at(FileMenu, 0, 0, F_WHITE|INTENSITY|B_BLACK, width);
  wm_puta_at(FileMenu, 0, 0, F_RED|B_BLACK|INTENSITY, 1);

  while ((choice != ENTER) && (choice != ESCAPE))
    {
       choice = _read_kbd(0,1,1);
      if (isalpha(choice) || (choice == ENTER))
	{
	  noselection = 1;
	  switch(toupper(choice)){
	  case 'M': selection = 0; break;
	  case 'C': selection = 1; break;
	  case 'V': selection = 2; break;
	  case 'R': selection = 3; break;
	  case 'A': selection = 4; break;
	  case 'D': selection = 5; break;
	  case 'W': selection = 6; break;
	  case 'T': selection = 7; break;
	  case 'N': selection = 8; break;
	  case 'K': selection = 9; break;
	  case 'U': selection = 10; break;
	  case 'S': selection = 11; break;
	  case 'I': selection = 12; break;
	  case 'O': selection = 13; break;
	  case 'H': selection = 14; break;
	  case 'L': selection = 15; break;
	  case 'E': selection = 16; break;
	  case 'P': selection = 17; break;
	  case 'X': selection = 18; break;
	  case ENTER: break;
	  default: noselection = 0;
	  }
	  if (noselection){
	    wm_close(FileMenu);
	    wm_delete(FileMenu);
	    if(!WIN->numselected){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    if ((!WIN->numfiles) &&
		(selection != 4) &&
		(selection != 11) && 
		(selection != 15) && 
		(selection != 16))
	      {wm_close(FileMenu);
	       wm_delete(FileMenu);
	       wm_puts_at(main_window,1,0,"File");
	       wm_puta_at(main_window, 1, 0, F_BLACK|B_WHITE, 4);
	       wm_puta_at(main_window, 1, 0, F_RED|B_WHITE, 1);
	       if (!NoneSelected) WIN->numselected = 0;
	       return 0;}
	    switch (selection)
	      {
	      case 0:
		if (Ok2Operate(WIN)){
		  select_area(numareas, WIN->area, &TO, 0);
		  if (TO >= 0)
		    for (i = 0; i < WIN->numselected; ++i)
		      if (!move(WIN,TO, WIN->selected[i])){
			delete_listing(WIN, WIN->selected[i]);
			for (j=0; j< WIN->numselected; ++j) --WIN->selected[j];
		      }
		  WIN->numselected = 0;
		  WIN->changed = 1;
		  if (WIN->highlight < 0) WIN->highlight = 0;
		  displaylist(WIN);
		  while ((WIN->highlight>max_vis_file(WIN)) && WIN->highlight)
		    --WIN->highlight;
		  wm_highlight(WIN, 1);
		}
		break;
	      case 1:
		for (i = 0; i < WIN->numselected; ++i)
		  contents(WIN->selected[i],WIN);
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 2:
		for (i = 0; i < WIN->numselected; ++i)
		  verify(WIN->selected[i], WIN);
		WIN->numselected = 0;
		wm_highlight(WIN, 1);
		break;
	      case 3:
		ThreadFiles = mem_malloc(sizeof(struct threadinfo));
		ThreadFiles->new_type =
		  get_a_type(ThreadFiles->newextension);
		if (ThreadFiles->new_type)
		  {
		    for (k=0; k < WIN->numselected;  ++k)
		      strcpy(ThreadFiles->namelist[k],
			     WIN->Files[WIN->selected[k]].fname);
		    ThreadFiles->WIN = WIN;
		    strcpy(ThreadFiles->path, fileareas[WIN->area].Download);
		    ThreadFiles->numfiles = WIN->numselected;
		    WIN->lock = 1;
		    if (_osmode != DOS_MODE)
		      ThreadID = _beginthread(re_archive, NULL, 16384,
					      (void *) ThreadFiles);
		    else re_archive (ThreadFiles);
		    if (_osmode != DOS_MODE){
		      if (Priority == 1)
			DosSetPriority(2, 1, 1, ThreadID);
		      else
			DosSetPriority(2, 2, 0, ThreadID);
		    }
		    WIN->numselected = 0;
		    displaylist(WIN);
		    wm_highlight(WIN, 1);
		    WIN->changed = 1;
		    WIN->numselected = 0;
		  }
		break;
	      case 4:
		if(savewin(WIN, 1))
		  if (adopt_files(WIN, 0, 0))
		    {
		      WIN->numselected = 0;
		      WIN->changed = 1;
		      displaylist(WIN);
		      wm_highlight(WIN, 1);
		    }
		break;
	      case 5:
		if (Ok2Operate(WIN)){
		  WIN->changed = 1;
		  for (i = WIN->numselected-1; i >= 0; --i){
		    del(WIN, WIN->selected[i]);
		    delete_listing(WIN, WIN->selected[i]);
		  }
		  WIN->numselected = 0;
		  displaylist(WIN);
		  wm_highlight(WIN, 1);
		}
		break;
	      case 6:
		ThreadFiles = mem_malloc(sizeof(struct threadinfo));
		for (k=0; k < WIN->numselected;  ++k)
		  strcpy(ThreadFiles->namelist[k],
			 WIN->Files[WIN->selected[k]].fname);
		strcpy(ThreadFiles->path, fileareas[WIN->area].Download);
		ThreadFiles->numfiles = WIN->numselected;
		if (_osmode != DOS_MODE)
		  _beginthread(pic_view, NULL, 16384, (void *) ThreadFiles);
		else pic_view(ThreadFiles);
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 7:
		for (i = 0; i < WIN->numselected; ++i)
		  touch_pos(WIN, WIN->selected[i]);
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 8:
		for (i = 0; i < WIN->numselected; ++i){
		  if(!extract(WIN->Files[WIN->selected[i]].fname,tempdir))
		    Virii_Check(tempdir,
				WIN->Files[WIN->selected[i]].fname);
		  else error2("Could not un-archive",
			      WIN->Files[WIN->selected[i]].fname);}
		WIN->numselected = 0;
	      break;
	      case 9:
		for (i=0; i<WIN->numfiles; ++i) WIN->selected[i] = i;
		WIN->numselected = WIN->numfiles;
		displaylist(WIN);		
		wm_highlight(WIN, 1);
		break;
	      case 10:
		WIN->numselected = 0;
		displaylist(WIN);		
		wm_highlight(WIN, 1);
		break;
	      case 11:
		write_filesbbs(WIN, 0);
		WIN->changed = 0;
		break;
	      case 12:
		strcpy(tempdir,"");
		insert_new(WIN, WIN->top_display + WIN->highlight, tempdir);
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 13:
		pos =WIN->highlight+WIN->top_display;
		if (is_selected(WIN, pos))
		  error2("You cannot insert before a selected file.  Please",
			 "deselect the file or choose another position");
		else{
		  for(i=0; (i < WIN->numselected) &&
		      (WIN->selected[i]<=pos);++i);
		  position = i;
		  for(i=0; i<position; ++i)
		    insert(WIN, WIN->selected[i]-i, pos);
		  offset = 0;
		  for(i=WIN->numselected-1; i >= position; --i)
		    {
		    insert(WIN, WIN->selected[i]+offset, pos);
		    ++offset;
		  WIN->changed = 1;
		  WIN->numselected = 0;
		  displaylist(WIN);
		  }
		  wm_highlight(WIN, 1);
		}
		break;
	      case 14:
		wm_puts_at(main_window,1,0,"File");
		wm_puta_at(main_window, 1, 0, F_BLACK|B_WHITE, 4);
		wm_puta_at(main_window, 1, 0, F_RED|B_WHITE, 1);
		find_dupes(numareas, 0);
		break;
	      case 15:
		locate(numareas, WIN);
		break;
	      case 16:
		if(!WIN->numselected){
		  WIN->selected[0] = WIN->top_display + WIN->highlight;
		  WIN->numselected = 1;}
		for (i=0; i < WIN->numselected; ++i){
		  if (_fnisrel(WIN->Files[WIN->selected[i]].fname))
		    sprintf(fname, "%s\\%s",fileareas[WIN->area].Download,
			    WIN->Files[WIN->selected[i]].fname);
		  else
		    strcpy(fname,WIN->Files[WIN->selected[i]].fname); 
		  if (ren(WIN, WIN->selected[i], fname))
		    WIN->changed = 1;}
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		break;

	      case 17:
		adopt_files(WIN, 0, 1);
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 18:
		savewin(&windowlist[1], 1);
		savewin(&windowlist[2], 1);
		wm_close_all();
		free_mem();
		free_window(&windowlist[1]);
		free_window(&windowlist[2]);
		v_gotoxy(xpos, ypos);
		v_ctype(cstart, cend);
		run_fbp(numareas);
		exit(0);
	      }
	    choice = ENTER;
	  }
	}
      else if (!choice){
	choice = _read_kbd(0,1,1);
	switch (choice)
	  {
	  case K_F1:
	    HELP(FileHelp);
	    break;
	  case K_UP:
	    if (selection > 0)
	      {
		wm_puta_at(FileMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(FileMenu, file_highlight(selection),
			   selection, F_RED|B_WHITE, 1);
		--selection;
		wm_puta_at(FileMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(FileMenu, file_highlight(selection), selection,
			   F_RED|B_BLACK|INTENSITY, 1);
	      }
	    else
	      {
		wm_puta_at(FileMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(FileMenu, file_highlight(selection),
			   selection, F_RED|B_WHITE, 1);
		selection = maxselections;
		wm_puta_at(FileMenu, 0, selection, F_WHITE|INTENSITY|B_BLACK, width);
		wm_puta_at(FileMenu, file_highlight(selection), selection,
			   F_RED|B_BLACK|INTENSITY, 1);
	      }
	    break;
	  case K_DOWN:
	    if (selection < maxselections)
	      {
		wm_puta_at(FileMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(FileMenu, file_highlight(selection),
			   selection, F_RED|B_WHITE, 1);
		++selection;
		wm_puta_at(FileMenu, 0, selection, F_WHITE|INTENSITY|B_BLACK, width);
		wm_puta_at(FileMenu, file_highlight(selection), selection,
			   F_RED|B_BLACK|INTENSITY, 1);
	      }
	    else
	      {
		wm_puta_at(FileMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(FileMenu, file_highlight(selection),
			   selection, F_RED|B_WHITE, 1);
		selection = 0;
		wm_puta_at(FileMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(FileMenu, file_highlight(selection), selection,
			   F_RED|B_BLACK|INTENSITY, 1);
	      }
	    break;
	  case K_PAGEUP:
	    wm_puta_at(FileMenu, 0, selection, F_BLACK|B_WHITE, width);
	    wm_puta_at(FileMenu, file_highlight(selection),
		       selection, F_RED|B_WHITE, 1);
	    selection = 0;
	    wm_puta_at(FileMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
	    wm_puta_at(FileMenu, file_highlight(selection),
		       selection, F_RED|B_BLACK|INTENSITY, 1);
	    break;
	  case K_PAGEDOWN:
	    wm_puta_at(FileMenu, 0, selection, F_BLACK|B_WHITE, width);
	    wm_puta_at(FileMenu, file_highlight(selection),
		       selection, F_RED|B_WHITE, 1);
	    selection = maxselections;
	    wm_puta_at(FileMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
	    wm_puta_at(FileMenu, file_highlight(selection),
		       selection, F_RED|B_BLACK|INTENSITY, 1);
	    break;
	  case K_RIGHT:
	  case K_LEFT:
	    wm_close(FileMenu);
	    wm_delete(FileMenu);
	    wm_puts_at(main_window,1,0,"File");
	    wm_puta_at(main_window, 1, 0, F_BLACK|B_WHITE, 4);
	    wm_puta_at(main_window, 1, 0, F_RED|B_WHITE, 1);
	    if (!NoneSelected) WIN->numselected = 0;
	    return choice;
	  }
      }
    }
  if (choice == ESCAPE)
    {
      wm_close(FileMenu);
      wm_delete(FileMenu);
    }
  wm_puts_at(main_window,1,0,"File");
  wm_puta_at(main_window, 1, 0, F_BLACK|B_WHITE, 4);
  wm_puta_at(main_window, 1, 0, F_RED|B_WHITE, 1);
  if (!NoneSelected) WIN->numselected = 0;
  return 0;
}


int description_menu()
{
  char *tempstrp;
  char * tempstrptr;
  struct Window * WIN = &windowlist[top(zorder)];
  char NoneSelected = WIN->numselected;
  int choice = 0;
  int selection = 0;
  wm_handle DMenu;
  int maxselections = 4;
  int width, height;
  int i;
  int noselection;

  /* selections:
     0) Remove
     1) Edit
     2) New
     3) Use FILE_ID
     4) Insert comment
     */


  if (!WIN->numfiles) return 0;

  DMenu = wm_create(18,2,31,maxselections+2,
		    2,F_BLACK|B_WHITE,F_BLACK|B_WHITE);
  wm_dimen(DMenu, &width, &height);
  wm_puts_at(DMenu, 0, 0, "Remove");
  wm_puta_at(DMenu, 0, 0, F_RED|B_WHITE, 1);
  wm_puts_at(DMenu, 0, 1, "Edit");
  wm_puta_at(DMenu, 0, 1, F_RED|B_WHITE, 1);
  wm_puts_at(DMenu, 0, 2, "New");
  wm_puta_at(DMenu, 0, 2, F_RED|B_WHITE, 1);
  wm_puts_at(DMenu, 0, 3, "Use FILE_ID");
  wm_puta_at(DMenu, 0, 3, F_RED|B_WHITE, 1);
  wm_puts_at(DMenu, 0, 4, "Insert Comment");
  wm_puta_at(DMenu, 0, 4, F_RED|B_WHITE, 1);
  wm_open(DMenu);
  wm_top(DMenu);

  wm_puts_at(main_window, 18,0,"Description");
  wm_puta_at(main_window, 18, 0, F_WHITE|B_BLACK|INTENSITY, 11);
  wm_puta_at(main_window, 18, 0, F_RED|B_BLACK|INTENSITY, 1);
  wm_puta_at(DMenu, 0, 0, F_WHITE|B_BLACK|INTENSITY, width);
  wm_puta_at(DMenu, 0, 0, F_RED|B_BLACK|INTENSITY, 1);

  while ((choice != ENTER) && (choice != ESCAPE))
    {
      choice = _read_kbd(0,1,1);
      if (isalpha(choice) || (choice == ENTER)){
	{
	  noselection = 1;
	  if ((choice == 'R') || (choice == 'r')) selection = 0;
	  else if (toupper(choice) == 'E') selection = 1;
	  else if (toupper(choice) == 'N') selection = 2;
	  else if (toupper(choice) == 'U') selection = 3;
	  else if (toupper(choice) == 'I') selection = 4;
	  else if (choice == ENTER);
	  else noselection = 0;
	  if (noselection){
	    if(!WIN->numselected){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    wm_close(DMenu);
	    wm_delete(DMenu);
	    switch (selection)
	      {
	      case 0:
		if (Ok2Operate){
		  for (i = WIN->numselected-1; i >= 0; --i)
		    delete_listing(WIN, WIN->selected[i]);
		  WIN->numselected = 0;
		  displaylist(WIN);
		  wm_highlight(WIN, 1);
		  WIN->changed = 1;
		}
		break;
	      case 1:
		for (i = WIN->numselected-1; i >= 0; --i)
		  {
		    tempstrp = mem_strdup(WIN->Files[WIN->selected[i]].description);
		    if (edit_str(&tempstrp, 250,
				 WIN->Files[WIN->selected[i]].fname)){
		      mem_free(WIN->Files[WIN->selected[i]].description);
		      WIN->Files[WIN->selected[i]].description=tempstrp;
		      WIN->changed = 1;}
		    else mem_free(tempstrp);
		  }
		WIN->numselected = 0;
		displaylist(WIN);
		if (WIN->highlight>max_vis_file(WIN))
		  WIN->highlight = max_vis_file(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 2:
		for (i = WIN->numselected-1; i >= 0; --i)
		  {
		    tempstrp = mem_strdup("");
		    if (edit_str(&tempstrp, 250,
				 WIN->Files[WIN->selected[i]].fname)){
		      mem_free(WIN->Files[WIN->selected[i]].description);
		      WIN->Files[WIN->selected[i]].description=tempstrp;
		      WIN->changed = 1;
		    }
		    else mem_free(tempstrp);
		  }
		WIN->numselected = 0;
		displaylist(WIN);
		if (WIN->highlight>max_vis_file(WIN))
		  WIN->highlight = max_vis_file(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 3:
		if(!WIN->numselected){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
		for (i = WIN->numselected-1; i >= 0; --i)
		  {
		    char fname[200] = "";
		    if (_fnisrel(WIN->Files[WIN->selected[i]].fname))
		      {
			strcat(fname, fileareas[WIN->area].Download);
			strcat(fname,"\\");
		      }
		    strcat(fname, WIN->Files[WIN->selected[i]].fname);
		    if (Get_File_id(fname,&tempstrptr, 0, 0,
				    WIN->Files[WIN->selected[i]].description)){
		      mem_free(WIN->Files[WIN->selected[i]].description);
		      WIN->Files[WIN->selected[i]].description = tempstrptr;
		      WIN->changed = 1;}
		  }
		WIN->numselected = 0;
		displaylist(WIN);
		if (WIN->highlight>max_vis_file(WIN))
		  WIN->highlight = max_vis_file(WIN);
		wm_highlight(WIN, 1);
		break;
	      case 4:
		insert_new(WIN, WIN->top_display + WIN->highlight,"COMMENTS");
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
		break;
	      }
	    choice = ENTER;
	  }
	}
      }
      else if (!choice){
	choice = _read_kbd(0,1,1);
	switch (choice)
	  {
	  case K_F1:
	    HELP(DescHelp);
	    break;
	  case K_UP:
	    if (selection > 0)
	      {
		wm_puta_at(DMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_WHITE, 1);
		--selection;
		wm_puta_at(DMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	      }
	    else
	      {
		wm_puta_at(DMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_WHITE, 1);
		selection = maxselections;
		wm_puta_at(DMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	      }
	    break;
	  case K_DOWN:
	    if (selection < maxselections)
	      {
		wm_puta_at(DMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_WHITE, 1);
		++selection;
		wm_puta_at(DMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_BLACK|INTENSITY,1);
	      }
	    else
	      {
		wm_puta_at(DMenu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_WHITE, 1);
		selection = 0;
		wm_puta_at(DMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(DMenu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	      }
	    break;
	  case K_PAGEUP:
	    wm_puta_at(DMenu, 0, selection, F_BLACK|B_WHITE, width);
	    wm_puta_at(DMenu, 0, selection, F_RED|B_WHITE, 1);
	    selection = 0;
	    wm_puta_at(DMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
	    wm_puta_at(DMenu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	    break;
	  case K_PAGEDOWN:
	    wm_puta_at(DMenu, 0, selection, F_BLACK|B_WHITE, width);
	    wm_puta_at(DMenu, 0, selection, F_RED|B_WHITE, 1);
	    selection = maxselections;
	    wm_puta_at(DMenu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
	    wm_puta_at(DMenu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	    break;
	  case K_RIGHT:
	  case K_LEFT:
	    wm_close(DMenu);
	    wm_delete(DMenu);
	    wm_puts_at(main_window, 18,0,"Description");
	    wm_puta_at(main_window, 18, 0, F_BLACK|B_WHITE, 11);
	    wm_puta_at(main_window, 18, 0, F_RED|B_WHITE, 1);
	    if (!NoneSelected) WIN->numselected = 0;
	    return choice;
	  }
      }
    }
  if (choice == ESCAPE){ wm_close(DMenu); wm_delete(DMenu); }
  wm_puts_at(main_window, 18,0,"Description");
  wm_puta_at(main_window, 18, 0, F_BLACK|B_WHITE, 11);
  wm_puta_at(main_window, 18, 0, F_RED|B_WHITE, 1);
  if (!NoneSelected) WIN->numselected = 0;
  return 0;
}


int sort_menu(struct Window *WIN)
{
  int choice = 0;
  wm_handle SrtMnu;
  int selection = 0;
  int maxselections = 5;
  int width, height;
  struct FileInfo * FileList;
  int noselection;
  int NoneSelected = 0;
  int i;

  /* selections:
     0) Name
     1) Date
     2) Size
     3) name
     4) date
     5) size
     */


  if (!WIN->numfiles) return 0;
  SrtMnu = wm_create(12,2,16,maxselections+2,
		     2,F_BLACK|B_WHITE,F_BLACK|B_WHITE);
  wm_dimen(SrtMnu, &width, &height);
  wm_puts_at(SrtMnu, 0, 0, "Name");
  wm_puta_at(SrtMnu, 0, 0, F_RED|B_WHITE, 1);
  wm_puts_at(SrtMnu, 0, 1, "Date");
  wm_puta_at(SrtMnu, 0, 1, F_RED|B_WHITE, 1);
  wm_puts_at(SrtMnu, 0, 2, "Size");
  wm_puta_at(SrtMnu, 0, 2, F_RED|B_WHITE, 1);
  wm_puts_at(SrtMnu, 0, 3, "name");
  wm_puta_at(SrtMnu, 0, 3, F_RED|B_WHITE, 1);
  wm_puts_at(SrtMnu, 0, 4, "date");
  wm_puta_at(SrtMnu, 0, 4, F_RED|B_WHITE, 1);
  wm_puts_at(SrtMnu, 0, 5, "size");
  wm_puta_at(SrtMnu, 0, 5, F_RED|B_WHITE, 1);
  wm_open(SrtMnu);
  wm_top(SrtMnu);

  wm_puts_at(main_window, 12,0,"Sort");
  wm_puta_at(main_window, 12, 0, F_WHITE|B_BLACK|INTENSITY, 4);
  wm_puta_at(main_window, 12, 0, F_RED|B_BLACK|INTENSITY, 1);
  wm_puta_at(SrtMnu, 0, 0, F_WHITE|B_BLACK|INTENSITY, width);
  wm_puta_at(SrtMnu, 0, 0, F_RED|B_BLACK|INTENSITY, 1);

  if (!WIN->numselected){
    NoneSelected = 1;
    for(i=0; i < WIN->numfiles; ++i)
      if (!IsComment(WIN->Files[i].fname)){
	WIN->selected[WIN->numselected] = i;
	++WIN->numselected;}
  }


  if (!WIN->numfiles) {wm_close(SrtMnu);
		       wm_delete(SrtMnu);
		       wm_puts_at(main_window, 12,0,"Sort");
		       wm_puta_at(main_window, 12, 0, F_BLACK|B_WHITE, 4);
		       wm_puta_at(main_window, 12, 0, F_RED|B_WHITE, 1);
		       mem_free(FileList);
		       return 0;}
  while ((choice != ENTER) && (choice != ESCAPE))
    {
      choice = _read_kbd(0,1,1);
      if (isalpha(choice) || (choice == ENTER)){
	{
	  noselection = 1;
	  if (choice == 'N') selection = 0;
	  else if (choice == 'D') selection = 1;
	  else if (choice == 'S') selection = 2;
	  else if (choice == 'n') selection = 3;
	  else if (choice == 'd') selection = 4;
	  else if (choice == 's') selection = 5;
	  else if (choice == ENTER);
	  else noselection = 0;
	  if (noselection){
	    wm_close(SrtMnu);
	    wm_delete(SrtMnu);
	    FileList=mem_malloc((WIN->numselected+2)*sizeof(struct FileInfo));
	    for(i = 0; i < WIN->numselected; ++i)
	      DuplicateFileInfo(&FileList[i], &WIN->Files[WIN->selected[i]]);

	    switch (selection)
	      {
	      case 0: QuickSort(FileList, WIN->numselected, 3); break;
	      case 1: QuickSort(FileList, WIN->numselected, 1); break;
	      case 2: QuickSort(FileList, WIN->numselected, 2); break;
	      case 3: QuickSort(FileList, WIN->numselected, -3); break;
	      case 4: QuickSort(FileList, WIN->numselected, -1); break;
	      case 5: QuickSort(FileList, WIN->numselected, -2); break;
	      }
	    for(i = 0; i < WIN->numselected; ++i){
	      mem_free(WIN->Files[WIN->selected[i]].description);
	      CopyFileInfo(&WIN->Files[WIN->selected[i]], &FileList[i]);
	    }
	    mem_free(FileList);
	    WIN->numselected = 0;
	    WIN->changed = 1;
	    displaylist(WIN);
	    if (WIN->top_display + WIN->highlight > max_vis_file(WIN))
	      WIN->highlight = 0;
	    wm_highlight(WIN, 1);
	    choice = ENTER;
	  }
	}
      }
      else if (!choice){
	choice = _read_kbd(0,1,1);
	switch (choice)
	  {
	  case K_F1:
	    HELP(SortHelp);
	    break;
	  case K_UP:
	    if (selection > 0)
	      {
		wm_puta_at(SrtMnu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_WHITE, 1);
		--selection;
		wm_puta_at(SrtMnu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	      }
	    else
	      {
		wm_puta_at(SrtMnu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_WHITE, 1);
		selection = maxselections;
		wm_puta_at(SrtMnu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	      }
	    break;
	  case K_DOWN:
	    if (selection < maxselections)
	      {
		wm_puta_at(SrtMnu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_WHITE, 1);
		++selection;
		wm_puta_at(SrtMnu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_BLACK|INTENSITY,1);
	      }
	    else
	      {
		wm_puta_at(SrtMnu, 0, selection, F_BLACK|B_WHITE, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_WHITE, 1);
		selection = 0;
		wm_puta_at(SrtMnu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
		wm_puta_at(SrtMnu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	      }
	    break;
	  case K_PAGEUP:
	    wm_puta_at(SrtMnu, 0, selection, F_BLACK|B_WHITE, width);
	    wm_puta_at(SrtMnu, 0, selection, F_RED|B_WHITE, 1);
	    selection = 0;
	    wm_puta_at(SrtMnu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
	    wm_puta_at(SrtMnu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	    break;
	  case K_PAGEDOWN:
	    wm_puta_at(SrtMnu, 0, selection, F_BLACK|B_WHITE, width);
	    wm_puta_at(SrtMnu, 0, selection, F_RED|B_WHITE, 1);
	    selection = maxselections;
	    wm_puta_at(SrtMnu, 0, selection, F_WHITE|B_BLACK|INTENSITY, width);
	    wm_puta_at(SrtMnu, 0, selection, F_RED|B_BLACK|INTENSITY, 1);
	    break;
	  case K_RIGHT:
	  case K_LEFT:
	    wm_close(SrtMnu);
	    wm_delete(SrtMnu);
	    wm_puts_at(main_window, 12,0,"Sort");
	    wm_puta_at(main_window, 12, 0, F_BLACK|B_WHITE, 4);
	    wm_puta_at(main_window, 12, 0, F_RED|B_WHITE, 1);
	    if (NoneSelected) WIN->numselected = 0;
	    return choice;
	  }
      }
    }
  if (choice == ESCAPE){
    if (NoneSelected) WIN->numselected = 0;
    wm_close(SrtMnu);
    wm_delete(SrtMnu);
  }
  wm_puts_at(main_window, 12,0,"Sort");
  wm_puta_at(main_window, 12, 0, F_BLACK|B_WHITE, 4);
  wm_puta_at(main_window, 12, 0, F_RED|B_WHITE, 1);
  return 0;
}




void adopt_all()
{
  int i;

  printf("Adopting files in all areas\n");
  for (i=0; i < numareas; ++i)
    {
      ReadFileList(i, &windowlist[1], 1);
      if (adopt_files(&windowlist[1], 1, 0))
	write_filesbbs(&windowlist[1], 0);
      printf(".");
    }
  run_fbp(numareas);
}





void get_all_file_id()
{
  char *tempstr;
  int i, j;
  char fname[300];
  struct Window * win;

  printf("Getting file_id.diz from ALL files in all areas\n");
  win = &windowlist[1];
  for (i=0; i < numareas; ++i)
    {
      ReadFileList(i, win, 1);
      for (j=0; j < win->numfiles; ++j)
	{
	  if (_fnisabs(win->Files[j].fname))
	    strcpy(fname,win->Files[j].fname);
	  else
	    {
	      strcpy(fname, fileareas[win->area].Download);
	      strcat(fname,"\\");
	      strcat(fname,win->Files[j].fname);
	    }
	  if(Get_File_id(fname, &tempstr, 0, 1, win->Files[j].description))
	    {
	      win->Files[j].description = mem_strdup(tempstr);
	      win->changed = 1;
	      printf("Extracting file_id.diz or desc.sdi in area %s\n",
		     fileareas[win->area].FileInfo);
	      printf("%s\n%s\n\n",fname, win->Files[j].description);
	    }
	}
      if (win->changed) write_filesbbs(win, 0);
      printf(".");
    }
  free_window(win);
}



VOID WriteAFHeader(FILE *f, PSZ filename)
{
  FILE *h;
  CHAR linein[256];
  
  if ((h = fopen(filename, "r")))
    {
      while (fgets(linein, sizeof(linein), h))
	fputs(linein, f);
      fclose(h);
    }
}

VOID WriteAFFooter(FILE *f, PSZ filename)
{
  FILE *h;
  CHAR linein[256];
  
  if ((h = fopen(filename, "r")))
    {
      while (fgets(linein, sizeof(linein), h))
	fputs(linein, f);
      fclose(h);
    }
}



VOID GetBlockChar(CHAR c, INT row, PSZ buf)
{
  INT i;
  PSZ p;
  
  c = toupper(c);
  
  if (isalpha(c))
    {
      p = Letters;
      p += ((((INT) c) - 65) * 24) + (row * 6);
      
      for (i=0;i<6;i++)
        {
	  buf[i] = p[i];
	  buf[i+1] = '\0';
        }
    }
  else if (isdigit(c))
    {
      p = Numbers;
      p += ((((INT) c) - 48) * 24) + (row * 6);
      
      for (i=0;i<6;i++)
	{
	  buf[i] = p[i];
	  buf[i+1] = '\0';
	}
    }
  else
    strcpy(buf, "      ");
}



void allfiles()
{
  time_t today = time(NULL);
  char store = 0;
  int i, j, k;
  struct Window * win;
  FILE * ALLFILES;
  FILE * NEWFILES;
  FILE * EXCLUDE;
  char *tempstr = NULL;
  char *eol;
  char *p;
  int more;
  CHAR blkStr[BLOCK_STR_SIZE+1];
  LONG filesize = 0;
  LONG numfiles = 0;
  LONG totfilesize = 0;
  LONG totnumfiles = 0;
  int * exclude = mem_malloc(sizeof(int) * numareas);
  char areanumber[81];
  int numexcluded = 0;
  char flag;
  int l;
  int new;
  char has_ext_desc;
  int numnames = 0;
  char ** areanames = (char **) mem_malloc(numareas*100);



  printf("Creating maxfile.all (all files list)\n");

  if ((EXCLUDE = fopen("maxfile.exc", "r")))
    {
      numexcluded = 0;
      numnames = 0;
      while (fgets(areanumber, 80, EXCLUDE)){
	if (areanumber[strlen(areanumber)-1] =='\n')
	  areanumber[strlen(areanumber)-1] = 0;
	if (areanumber[0] != ';'){
	  if (isdigit(areanumber[0]))
	    exclude[numexcluded++] = atoi(areanumber);
	  else if (areanumber[0] == '+')
	      areanames[numnames++] = mem_strdup(&(areanumber[1]));
	  else if (!strlen(areanumber));
	  else {
	    printf("The following line in maxfile.exc is invalid");
	    printf("\n%s\n", areanumber);
	    printf("Maxfile.exc can consist of the number of an area as\n");
	    printf("presented by the change areas list in MaxFile/2 or it\n");
	    printf("can have a '+' followed by the area tag of a given\n");
	    printf("file area.  This line will be ignored.");
	  }
	}
      }
    }
  win = &windowlist[1];
  win->width = 79;
  if ((ALLFILES = fopen("maxfile.all","w+")) &&
      (NEWFILES = fopen("maxfile.new","w+"))){
    fprintf(ALLFILES, "%s%s\n", SEPLINE, SEPLINE);
    fprintf(ALLFILES, "\n\n All Files Listing - Generated by MaxFile/2.\n\n");
    fprintf(ALLFILES, "%s%s\n", SEPLINE, SEPLINE);
    WriteAFHeader(ALLFILES, "AllFiles.Hdr");
    fprintf(NEWFILES, "%s%s\n", SEPLINE, SEPLINE);
    fprintf(NEWFILES, "\n\n All Files Listing - Generated by MaxFile/2.\n\n");
    fprintf(NEWFILES, "%s%s\n", SEPLINE, SEPLINE);
    WriteAFHeader(NEWFILES, "NewFiles.Hdr");
    for (i=0; i < numareas; ++i)
      {
	printf(".");
	for (j=0; j < numexcluded; ++j)
	  if (i == exclude[j]) j = numareas+2;
	if (j < numareas+2)
	  for (j=0; j < numnames; ++j)
	    if (!stricmp(areanames[j], fileareas[i].Area)) j = numareas+2;
	
	if (j < numareas+2){
	  ReadFileList(i, win, 1);

	  for (k=0; k < win->numfiles; ++k){

	  /*  Strip out the extended description characters  */

	    if (ExtendedDesc)
	      for (l=0; l < strlen(win->Files[k].fname); ++l)
		{
		  flag = 0;
		  if (win->Files[k].fname[l] == '\n') flag = 1;
		  if (flag && (win->Files[k].fname[l] == ExtendedDesc))
		    flag = win->Files[k].fname[l] = 0;
		}


	    if (!IsComment(win->Files[k].fname)){
	      ++numfiles;
	      filesize += atoi(win->Files[k].fsize)/1024;
	    }
	  }
	  totfilesize += filesize;
	  totnumfiles += numfiles;
	  
	  fprintf(ALLFILES, "%s%s\n", SEPLINE, SEPLINE);
	  fprintf(NEWFILES, "%s%s\n", SEPLINE, SEPLINE);
	  for (k=0; k<4; k++)
	    {
	    p = blkStr;
	    for (j=0; j<strlen(fileareas[i].Area); j++)
	      {
		GetBlockChar(fileareas[i].Area[j], k, p);
		while (*p) p++;
	      }
	    fprintf(ALLFILES, "%s\n", blkStr);
	    fprintf(NEWFILES, "%s\n", blkStr);
	  }
	  fprintf(ALLFILES, "\n %s\n", fileareas[i].FileInfo);
	  fprintf(ALLFILES, " %ld files available (%ld kbytes)\n",
		  numfiles, filesize);
	  fprintf(ALLFILES, "%s%s\n", SEPLINE, SEPLINE);
	  fprintf(NEWFILES, "\n %s\n", fileareas[i].FileInfo);
	  fprintf(NEWFILES, " %ld files available (%ld kbytes)\n",
		  numfiles, filesize);
	  fprintf(NEWFILES, "%s%s\n", SEPLINE, SEPLINE);
	  
	  numfiles = filesize = 0;

	  for (j=0; j < win->numfiles; ++j)
	    {
	      new = newfile(today, win->Files[j].date,NewFiles,American_date);
	      more = 1;
	      tempstr=
		mem_realloc(tempstr,50 + strlen(win->Files[j].description));
	      if (!IsComment(win->Files[j].fname))
		{
		  p = win->Files[j].description;
		  if (*p == '/')  /* skip download flags */
		    {
		      p++;
		      if ((toupper(*p) == 'T') || (toupper(*p) == 'B'))
			{
			  p++;
			  if ((toupper(*p) =='T') || (toupper(*p) == 'B')) p++;
			}
		      else p--;
		    }
		  sprintf(tempstr, "%s%s %s %s",mygetname(win->Files[j].fname),
			  win->Files[j].date, win->Files[j].fsize, p);
		}
	      else{
		fprintf(ALLFILES, "%s\n",win->Files[j].description);
		fprintf(NEWFILES, "%s\n",win->Files[j].description);
		more = 0;}
	      
	      p = tempstr;

	      has_ext_desc = 0;
	      if (ExtendedDesc){
		eol = p;
		while (*eol){
		  ++eol;
		  if (*eol == '\n'){
		    while ((*eol) && (*eol != ExtendedDesc)) ++eol;
		    if (*eol) *eol = ' ';
		    has_ext_desc = 1;
		  }
		}
	      }

	      if(has_ext_desc || FileListMargin)
		{
		  while (more && new){
		    eol = p;
		    while ((*eol) && (*eol != '\n')) ++eol;
		    more = *eol;
		    *eol = 0;
		    fprintf(ALLFILES, "%s\n", p);
		    p = ++eol;
		  }
		}
	      else while(more)
		{
		  eol = &p[ min(win->width, strlen(p)) ];
		  if (strlen(p) <= win->width){
		    if (new) fprintf(NEWFILES, "%s\n", p);
		    fprintf(ALLFILES, "%s\n", p);
		    more = 0;}
		  else {
		    while ((*eol != ' ') && (eol > p) && (more))
		      eol--;
		    if ( (eol == p) && more )
		      {
			store = *p; 
			p[win->width] = 0; 
			eol = &p[win->width];
		      }
		    else if (more){ 
		      *eol = 0; 
		      store = ' ';
		    }
		    if (new) fprintf(NEWFILES, "%s\n", p);
		    fprintf(ALLFILES, "%s\n", p);
		    if (more) *eol = store;
		    p = eol;
		    win->width = 50;
		  }
		  if (more){
		    if (new) fprintf(NEWFILES,FileListBuff);
		    fprintf(ALLFILES,FileListBuff);}
		}
	      win->width = 79;
	    }
	}
      }

    fprintf(ALLFILES,"\n\n Total: %ld files available with %ld kbytes\n\n",
	    totnumfiles, totfilesize);

    WriteAFHeader(ALLFILES, "AllFiles.Ftr");
    if (new) WriteAFHeader(NEWFILES, "NewFiles.Ftr");
    fclose(ALLFILES);
  }
  for (j=0; j < numnames; mem_free(areanames[j++]));
  mem_free(areanames);
  mem_free(exclude);
  mem_free(tempstr);
}



void alldupes()
{
  int MaxAreaLen;
  int i;
  struct Window * win;
  FILE * ALLFILES;
  char *eol;
  char *p;
  char store = 0;
  char area[50];
  char *tempstr = NULL;
  int more;
  char offset[50];

  printf("Creating maxfile.dup (Duplicate files list)\n");

  win = find_dupes(numareas, 1);
  win->width = 79;
  if ((ALLFILES = fopen("maxfile.dup","w+"))){
    fprintf(ALLFILES, "%s%s\n", SEPLINE, SEPLINE);
    fprintf(ALLFILES, "\n\n Duplicate Files Listing - Generated by MaxFile/2.\n\n");
    fprintf(ALLFILES, "%s%s\n", SEPLINE, SEPLINE);

    MaxAreaLen = 0;
    for (i=0; i < win->numfiles; ++i)
      if (strlen(fileareas[win->Files[i].area].Area) > MaxAreaLen)
	MaxAreaLen = strlen(fileareas[win->Files[i].area].Area);
    MaxAreaLen = (MaxAreaLen < 4) ? 4 : 4;

    offset[0] = 0;
    for (i=0; i < MaxAreaLen+29; ++i)
      strcat(offset, " ");

    fprintf(ALLFILES, "AREA");
    for (i=0; i < MaxAreaLen - 4; ++i)
      fprintf(ALLFILES, " ");
    fprintf(ALLFILES,"  FileName      Date    Size             Description\n");
    fprintf(ALLFILES, "%s%s\n", SEPLINE, SEPLINE);


    for (i=0; i < win->numfiles; ++i)
      {
	strcpy(area, fileareas[win->Files[i].area].Area);
	while (strlen(area) < MaxAreaLen+1) strcat(area, " ");

	tempstr = mem_realloc(tempstr, strlen(area) + 1 + 
			      strlen(win->Files[i].fname) + 1 +
			      strlen(win->Files[i].fsize) + 1 +
			      strlen(win->Files[i].date) + 1 +
			      strlen(win->Files[i].description) + 1 + 10);
		  sprintf(tempstr, "%s%s%s%s %s", area,
			  mygetname(win->Files[i].fname),
			  win->Files[i].date, win->Files[i].fsize,
			   win->Files[i].description);
	p = tempstr;
	more = 1;
	while(more)
	  {
	    eol = &p[ min(win->width, strlen(p)) ];
	    if (strlen(p) <= win->width){
	      fprintf(ALLFILES, "%s\n", p);
	      more = 0;}
	    else {
	      while ((*eol != ' ') && (eol > p) && (more))
		eol--;
	      if ( (eol == p) && more )
		{
		  store = *p; 
		  p[win->width] = 0; 
		  eol = &p[win->width];
		}
	      else if (more){ 
		*eol = 0; 
		store = ' ';
	      }
	      fprintf(ALLFILES, "%s\n", p);
	      if (more) *eol = store;
	      p = eol;
	      win->width = 79 - (MaxAreaLen + 29);
	    }
	    if (more) fprintf(ALLFILES, "%s", offset);
	  }
	win->width = 79;
      }
  }
  fclose(ALLFILES);
  mem_free(tempstr);
  free_window(win);
}


void allsort()
{
  struct FileInfo * FileList;
  int i, j, k;
  struct Window * win = &windowlist[1];

  printf("Sorting\n");
  for (i=0; i < numareas; ++i)
    {
      ReadFileList(i, win, 1);
      win->numselected = 0;

      for(j=0; j < win->numfiles; ++j)
	if (!IsComment(win->Files[j].fname)){
	  win->selected[win->numselected] = j;
	  ++win->numselected;}

      FileList = mem_malloc((win->numselected + 2)*sizeof(struct FileInfo));
      
      for(k = 0; k < win->numselected; ++k)
	DuplicateFileInfo(&FileList[k], &win->Files[win->selected[k]]);

      QuickSort(FileList, win->numselected, 3);

      for(k = 0; k < win->numselected; ++k){
	mem_free(win->Files[win->selected[k]].description);
	CopyFileInfo(&win->Files[win->selected[k]], &FileList[k]);
      }
      
      mem_free(FileList);
      write_filesbbs(win, 1);
      printf(".");
    }
}



int commandline(int argc, char * argv[])
{
  int i;

  wm_close_all();
  for (i=1; i < argc; ++i)
    {
      if (!strnicmp(argv[i],"-adopt", strlen("-adopt")))
	adopt_all();
      else if (!strnicmp(argv[i],"-file_id", strlen("-file_id")))
	get_all_file_id();
      else if (!strnicmp(argv[i],"-allfiles", strlen("-allfiles")))
	allfiles();
      else if (!strnicmp(argv[i],"-sort", strlen("-sort")))
	allsort();
      else if (!strnicmp(argv[i],"-dupelist", strlen("-dupelist")))
	alldupes();
      else printf("I don't understand the command line option: %s\n",argv[i]);
      printf("\n");
    }
  return 0;
}





void welcome(int wait)
{
  FILE * FIRST;
  wm_handle welcome = wm_create(0,0,MaxX, MaxY, 0,
				BW_NORMAL|INTENSITY,BW_NORMAL|INTENSITY);


  wm_open(welcome);
  wm_top(welcome);
  wm_puts_at(welcome,0,0,"                              MAXFILE/2 v1.30");
  wm_puta_at(welcome,0,0,F_GREEN|B_BLACK|INTENSITY,MaxX);
  wm_puts_at(welcome,0,2,"               An OS/2 File Manager for Maximus/Lora/SBBS/...");

  wm_puts_at(welcome,0,4,"               MaxFile/2 comes with ABSOLUTELY NO WARRANTY");
  wm_puts_at(welcome,0,5,"               This is free software, and you are welcome to redistribute it");
  wm_puts_at(welcome,0,6,"               under certain conditions which can be found in the");
  wm_puts_at(welcome,0,7,"               file COPYING.");
  
  
  wm_puts_at(welcome,0,12,"I can be contacted at");
  wm_puts_at(welcome,0,13,"Internet: rvaniwaa@carbon.denver.colorado.edu");
  wm_puta_at(welcome,0,12,F_MAGENTA|B_BLACK|INTENSITY,MaxX);
  wm_puta_at(welcome,0,13,F_MAGENTA|B_BLACK|INTENSITY,MaxX);
  wm_puta_at(welcome,0,14,F_MAGENTA|B_BLACK|INTENSITY,MaxX);
  
  wm_puts_at(welcome,0,16,"I am very interested in any/all comments/complaints as well as");
  wm_puts_at(welcome,0,17,"suggestions for improvements for later versions.");
  
  
  if (!wait){  
    if (bbs_type == MAXIMUS)      FindAreas((void *)areabbs);
    else if (bbs_type == LORA)    ReadSDat((void *)areabbs);
    else if (bbs_type == SBBS)    ReadSBBSDat((void *)areabbs);
    else if (bbs_type == GENERIC) ReadGDat((void *)areabbs);
    
    if (areasort) SortAreas();
    
    
    if (!((Window1area >= 0) && (Window1area < numareas))) Window1area = 0;
    ReadFileList(Window1area, &windowlist[1], 1);
    if (!((Window2area >= 0) && (Window2area < numareas))) Window2area = 1;
    ReadFileList(Window2area, &windowlist[2], 1);
    
    if (access("firstrun.dat", 0))
      {
	FIRST = fopen("firstrun.dat", "w");
	fputs(" ",FIRST);
	fclose(FIRST);
	sleep(5);
      }
  }
  else{
    wm_puts_at(welcome,0,20,"                            Press any key to continue");
    wm_puta_at(welcome,0,20,F_YELLOW|B_BLACK|INTENSITY,MaxX);
    _read_kbd(0,1,0);
  }
  
  wm_close(welcome);
  wm_delete(welcome);
}





void INIT() 
{ 
  areabbs = mem_strdup(""); 
  maxdir = mem_strdup("");
  GifViewer = mem_strdup(""); 
  BMPViewer = mem_strdup(""); 
  JPGViewer = mem_strdup(""); 
  PCXViewer = mem_strdup(""); 
  TIFViewer = mem_strdup(""); 
  TXTViewer = mem_strdup(""); 
  VirusScanner = mem_strdup(""); 
  fbpcmd = mem_strdup(""); 
  DefaultDescription = mem_strdup("");
  externaledit = mem_strdup("");
}





void main(int argc, char * argv[])
{
/*  ULONG DefaultDriver = 0;
  HMOU Mouse;*/

  int offset;
  int DONTEXIT = 1;
  int choice = 1;
  int selection;
  int top_window;
  int diff;
  FILE * cfgfile;
  int i, j, k;
  char junk[5];
  char WhirlyGig[10];
  char WGCount;
  struct Window * WIN;
  char arrow;
  int temp_pos;
  int pos;
  int position;
  char menu;
  wm_handle NotDone;
  int TO;
  struct threadinfo * ThreadFiles;
  char * tempstrptr;
  char * tempstrp;
  char tempdir[1200];
  char * tmp;


#ifndef normal_mem
  mem_init();
  atexit(mem_term);
#endif

  for(i=0; i<maxarchivers; ++i)
    {
      strcpy(archivers[i].add, "");
      strcpy(archivers[i].extract, "");
      strcpy(archivers[i].view, "");
      strcpy(archivers[i].verify, "");
    }
  for (i=0; i <numMacros+1; Macros[i++] = NULL);

  if(!(cfgfile = fopen("maxfile.cfg", "r"))){
    printf("The maxfile.cfg file could not be located in the\n");
    printf("in the current directory.");
    exit(-1);
  }
  INIT();
  Read_Cfg_File(cfgfile);
  if (!strlen(TempDir))
    TempDir = mem_strdup(getenv("TMP"));
  fclose(cfgfile);
  for (i=0; i < maxwindows; zorder[i++] = -1);
  init_screen(windowlist);
  v_init();
  v_getxy(&xpos, &ypos);
  v_getctype (&cstart, &cend);

  if (argc > 1){
    if (isdigit(argv[1][1]))
      {
	tmp = ++argv[1];
	key = _atoll(tmp);
	for (i=1; i< argc-1; ++i) argv[i] =  argv[i+1];
	--argc;}
  }
  welcome(0);

  if (argc > 1)
    {
      if (!commandline(argc, argv)){
	run_fbp(numareas);
	free_mem();
	free_window(&windowlist[1]);
	free_window(&windowlist[2]);
	wm_close_all();
	v_gotoxy(xpos, ypos);
	v_ctype(cstart, cend);
	exit(0);
      }
    }

  wm_open(windowlist[1].Handle);
  wm_open(windowlist[2].Handle);
  wm_top(windowlist[1].Handle);
  wm_top(windowlist[2].Handle);
  displaylist(&windowlist[1]);
  displaylist(&windowlist[2]);
  wm_top(windowlist[1].Handle);
  wm_top(windowlist[2].Handle);
  WIN = &windowlist[top(zorder)];
  wm_highlight(WIN, 1);

  while (DONTEXIT)
    {
      choice = _read_kbd(0,1,0);
      top_window = top(zorder);
      WIN = &windowlist[top_window];
      if (!choice){
	choice = _read_kbd(0,1,0);
	switch(choice)
	  {
	  case K_ALT_W:
	    dateincr(&WIN->Files[WIN->top_display + WIN->highlight],
		     &WIN->Files[WIN->top_display + WIN->highlight+1]);
	    break;
	  case K_ALT_Z:
	    welcome(1);
	    break;
	  case K_ALT_E:
	    if((!WIN->numselected) && (choice != ' ')){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    for (i = WIN->numselected-1; i >= 0; --i)
	      {
		tempstrp= mem_strdup(WIN->Files[WIN->selected[i]].description);
		if (edit_str(&tempstrp, 250,
			     WIN->Files[WIN->selected[i]].fname)){
		  mem_free(WIN->Files[WIN->selected[i]].description);
		  WIN->Files[WIN->selected[i]].description = tempstrp;
		  WIN->changed = 1;}
		else mem_free(tempstrp);
	      }
	    WIN->numselected = 0;
	    displaylist(WIN);
	    if (WIN->highlight>max_vis_file(WIN))
	      WIN->highlight = max_vis_file(WIN);
	    wm_highlight(WIN, 1);
	    break;
	  case K_ALT_R:
	    if (Ok2Operate(WIN)){
	      for (i = WIN->numselected-1; i >= 0; --i){
		del(WIN, WIN->selected[i]);
		delete_listing(WIN, WIN->selected[i]);}
	      WIN->changed = 1;
	      WIN->numselected = 0;
	      displaylist(WIN);
	      wm_highlight(WIN, 1);
	    }
	    break;
	  case K_ALT_N:
	    if((!WIN->numselected) && (choice != ' ')){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    for (i = 0; i < WIN->numselected; ++i){
	      if(!extract(WIN->Files[WIN->selected[i]].fname,tempdir))
		Virii_Check(tempdir,
			    WIN->Files[WIN->selected[i]].fname);
	      else error2("Could not un-archive",
			  WIN->Files[WIN->selected[i]].fname);}
	    WIN->numselected = 0;
	    break;
	  case K_ALT_P:
	    if((!WIN->numselected) && (choice != ' ')){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    ThreadFiles = mem_malloc(sizeof(struct threadinfo));
	    for (k=0; k < WIN->numselected;  ++k)
	      strcpy(ThreadFiles->namelist[k],
		     WIN->Files[WIN->selected[k]].fname);
	    strcpy(ThreadFiles->path, fileareas[WIN->area].Download);
	    ThreadFiles->numfiles = WIN->numselected;
	    if (_osmode != DOS_MODE)
	      _beginthread(pic_view, NULL, 16384, (void *) ThreadFiles);
	    else pic_view(ThreadFiles);
	    WIN->numselected = 0;
	    displaylist(WIN);
	    wm_highlight(WIN, 1);
	    break;
	  case K_ALT_A:
	    if (savewin(WIN, 0))
	      if (adopt_files(WIN, 0, 0))
		{
		  WIN->changed = 1;
		  WIN->numselected = 0;
		  displaylist(WIN);
		  wm_highlight(WIN, 1);
		}
	    break;
	  case K_ALT_C:
	    if((!WIN->numselected) && (choice != ' ')){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    for (i = 0; i < WIN->numselected; ++i)
	      contents(WIN->selected[i],WIN);
	    WIN->numselected = 0;
	    displaylist(WIN);
	    wm_highlight(WIN, 1);
	    break;
	  case K_ALT_V:
	    if((!WIN->numselected) && (choice != ' ')){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    for (i = 0; i < WIN->numselected; ++i)
	      verify(WIN->selected[i], WIN);
	    WIN->numselected = 0;
	    displaylist(WIN);
	    wm_highlight(WIN, 1);
	    break;

	  case K_ALT_O:
	    pos = WIN->highlight+WIN->top_display;
	    if (is_selected(WIN, pos) || !WIN->numselected)
	      error2("You cannot insert before a selected file.  Please",
		     "deselect the file or choose another position");
	    else{
	      if (!WIN->numselected){
		WIN->selected[0] = WIN->top_display + WIN->highlight;
		WIN->numselected = 1;}
	      for(i=0; (i < WIN->numselected) &&
		  (WIN->selected[i]<=pos);++i);
	      position = i;
	      for(i=0; i<position; ++i)
		insert(WIN, WIN->selected[i]-i, pos);
	      offset = 0;
	      for(i=WIN->numselected-1; i >= position; --i)
		{
		  insert(WIN, WIN->selected[i]+offset, pos);
		  ++offset;
		}
	      WIN->changed = 1;
	      WIN->numselected = 0;
	      displaylist(WIN);
	      wm_highlight(WIN, 1);
	    }
	    break;

	  case K_ALT_I:
	    if((!WIN->numselected) && (choice != ' ')){
	      WIN->selected[0] = WIN->top_display + WIN->highlight;
	      WIN->numselected = 1;}
	    for (i = WIN->numselected-1; i >= 0; --i)
	      {
		char fname[200] = "";
		if (_fnisrel(WIN->Files[WIN->selected[i]].fname))
		  {
		    strcat(fname, fileareas[WIN->area].Download);
		    strcat(fname,"\\");
		  }
		strcat(fname, WIN->Files[WIN->selected[i]].fname);
		if (Get_File_id(fname, &tempstrptr,0, 0,
				WIN->Files[WIN->selected[i]].description)){
		  WIN->Files[WIN->selected[i]].description = mem_strdup(tempstrptr);}
		  WIN->changed = 1;
	      }
	    WIN->numselected = 0;
	    displaylist(WIN);
	    if (WIN->highlight>max_vis_file(WIN))
	      WIN->highlight = max_vis_file(WIN);
	    wm_highlight(WIN, 1);
	    break;
	  case K_ALT_X:
	    DONTEXIT = 0;
	    break;
	  case K_ALT_F:
	  case K_ALT_D:
	  case K_ALT_S:
	    if (choice == K_ALT_F) menu = 0;
	    else if (choice == K_ALT_S) menu = 1;
	    else menu = 2;
	    arrow = -1;
	    while (arrow)
	      {
		switch (menu)
		  {
		  case 0:
		    arrow = file_menu(numareas); break;
		  case 1:
		    arrow = sort_menu(WIN); break;
		  case 2:
		    arrow = description_menu(); break;
		  }
		if (arrow == K_RIGHT) ++menu; else --menu;
		if (menu > 2) menu = 0;
		else if (menu < 0) menu = 2;
	      }
	    break;
	  case K_F1:
	    HELP(MainHelp);
	    break;
	  case K_HOME:
	    WIN->top_display = 0;
	    displaylist(WIN);
	    WIN->highlight = 0;
	    wm_highlight(WIN, 1);
	    break;
	  case K_END:
	    if (!(WIN->all_displayed))
	      {
		WIN->top_display = display_end(WIN);
		displaylist(WIN);
		WIN->highlight = max_vis_file(WIN);
		wm_highlight(WIN, 1);
	      }
	    else if (WIN->highlight + WIN->top_display != WIN->numfiles - 1){
	      wm_highlight(WIN, 0);
	      WIN->highlight = max_vis_file(WIN);
	      wm_highlight(WIN, 1);
	    }
	    break;
	  case K_DOWN:
	    if (WIN->highlight + WIN->top_display != WIN->numfiles - 1)
	      {
		wm_highlight(WIN, 0);
		scroll_up(WIN);
		wm_highlight(WIN, 1);
	      }
	    break;
	  case K_RIGHT:
	    grow_right(WIN);
	    break;
	  case K_CTRL_PAGEUP:
	    maximize(WIN);
	    break;
	  case K_CTRL_PAGEDOWN:
	    normalize(WIN);
	    break;
	  case K_LEFT:
	    grow_left(WIN);
	    break;
	  case K_CTRL_RIGHT:
	    shrink_right(WIN);
	    break;
	  case K_CTRL_LEFT:
	    shrink_left(WIN);
	    break;
	  case K_CTRL_UP:
	    shrink_up(WIN);
	    break;
	  case K_CTRL_DOWN:
	    shrink_down(WIN);
	    break;
	  case K_ALT_UP:
	    grow_up(WIN);
	    break;
	  case K_ALT_DOWN:
	    grow_down(WIN);
	    break;
	  case K_UP:
	    if (WIN->top_display || WIN->highlight){
	      wm_highlight(WIN, 0);
	      scroll_down(WIN);
	      wm_highlight(WIN, 1);}
	    break;
	  case K_PAGEDOWN:
	    if (WIN->bottom_display < WIN->numfiles-1)
	      {
		diff = WIN->bottom_display - WIN->top_display - 1;
		if (WIN->bottom_display + diff < WIN->numfiles-1){
		  WIN->top_display += diff;
		  WIN->highlight = 0;
		  displaylist(WIN);
		  wm_highlight(WIN, 1);
		}
		else if(!WIN->all_displayed){
		  WIN->top_display = display_end(WIN);
		  WIN->highlight = max_vis_file(WIN);
		  displaylist(WIN);
		  wm_highlight(WIN, 1);
		}
		else{
		  wm_highlight(WIN, 0);
		  WIN->highlight = max_vis_file(WIN);
		  wm_highlight(WIN, 1);
		}
	      }
	    break;
	  case K_PAGEUP:
	    if (WIN->top_display + WIN->highlight){
	      wm_highlight(WIN, 0);	    
	      if (WIN->highlight) WIN->highlight = 0;
	      else{
		diff = WIN->bottom_display - WIN->top_display - 1;
		if (WIN->top_display - diff < 0)
		  WIN->top_display = 0;
		else
		  WIN->top_display -= diff;
		if (WIN->top_display - diff < 0) diff = 0;
		displaylist(WIN);
	      }
	      wm_highlight(WIN, 1);
	    }
	    break;
	  case K_F2: case K_F3: case K_F4: case K_F5: case K_F6: case K_F7:
	    switch (choice)
	      {
	      case K_F2: selection = 0; break;
	      case K_F3: selection = 1; break;
	      case K_F4: selection = 2; break;
	      case K_F5: selection = 3; break;
	      case K_F6: selection = 4; break;
	      case K_F7: selection = 5; break;
	      case K_F8: selection = 6; break;
	      case K_F9: selection = 7; break;
	      default:   selection = 8; break;
	      }
	    if (Macros[selection])
	      {
		if((!WIN->numselected) && (choice != ' ')){
		  WIN->selected[0] = WIN->top_display + WIN->highlight;
		  WIN->numselected = 1;}
		ThreadFiles = mem_malloc(sizeof(struct threadinfo));
		ThreadFiles->new_type = selection;
		for (k=0; k < WIN->numselected;  ++k)
		  strcpy(ThreadFiles->namelist[k],
			 WIN->Files[WIN->selected[k]].fname);
		strcpy(ThreadFiles->path, fileareas[WIN->area].Download);
		ThreadFiles->numfiles = WIN->numselected;
		if (_osmode != DOS_MODE)
		  _beginthread(run_macro, NULL, 16384, (void *) ThreadFiles);
		else run_macro(ThreadFiles);
		WIN->numselected = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
	      }
	    else
	      error("You have not yet defined that macro");
	    break;
	  }
      }
      else
	switch (choice)
	  {
	  case TAB:
	    wm_highlight(WIN, 0);
	    wm_up_all();
	    WIN = &windowlist[top(zorder)];
	    wm_highlight(WIN, 1);
	    break;
	  case ' ':
	    pos = WIN->top_display + WIN->highlight;
	    if (!is_selected(WIN, pos))
	      {
		for(i=0;(i<WIN->numselected) && (WIN->selected[i]<pos); ++i);
		++WIN->numselected;
		for (j=i; j < WIN->numselected; ++j)
		  {
		    temp_pos = WIN->selected[j];
		    WIN->selected[j] = pos;
		    pos = temp_pos;
		  }
		wm_putc_at(WIN->Handle, 0,
			   WIN->FileStart[WIN->highlight], '*');
	      }
	    else
	      {
		for(i = 0; (i < WIN->numselected) &&
		    (WIN->selected[i] < pos); ++i);
		--WIN->numselected;
		for (j = i; j <WIN->numselected; ++j)
		  WIN->selected[j] = WIN->selected[j+1];
		wm_putc_at(WIN->Handle, 0,
			   WIN->FileStart[WIN->highlight], ' ');
	      }
	    wm_highlight(WIN, 0);
	    scroll_up(WIN);
	    wm_highlight(WIN, 1);
	    break;
	  case 'k': case 'K':
	    for (i=0; i<WIN->numfiles; ++i) WIN->selected[i] = i;
	    WIN->numselected = WIN->numfiles;
	    displaylist(WIN);		
	    wm_highlight(WIN, 1);
	    break;
	  case 'U': case 'u':
	    WIN->numselected = 0;
	    displaylist(WIN);		
	    wm_highlight(WIN, 1);
	    break;
	  case 'z': case 'Z':
	    WIN->size = !(WIN->size);
	    displaylist(WIN);
	    if (WIN->highlight >= max_vis_file(WIN))
	      WIN->highlight = max_vis_file(WIN);
	    wm_highlight(WIN, 1);
	    break;
	  case 'S': case 's':
	    write_filesbbs(WIN, 0);
	    WIN->changed = 0;
	    break;
	  case 'a':
	  case 'A':
	  case 'r':
	  case 'R':
	  case '[':
	  case ']':
	    if (WIN->lock)
	      error2("Sorry, you cannot change areas as this area presently",
		     "has files being re-archived. (See which file above)");
	    else
	      if (savewin(WIN, 0))
		{
		  switch (choice){
		  case 'a': case 'A':
		    select_area(numareas, WIN->area, &selection, 0);
		    break;
		  case 'r': case 'R':
		    selection = WIN->area;
		    break;
		  case '[':
		    selection = WIN->area - 1;
		    if (selection == -1) selection = numareas-1;
		    break;
		  case ']':
		    selection = WIN->area + 1;
		    if (selection == numareas) selection = 0;
		  }
		  if (selection > -1){
		    ReadFileList(selection, WIN, 1);
		    WIN->top_display = 0;
		    displaylist(WIN);
		    wm_highlight(WIN, 1);}
		};
	    break;
	  case 'W':
	  case 'w':
	    WIN->wrap = !(WIN->wrap);
	    displaylist(WIN);
	    if ((WIN->highlight) > max_vis_file(WIN))
	      WIN->highlight = 0;
	    wm_highlight(WIN, 1);
	    break;
	  case 'd':
	  case 'D':
	    WIN->date = !(WIN->date);
	    displaylist(WIN);
	    if (WIN->highlight >= max_vis_file(WIN))
	      WIN->highlight = max_vis_file(WIN);
	    wm_highlight(WIN, 1);
	    break;
	  case 'M':
	  case 'm':
	    if (Ok2Operate(WIN))
	      {
		select_area(numareas, WIN->area, &TO, 0);
		if (TO >= 0)
		  for (i = 0; i < WIN->numselected; ++i)
		    if (!move(WIN, TO, WIN->selected[i])){
		      delete_listing(WIN, WIN->selected[i]);
		      for (j=0; j< WIN->numselected; ++j) --WIN->selected[j];}
		
		WIN->numselected = 0;
		WIN->changed = 1;
		if (WIN->highlight < 0) WIN->highlight = 0;
		displaylist(WIN);
		wm_highlight(WIN, 1);
	      }
	    break;
	  }
    }
  WhirlyGig[1] = -1;
  WGCount = 0;
  NotDone = wm_create(MidX-20, MidY-1, MidX+20, MidY, 2,
		      F_RED|B_BLACK|INTENSITY, F_RED|B_BLACK|INTENSITY);
  while (Re_Archiving)
    {
      ++WGCount;
      wm_open(NotDone);
	  if (WGCount == 0) WhirlyGig[0] = '|';
      if (WGCount == 1) WhirlyGig[0] = '/';
      if (WGCount == 2) WhirlyGig[0] = '-';
      if (WGCount == 3){ WhirlyGig[0] = '\\'; WGCount = -1;}
      wm_top(NotDone);
      if (Re_Archiving != 1){
	wm_clr_eol(NotDone, 37,0);
	wm_puts_at(NotDone, 0, 0, "There are ");
	wm_puts_at(NotDone, 10, 0, _ltoa(Re_Archiving, junk, 10));
	wm_puts_at(NotDone, 12, 0, " threads that are re-archiving");
      }
      else{
	wm_clr_eol(NotDone, 37,0);
	wm_puts_at(NotDone,0,0,"There is 1 thread that is re-archiving");
      }
      wm_puts_at(NotDone, 0, 1, "Please wait...");
      wm_puts_at(NotDone, 14, 1, WhirlyGig);
      _sleep2(250);
    }
  wm_close(NotDone);
  savewin(&windowlist[1], 1);
  savewin(&windowlist[2], 1);
  v_clear();
  wm_close_all();

  v_gotoxy(xpos, ypos);
  v_ctype(cstart, cend);

  run_fbp(numareas);
  free_mem();
  free_window(&windowlist[1]);
  free_window(&windowlist[2]);
}
